# fortanix_sdkms_rest_api

FortanixSdkmsRestApi - JavaScript client for fortanix_sdkms_rest_api
This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
This SDK is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 1.0.0-20200608
- Package version: 1.0.0-20200608
- Build package: io.swagger.codegen.languages.JavascriptClientCodegen
For more information, please visit [https://support.fortanix.com/sdkms](https://support.fortanix.com/sdkms)

## Installation

### For [Node.js](https://nodejs.org/)

#### npm

To publish the library as a [npm](https://www.npmjs.com/),
please follow the procedure in ["Publishing npm packages"](https://docs.npmjs.com/getting-started/publishing-npm-packages).

Then install it via:

```shell
npm install fortanix_sdkms_rest_api --save
```

#### git
#
If the library is hosted at a git repository, e.g.
https://github.com/GIT_USER_ID/GIT_REPO_ID
then install it via:

```shell
    npm install GIT_USER_ID/GIT_REPO_ID --save
```

### For browser

The library also works in the browser environment via npm and [browserify](http://browserify.org/). After following
the above steps with Node.js and installing browserify with `npm install -g browserify`,
perform the following (assuming *main.js* is your entry file):

```shell
browserify main.js > bundle.js
```

Then include *bundle.js* in the HTML pages.

## Getting Started

Please follow the [installation](#installation) instruction and execute the following JS code:

```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');

var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = "YOUR API KEY"
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix['Authorization'] = "Token"

var api = new FortanixSdkmsRestApi.AWSApi()

var keyId = "keyId_example"; // {String} kid of security object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
api.cancelDeletion(keyId, callback);

```

## Documentation for API Endpoints

All URIs are relative to *https://apps.smartkey.io*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*FortanixSdkmsRestApi.AWSApi* | [**cancelDeletion**](docs/AWSApi.md#cancelDeletion) | **POST** /crypto/v1/keys/{key-id}/cancel_deletion | Cancel scheduled deletion of an AWS KMS key
*FortanixSdkmsRestApi.AWSApi* | [**deleteKeyMaterial**](docs/AWSApi.md#deleteKeyMaterial) | **POST** /crypto/v1/keys/{key-id}/delete_key_material | Delete the key material of an AWS KMS key
*FortanixSdkmsRestApi.AWSApi* | [**restore**](docs/AWSApi.md#restore) | **POST** /crypto/v1/keys/{key-id}/restore | Restore an AWS KMS key from its source key material
*FortanixSdkmsRestApi.AWSApi* | [**scheduleDeletion**](docs/AWSApi.md#scheduleDeletion) | **POST** /crypto/v1/keys/{key-id}/schedule_deletion | Schedule an AWS KMS key for deletion
*FortanixSdkmsRestApi.AccountsApi* | [**createAccount**](docs/AccountsApi.md#createAccount) | **POST** /sys/v1/accounts | Create a new account
*FortanixSdkmsRestApi.AccountsApi* | [**deleteAccount**](docs/AccountsApi.md#deleteAccount) | **DELETE** /sys/v1/accounts/{account-id} | Delete account
*FortanixSdkmsRestApi.AccountsApi* | [**getAccount**](docs/AccountsApi.md#getAccount) | **GET** /sys/v1/accounts/{account-id} | Get a specific account
*FortanixSdkmsRestApi.AccountsApi* | [**getAccounts**](docs/AccountsApi.md#getAccounts) | **GET** /sys/v1/accounts | Get all accounts
*FortanixSdkmsRestApi.AccountsApi* | [**updateAccount**](docs/AccountsApi.md#updateAccount) | **PATCH** /sys/v1/accounts/{account-id} | Update account
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**approve**](docs/ApprovalRequestsApi.md#approve) | **POST** /sys/v1/approval_requests/{request-id}/approve | Approve a request.
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**createApprovalRequest**](docs/ApprovalRequestsApi.md#createApprovalRequest) | **POST** /sys/v1/approval_requests | Create approval request
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**deleteApprovalRequest**](docs/ApprovalRequestsApi.md#deleteApprovalRequest) | **DELETE** /sys/v1/approval_requests/{request-id} | Delete an approval request.
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**deny**](docs/ApprovalRequestsApi.md#deny) | **POST** /sys/v1/approval_requests/{request-id}/deny | Deny a request.
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**getApprovalRequest**](docs/ApprovalRequestsApi.md#getApprovalRequest) | **GET** /sys/v1/approval_requests/{request-id} | Get an approval request.
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**getApprovalRequests**](docs/ApprovalRequestsApi.md#getApprovalRequests) | **GET** /sys/v1/approval_requests | Get all approval requests
*FortanixSdkmsRestApi.ApprovalRequestsApi* | [**getResult**](docs/ApprovalRequestsApi.md#getResult) | **POST** /sys/v1/approval_requests/{request-id}/result | Get the result for an approved or failed request.
*FortanixSdkmsRestApi.AppsApi* | [**createApp**](docs/AppsApi.md#createApp) | **POST** /sys/v1/apps | Create a new application
*FortanixSdkmsRestApi.AppsApi* | [**deleteApp**](docs/AppsApi.md#deleteApp) | **DELETE** /sys/v1/apps/{app-id} | Delete application
*FortanixSdkmsRestApi.AppsApi* | [**getApp**](docs/AppsApi.md#getApp) | **GET** /sys/v1/apps/{app-id} | Get a specific application
*FortanixSdkmsRestApi.AppsApi* | [**getApps**](docs/AppsApi.md#getApps) | **GET** /sys/v1/apps | Get all applications
*FortanixSdkmsRestApi.AppsApi* | [**getCredential**](docs/AppsApi.md#getCredential) | **GET** /sys/v1/apps/{app-id}/credential | Get a specific application&#39;s credential
*FortanixSdkmsRestApi.AppsApi* | [**regenerateApiKey**](docs/AppsApi.md#regenerateApiKey) | **POST** /sys/v1/apps/{app-id}/reset_secret | Regenerate API key
*FortanixSdkmsRestApi.AppsApi* | [**updateApp**](docs/AppsApi.md#updateApp) | **PATCH** /sys/v1/apps/{app-id} | Update an application
*FortanixSdkmsRestApi.AuthenticationApi* | [**authorize**](docs/AuthenticationApi.md#authorize) | **POST** /sys/v1/session/auth | Create a session for a user or an app
*FortanixSdkmsRestApi.AuthenticationApi* | [**checkHealth**](docs/AuthenticationApi.md#checkHealth) | **GET** /sys/v1/health | Check whether the server is handling requests
*FortanixSdkmsRestApi.AuthenticationApi* | [**getServerVersion**](docs/AuthenticationApi.md#getServerVersion) | **GET** /sys/v1/version | Get SDKMS version information
*FortanixSdkmsRestApi.AuthenticationApi* | [**reAuth**](docs/AuthenticationApi.md#reAuth) | **POST** /sys/v1/session/reauth | Create a new session for a user or an app using an existing session bearer token.
*FortanixSdkmsRestApi.AuthenticationApi* | [**refresh**](docs/AuthenticationApi.md#refresh) | **POST** /sys/v1/session/refresh | Refreshes existing user or app session.
*FortanixSdkmsRestApi.AuthenticationApi* | [**selectAccount**](docs/AuthenticationApi.md#selectAccount) | **POST** /sys/v1/session/select_account | Select a user&#39;s account to work on
*FortanixSdkmsRestApi.AuthenticationApi* | [**terminate**](docs/AuthenticationApi.md#terminate) | **POST** /sys/v1/session/terminate | Terminate a session
*FortanixSdkmsRestApi.AuthenticationApi* | [**unlock2F**](docs/AuthenticationApi.md#unlock2F) | **POST** /sys/v1/session/config_2fa/auth | Unlock two factor configuration
*FortanixSdkmsRestApi.ChildAccountUsersApi* | [**createChildAccountUser**](docs/ChildAccountUsersApi.md#createChildAccountUser) | **POST** /sys/v1/users/child_account | Create a new user user in a child account
*FortanixSdkmsRestApi.ChildAccountUsersApi* | [**deleteChildAccountUser**](docs/ChildAccountUsersApi.md#deleteChildAccountUser) | **DELETE** /sys/v1/users/child_account/{user-id} | Completely delete a user in child account
*FortanixSdkmsRestApi.ChildAccountUsersApi* | [**getAllChildAccountUsers**](docs/ChildAccountUsersApi.md#getAllChildAccountUsers) | **GET** /sys/v1/users/child_account/{account-id}/all | Get all users in a child account
*FortanixSdkmsRestApi.ChildAccountUsersApi* | [**getChildAccountUser**](docs/ChildAccountUsersApi.md#getChildAccountUser) | **GET** /sys/v1/users/child_account/{user-id} | Get a specific child account user
*FortanixSdkmsRestApi.ChildAccountUsersApi* | [**updateChildAccountUser**](docs/ChildAccountUsersApi.md#updateChildAccountUser) | **PATCH** /sys/v1/users/child_account/{user-id} | Update a child account user
*FortanixSdkmsRestApi.ChildAccountsApi* | [**createChildAccount**](docs/ChildAccountsApi.md#createChildAccount) | **POST** /sys/v1/accounts/child | Create a new child account
*FortanixSdkmsRestApi.ChildAccountsApi* | [**getChildAccounts**](docs/ChildAccountsApi.md#getChildAccounts) | **GET** /sys/v1/accounts/{account-id}/child | Get all child accounts of the given account
*FortanixSdkmsRestApi.DigestApi* | [**batchMac**](docs/DigestApi.md#batchMac) | **POST** /crypto/v1/keys/batch/mac | Batch MAC with one or more keys
*FortanixSdkmsRestApi.DigestApi* | [**batchMacVerify**](docs/DigestApi.md#batchMacVerify) | **POST** /crypto/v1/keys/batch/macverify | Batch MAC Verify with one or more keys
*FortanixSdkmsRestApi.DigestApi* | [**computeDigest**](docs/DigestApi.md#computeDigest) | **POST** /crypto/v1/digest | Compute a message digest of data
*FortanixSdkmsRestApi.DigestApi* | [**computeMac**](docs/DigestApi.md#computeMac) | **POST** /crypto/v1/keys/{key-id}/mac | Compute MAC using a key
*FortanixSdkmsRestApi.DigestApi* | [**computeMacEx**](docs/DigestApi.md#computeMacEx) | **POST** /crypto/v1/mac | Compute MAC using a key
*FortanixSdkmsRestApi.DigestApi* | [**verifyMac**](docs/DigestApi.md#verifyMac) | **POST** /crypto/v1/keys/{key-id}/macverify | Verify MAC using a key
*FortanixSdkmsRestApi.DigestApi* | [**verifyMacEx**](docs/DigestApi.md#verifyMacEx) | **POST** /crypto/v1/macverify | Verify MAC using a key
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**batchDecrypt**](docs/EncryptionAndDecryptionApi.md#batchDecrypt) | **POST** /crypto/v1/keys/batch/decrypt | Batch decrypt with one or more keys
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**batchEncrypt**](docs/EncryptionAndDecryptionApi.md#batchEncrypt) | **POST** /crypto/v1/keys/batch/encrypt | Batch encrypt with one or more keys
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decrypt**](docs/EncryptionAndDecryptionApi.md#decrypt) | **POST** /crypto/v1/keys/{key-id}/decrypt | Decrypt data
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptEx**](docs/EncryptionAndDecryptionApi.md#decryptEx) | **POST** /crypto/v1/decrypt | Decrypt data
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptFinal**](docs/EncryptionAndDecryptionApi.md#decryptFinal) | **POST** /crypto/v1/keys/{key-id}/decrypt/final | Conclude multi-part decryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptFinalEx**](docs/EncryptionAndDecryptionApi.md#decryptFinalEx) | **POST** /crypto/v1/decrypt/final | Conclude multi-part decryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptInit**](docs/EncryptionAndDecryptionApi.md#decryptInit) | **POST** /crypto/v1/keys/{key-id}/decrypt/init | Begin multi-part decryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptInitEx**](docs/EncryptionAndDecryptionApi.md#decryptInitEx) | **POST** /crypto/v1/decrypt/init | Begin multi-part decryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptUpdate**](docs/EncryptionAndDecryptionApi.md#decryptUpdate) | **POST** /crypto/v1/keys/{key-id}/decrypt/update | Continue multi-part decryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**decryptUpdateEx**](docs/EncryptionAndDecryptionApi.md#decryptUpdateEx) | **POST** /crypto/v1/decrypt/update | Continue multi-part decryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encrypt**](docs/EncryptionAndDecryptionApi.md#encrypt) | **POST** /crypto/v1/keys/{key-id}/encrypt | Encrypt data
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptEx**](docs/EncryptionAndDecryptionApi.md#encryptEx) | **POST** /crypto/v1/encrypt | Encrypt data
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptFinal**](docs/EncryptionAndDecryptionApi.md#encryptFinal) | **POST** /crypto/v1/keys/{key-id}/encrypt/final | Conclude multi-part encryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptFinalEx**](docs/EncryptionAndDecryptionApi.md#encryptFinalEx) | **POST** /crypto/v1/encrypt/final | Conclude multi-part encryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptInit**](docs/EncryptionAndDecryptionApi.md#encryptInit) | **POST** /crypto/v1/keys/{key-id}/encrypt/init | Begin multi-part encryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptInitEx**](docs/EncryptionAndDecryptionApi.md#encryptInitEx) | **POST** /crypto/v1/encrypt/init | Begin multi-part encryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptUpdate**](docs/EncryptionAndDecryptionApi.md#encryptUpdate) | **POST** /crypto/v1/keys/{key-id}/encrypt/update | Continue multi-part encryption
*FortanixSdkmsRestApi.EncryptionAndDecryptionApi* | [**encryptUpdateEx**](docs/EncryptionAndDecryptionApi.md#encryptUpdateEx) | **POST** /crypto/v1/encrypt/update | Continue multi-part encryption
*FortanixSdkmsRestApi.GroupsApi* | [**createGroup**](docs/GroupsApi.md#createGroup) | **POST** /sys/v1/groups | Create new group
*FortanixSdkmsRestApi.GroupsApi* | [**deleteGroup**](docs/GroupsApi.md#deleteGroup) | **DELETE** /sys/v1/groups/{group-id} | Delete group
*FortanixSdkmsRestApi.GroupsApi* | [**getGroup**](docs/GroupsApi.md#getGroup) | **GET** /sys/v1/groups/{group-id} | Get a specific group
*FortanixSdkmsRestApi.GroupsApi* | [**getGroups**](docs/GroupsApi.md#getGroups) | **GET** /sys/v1/groups | Get all groups
*FortanixSdkmsRestApi.GroupsApi* | [**updateGroup**](docs/GroupsApi.md#updateGroup) | **PATCH** /sys/v1/groups/{group-id} | Update group
*FortanixSdkmsRestApi.LogsApi* | [**getAuditLogs**](docs/LogsApi.md#getAuditLogs) | **GET** /sys/v1/logs | Get audit logs
*FortanixSdkmsRestApi.PluginsApi* | [**createPlugin**](docs/PluginsApi.md#createPlugin) | **POST** /sys/v1/plugins | Create a new plugin
*FortanixSdkmsRestApi.PluginsApi* | [**deletePlugin**](docs/PluginsApi.md#deletePlugin) | **DELETE** /sys/v1/plugins/{plugin-id} | Delete plugin
*FortanixSdkmsRestApi.PluginsApi* | [**getPlugin**](docs/PluginsApi.md#getPlugin) | **GET** /sys/v1/plugins/{plugin-id} | Get a specific plugin
*FortanixSdkmsRestApi.PluginsApi* | [**getPlugins**](docs/PluginsApi.md#getPlugins) | **GET** /sys/v1/plugins | Get all plugins
*FortanixSdkmsRestApi.PluginsApi* | [**invokePlugin**](docs/PluginsApi.md#invokePlugin) | **POST** /sys/v1/plugins/{plugin-id} | Invoke a plugin
*FortanixSdkmsRestApi.PluginsApi* | [**sysV1PluginsInvokePluginIdGet**](docs/PluginsApi.md#sysV1PluginsInvokePluginIdGet) | **GET** /sys/v1/plugins/invoke/{plugin-id} | Invoke a plugin using GET.
*FortanixSdkmsRestApi.PluginsApi* | [**updatePlugin**](docs/PluginsApi.md#updatePlugin) | **PATCH** /sys/v1/plugins/{plugin-id} | Update a plugin
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**activateSecurityObject**](docs/SecurityObjectsApi.md#activateSecurityObject) | **POST** /crypto/v1/keys/{key-id}/activate | Transitions immediately a security object to Active state
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**agreeKey**](docs/SecurityObjectsApi.md#agreeKey) | **POST** /crypto/v1/agree | Agree on a key from two other keys
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**deletePrivateKey**](docs/SecurityObjectsApi.md#deletePrivateKey) | **DELETE** /crypto/v1/keys/{key-id}/private | Remove / Destroy private half of the asymmetric key
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**deleteSecurityObject**](docs/SecurityObjectsApi.md#deleteSecurityObject) | **DELETE** /crypto/v1/keys/{key-id} | Delete a security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**deriveKey**](docs/SecurityObjectsApi.md#deriveKey) | **POST** /crypto/v1/keys/{key-id}/derive | Derive a key from another key
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**deriveKeyEx**](docs/SecurityObjectsApi.md#deriveKeyEx) | **POST** /crypto/v1/derive | Derive a key from another key
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**destroySecurityObject**](docs/SecurityObjectsApi.md#destroySecurityObject) | **POST** /crypto/v1/keys/{key-id}/destroy | Destroys a security object, leaving its metadata in place
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**exportSobjectComponents**](docs/SecurityObjectsApi.md#exportSobjectComponents) | **POST** /crypto/v1/keys/components/export | export key components
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**generateSecurityObject**](docs/SecurityObjectsApi.md#generateSecurityObject) | **POST** /crypto/v1/keys | Generate a new security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**getSecurityObject**](docs/SecurityObjectsApi.md#getSecurityObject) | **GET** /crypto/v1/keys/{key-id} | Get a specific security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**getSecurityObjectDigest**](docs/SecurityObjectsApi.md#getSecurityObjectDigest) | **POST** /crypto/v1/keys/digest | Retrieve the digest (hash) of the value of an exportable security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**getSecurityObjectKcv**](docs/SecurityObjectsApi.md#getSecurityObjectKcv) | **POST** /crypto/v1/keys/kcv | Get the key check value (KCV) of a symmetric key
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**getSecurityObjectValue**](docs/SecurityObjectsApi.md#getSecurityObjectValue) | **GET** /crypto/v1/keys/{key-id}/export | Retrieve the value of an exportable security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**getSecurityObjectValueEx**](docs/SecurityObjectsApi.md#getSecurityObjectValueEx) | **POST** /crypto/v1/keys/export | Retrieve the value of an exportable security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**getSecurityObjects**](docs/SecurityObjectsApi.md#getSecurityObjects) | **GET** /crypto/v1/keys | Get all security objects
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**importSecurityObject**](docs/SecurityObjectsApi.md#importSecurityObject) | **PUT** /crypto/v1/keys | Import a security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**importSobjectComponents**](docs/SecurityObjectsApi.md#importSobjectComponents) | **POST** /crypto/v1/keys/components/import | import key components
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**persistSecurityObject**](docs/SecurityObjectsApi.md#persistSecurityObject) | **POST** /crypto/v1/keys/persist | Persist a transient key.
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**revertHistoryItem**](docs/SecurityObjectsApi.md#revertHistoryItem) | **PUT** /crypto/v1/keys/{key-id}/revert | Reverts a security object to a previous state
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**revokeSecurityObject**](docs/SecurityObjectsApi.md#revokeSecurityObject) | **POST** /crypto/v1/keys/{key-id}/revoke | Transitions immediately a security object to Deactivated or Compromised state
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**rotateSecurityObject**](docs/SecurityObjectsApi.md#rotateSecurityObject) | **POST** /crypto/v1/keys/rekey | Rotate a key.
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**updateSecurityObject**](docs/SecurityObjectsApi.md#updateSecurityObject) | **PATCH** /crypto/v1/keys/{key-id} | Update a security object
*FortanixSdkmsRestApi.SecurityObjectsApi* | [**verifyKcv**](docs/SecurityObjectsApi.md#verifyKcv) | **POST** /crypto/v1/keys/kcv/verify | Verify that the KCV of the provided key material matches the provided KCV
*FortanixSdkmsRestApi.SignAndVerifyApi* | [**batchSign**](docs/SignAndVerifyApi.md#batchSign) | **POST** /crypto/v1/keys/batch/sign | Batch sign with one or more private keys
*FortanixSdkmsRestApi.SignAndVerifyApi* | [**batchVerify**](docs/SignAndVerifyApi.md#batchVerify) | **POST** /crypto/v1/keys/batch/verify | Batch verify with one or more private keys
*FortanixSdkmsRestApi.SignAndVerifyApi* | [**sign**](docs/SignAndVerifyApi.md#sign) | **POST** /crypto/v1/keys/{key-id}/sign | Sign with a private key
*FortanixSdkmsRestApi.SignAndVerifyApi* | [**signEx**](docs/SignAndVerifyApi.md#signEx) | **POST** /crypto/v1/sign | Sign with a private key
*FortanixSdkmsRestApi.SignAndVerifyApi* | [**verify**](docs/SignAndVerifyApi.md#verify) | **POST** /crypto/v1/keys/{key-id}/verify | Verify a signature with a key
*FortanixSdkmsRestApi.SignAndVerifyApi* | [**verifyEx**](docs/SignAndVerifyApi.md#verifyEx) | **POST** /crypto/v1/verify | Verify a signature with a key
*FortanixSdkmsRestApi.StatsApi* | [**getAppStats**](docs/StatsApi.md#getAppStats) | **GET** /sys/v1/stats/{app-id}/app | Get transaction statistics for a specific application
*FortanixSdkmsRestApi.StatsApi* | [**getAppsStats**](docs/StatsApi.md#getAppsStats) | **GET** /sys/v1/stats/apps | Get app aggregate transaction statistics
*FortanixSdkmsRestApi.StatsApi* | [**getGroupStats**](docs/StatsApi.md#getGroupStats) | **GET** /sys/v1/stats/{group-id}/group | Get transaction statistics for a specific group
*FortanixSdkmsRestApi.StatsApi* | [**getGroupsStats**](docs/StatsApi.md#getGroupsStats) | **GET** /sys/v1/stats/groups | Get group aggregate transaction statistics
*FortanixSdkmsRestApi.StatsApi* | [**getSecurityObjectStats**](docs/StatsApi.md#getSecurityObjectStats) | **GET** /sys/v1/stats/{key-id}/key | Get transaction statistics for a specific security object
*FortanixSdkmsRestApi.TwoFactorAuthenticationApi* | [**authorizeRecoveryCode**](docs/TwoFactorAuthenticationApi.md#authorizeRecoveryCode) | **POST** /sys/v1/session/auth/2fa/recovery_code | Use a backup recovery code to complete authentication
*FortanixSdkmsRestApi.TwoFactorAuthenticationApi* | [**authorizeU2F**](docs/TwoFactorAuthenticationApi.md#authorizeU2F) | **POST** /sys/v1/session/auth/2fa/u2f | Use a U2F key to complete authentication
*FortanixSdkmsRestApi.TwoFactorAuthenticationApi* | [**generateRecoveryCodes**](docs/TwoFactorAuthenticationApi.md#generateRecoveryCodes) | **POST** /sys/v1/users/generate_recovery_code | Generate backup recovery codes for the current user
*FortanixSdkmsRestApi.TwoFactorAuthenticationApi* | [**generateU2FChallenge**](docs/TwoFactorAuthenticationApi.md#generateU2FChallenge) | **POST** /sys/v1/session/config_2fa/new_challenge | Generate a new challenge for registering a U2F devices
*FortanixSdkmsRestApi.TwoFactorAuthenticationApi* | [**lock2F**](docs/TwoFactorAuthenticationApi.md#lock2F) | **POST** /sys/v1/session/config_2fa/terminate | Lock two factor configuration
*FortanixSdkmsRestApi.UsersApi* | [**changePassword**](docs/UsersApi.md#changePassword) | **POST** /sys/v1/users/change_password | Change user password
*FortanixSdkmsRestApi.UsersApi* | [**confirmEmail**](docs/UsersApi.md#confirmEmail) | **POST** /sys/v1/users/{user-id}/confirm_email | Confirms user&#39;s email address
*FortanixSdkmsRestApi.UsersApi* | [**createUser**](docs/UsersApi.md#createUser) | **POST** /sys/v1/users | Create a new user
*FortanixSdkmsRestApi.UsersApi* | [**deleteUser**](docs/UsersApi.md#deleteUser) | **DELETE** /sys/v1/users/{user-id}/accounts | Removed user&#39;s association with an account
*FortanixSdkmsRestApi.UsersApi* | [**deleteUserAccount**](docs/UsersApi.md#deleteUserAccount) | **DELETE** /sys/v1/users | Completely delete a user profile from system
*FortanixSdkmsRestApi.UsersApi* | [**forgotPassword**](docs/UsersApi.md#forgotPassword) | **POST** /sys/v1/users/forgot_password | Initiate password reset sequence for a user
*FortanixSdkmsRestApi.UsersApi* | [**getUser**](docs/UsersApi.md#getUser) | **GET** /sys/v1/users/{user-id} | Get a specific user
*FortanixSdkmsRestApi.UsersApi* | [**getUserAccount**](docs/UsersApi.md#getUserAccount) | **GET** /sys/v1/users/accounts | Get account information for the user
*FortanixSdkmsRestApi.UsersApi* | [**getUsers**](docs/UsersApi.md#getUsers) | **GET** /sys/v1/users | Get all users
*FortanixSdkmsRestApi.UsersApi* | [**inviteUser**](docs/UsersApi.md#inviteUser) | **POST** /sys/v1/users/invite | Invite a user
*FortanixSdkmsRestApi.UsersApi* | [**processInvitations**](docs/UsersApi.md#processInvitations) | **POST** /sys/v1/users/process_invite | Process a user&#39;s pending account invitations
*FortanixSdkmsRestApi.UsersApi* | [**resendConfirmEmail**](docs/UsersApi.md#resendConfirmEmail) | **POST** /sys/v1/users/{user-id}/resend_confirm_email | Resend email with link to confirm user&#39;s email address
*FortanixSdkmsRestApi.UsersApi* | [**resendInvitation**](docs/UsersApi.md#resendInvitation) | **POST** /sys/v1/users/{user-id}/resend_invite | Resend invite to the user to join a specific account
*FortanixSdkmsRestApi.UsersApi* | [**resetPassword**](docs/UsersApi.md#resetPassword) | **POST** /sys/v1/users/{user-id}/reset_password | Reset a user&#39;s password
*FortanixSdkmsRestApi.UsersApi* | [**updateUser**](docs/UsersApi.md#updateUser) | **PATCH** /sys/v1/users/{user-id} | Update user
*FortanixSdkmsRestApi.UsersApi* | [**validatePasswordResetToken**](docs/UsersApi.md#validatePasswordResetToken) | **POST** /sys/v1/users/{user-id}/validate_token | Validates password reset token for the user
*FortanixSdkmsRestApi.WrappingAndUnwrappingApi* | [**unwrapKey**](docs/WrappingAndUnwrappingApi.md#unwrapKey) | **POST** /crypto/v1/keys/{key-id}/unwrapkey | Unwrap a security object with a key
*FortanixSdkmsRestApi.WrappingAndUnwrappingApi* | [**unwrapKeyEx**](docs/WrappingAndUnwrappingApi.md#unwrapKeyEx) | **POST** /crypto/v1/unwrapkey | Unwrap a security object with a key
*FortanixSdkmsRestApi.WrappingAndUnwrappingApi* | [**wrapKey**](docs/WrappingAndUnwrappingApi.md#wrapKey) | **POST** /crypto/v1/keys/{key-id}/wrapkey | Wrap a security object with a key 
*FortanixSdkmsRestApi.WrappingAndUnwrappingApi* | [**wrapKeyEx**](docs/WrappingAndUnwrappingApi.md#wrapKeyEx) | **POST** /crypto/v1/wrapkey | Wrap a security object with a key 


## Documentation for Models

 - [FortanixSdkmsRestApi.ADDecryptInput](docs/ADDecryptInput.md)
 - [FortanixSdkmsRestApi.ADEncryptInput](docs/ADEncryptInput.md)
 - [FortanixSdkmsRestApi.Account](docs/Account.md)
 - [FortanixSdkmsRestApi.AccountRequest](docs/AccountRequest.md)
 - [FortanixSdkmsRestApi.AccountState](docs/AccountState.md)
 - [FortanixSdkmsRestApi.AgreeKeyMechanism](docs/AgreeKeyMechanism.md)
 - [FortanixSdkmsRestApi.AgreeKeyRequest](docs/AgreeKeyRequest.md)
 - [FortanixSdkmsRestApi.App](docs/App.md)
 - [FortanixSdkmsRestApi.AppAuthType](docs/AppAuthType.md)
 - [FortanixSdkmsRestApi.AppCredential](docs/AppCredential.md)
 - [FortanixSdkmsRestApi.AppCredentialResponse](docs/AppCredentialResponse.md)
 - [FortanixSdkmsRestApi.AppCredentialSignedjwt](docs/AppCredentialSignedjwt.md)
 - [FortanixSdkmsRestApi.AppCredentialSignedjwtSigningKeys](docs/AppCredentialSignedjwtSigningKeys.md)
 - [FortanixSdkmsRestApi.AppCredentialTrustedca](docs/AppCredentialTrustedca.md)
 - [FortanixSdkmsRestApi.AppOauthConfig](docs/AppOauthConfig.md)
 - [FortanixSdkmsRestApi.AppPermissions](docs/AppPermissions.md)
 - [FortanixSdkmsRestApi.AppRequest](docs/AppRequest.md)
 - [FortanixSdkmsRestApi.AppResetSecretRequest](docs/AppResetSecretRequest.md)
 - [FortanixSdkmsRestApi.ApprovableResult](docs/ApprovableResult.md)
 - [FortanixSdkmsRestApi.ApprovalRequest](docs/ApprovalRequest.md)
 - [FortanixSdkmsRestApi.ApprovalRequestRequest](docs/ApprovalRequestRequest.md)
 - [FortanixSdkmsRestApi.ApprovalStatus](docs/ApprovalStatus.md)
 - [FortanixSdkmsRestApi.ApprovalSubject](docs/ApprovalSubject.md)
 - [FortanixSdkmsRestApi.ApproveRequest](docs/ApproveRequest.md)
 - [FortanixSdkmsRestApi.AuditLogResponse](docs/AuditLogResponse.md)
 - [FortanixSdkmsRestApi.AuthConfig](docs/AuthConfig.md)
 - [FortanixSdkmsRestApi.AuthConfigPassword](docs/AuthConfigPassword.md)
 - [FortanixSdkmsRestApi.AuthConfigSignedJWT](docs/AuthConfigSignedJWT.md)
 - [FortanixSdkmsRestApi.AuthResponse](docs/AuthResponse.md)
 - [FortanixSdkmsRestApi.AuthType](docs/AuthType.md)
 - [FortanixSdkmsRestApi.AzureKeyVaultType](docs/AzureKeyVaultType.md)
 - [FortanixSdkmsRestApi.BatchDecryptRequest](docs/BatchDecryptRequest.md)
 - [FortanixSdkmsRestApi.BatchDecryptRequestInner](docs/BatchDecryptRequestInner.md)
 - [FortanixSdkmsRestApi.BatchDecryptResponse](docs/BatchDecryptResponse.md)
 - [FortanixSdkmsRestApi.BatchDecryptResponseInner](docs/BatchDecryptResponseInner.md)
 - [FortanixSdkmsRestApi.BatchEncryptRequest](docs/BatchEncryptRequest.md)
 - [FortanixSdkmsRestApi.BatchEncryptRequestInner](docs/BatchEncryptRequestInner.md)
 - [FortanixSdkmsRestApi.BatchEncryptResponse](docs/BatchEncryptResponse.md)
 - [FortanixSdkmsRestApi.BatchEncryptResponseInner](docs/BatchEncryptResponseInner.md)
 - [FortanixSdkmsRestApi.BatchMacRequest](docs/BatchMacRequest.md)
 - [FortanixSdkmsRestApi.BatchMacResponse](docs/BatchMacResponse.md)
 - [FortanixSdkmsRestApi.BatchMacResponseInner](docs/BatchMacResponseInner.md)
 - [FortanixSdkmsRestApi.BatchMacVerifyRequest](docs/BatchMacVerifyRequest.md)
 - [FortanixSdkmsRestApi.BatchSignRequest](docs/BatchSignRequest.md)
 - [FortanixSdkmsRestApi.BatchSignResponse](docs/BatchSignResponse.md)
 - [FortanixSdkmsRestApi.BatchSignResponseInner](docs/BatchSignResponseInner.md)
 - [FortanixSdkmsRestApi.BatchVerifyRequest](docs/BatchVerifyRequest.md)
 - [FortanixSdkmsRestApi.BatchVerifyResponse](docs/BatchVerifyResponse.md)
 - [FortanixSdkmsRestApi.BatchVerifyResponseInner](docs/BatchVerifyResponseInner.md)
 - [FortanixSdkmsRestApi.CaConfig](docs/CaConfig.md)
 - [FortanixSdkmsRestApi.ChildAccountUser](docs/ChildAccountUser.md)
 - [FortanixSdkmsRestApi.ChildAccountUserRequest](docs/ChildAccountUserRequest.md)
 - [FortanixSdkmsRestApi.CipherMode](docs/CipherMode.md)
 - [FortanixSdkmsRestApi.ConfirmEmailRequest](docs/ConfirmEmailRequest.md)
 - [FortanixSdkmsRestApi.ConfirmEmailResponse](docs/ConfirmEmailResponse.md)
 - [FortanixSdkmsRestApi.CreatorType](docs/CreatorType.md)
 - [FortanixSdkmsRestApi.CryptMode](docs/CryptMode.md)
 - [FortanixSdkmsRestApi.DecryptFinalRequest](docs/DecryptFinalRequest.md)
 - [FortanixSdkmsRestApi.DecryptFinalRequestEx](docs/DecryptFinalRequestEx.md)
 - [FortanixSdkmsRestApi.DecryptFinalResponse](docs/DecryptFinalResponse.md)
 - [FortanixSdkmsRestApi.DecryptInitRequest](docs/DecryptInitRequest.md)
 - [FortanixSdkmsRestApi.DecryptInitRequestEx](docs/DecryptInitRequestEx.md)
 - [FortanixSdkmsRestApi.DecryptInitResponse](docs/DecryptInitResponse.md)
 - [FortanixSdkmsRestApi.DecryptRequest](docs/DecryptRequest.md)
 - [FortanixSdkmsRestApi.DecryptRequestEx](docs/DecryptRequestEx.md)
 - [FortanixSdkmsRestApi.DecryptResponse](docs/DecryptResponse.md)
 - [FortanixSdkmsRestApi.DecryptUpdateRequest](docs/DecryptUpdateRequest.md)
 - [FortanixSdkmsRestApi.DecryptUpdateRequestEx](docs/DecryptUpdateRequestEx.md)
 - [FortanixSdkmsRestApi.DecryptUpdateResponse](docs/DecryptUpdateResponse.md)
 - [FortanixSdkmsRestApi.DeriveKeyMechanism](docs/DeriveKeyMechanism.md)
 - [FortanixSdkmsRestApi.DeriveKeyRequest](docs/DeriveKeyRequest.md)
 - [FortanixSdkmsRestApi.DeriveKeyRequestEx](docs/DeriveKeyRequestEx.md)
 - [FortanixSdkmsRestApi.DigestAlgorithm](docs/DigestAlgorithm.md)
 - [FortanixSdkmsRestApi.DigestRequest](docs/DigestRequest.md)
 - [FortanixSdkmsRestApi.DigestResponse](docs/DigestResponse.md)
 - [FortanixSdkmsRestApi.DsaOptions](docs/DsaOptions.md)
 - [FortanixSdkmsRestApi.EllipticCurve](docs/EllipticCurve.md)
 - [FortanixSdkmsRestApi.EncryptFinalRequest](docs/EncryptFinalRequest.md)
 - [FortanixSdkmsRestApi.EncryptFinalRequestEx](docs/EncryptFinalRequestEx.md)
 - [FortanixSdkmsRestApi.EncryptFinalResponse](docs/EncryptFinalResponse.md)
 - [FortanixSdkmsRestApi.EncryptInitRequest](docs/EncryptInitRequest.md)
 - [FortanixSdkmsRestApi.EncryptInitRequestEx](docs/EncryptInitRequestEx.md)
 - [FortanixSdkmsRestApi.EncryptInitResponse](docs/EncryptInitResponse.md)
 - [FortanixSdkmsRestApi.EncryptRequest](docs/EncryptRequest.md)
 - [FortanixSdkmsRestApi.EncryptRequestEx](docs/EncryptRequestEx.md)
 - [FortanixSdkmsRestApi.EncryptResponse](docs/EncryptResponse.md)
 - [FortanixSdkmsRestApi.EncryptUpdateRequest](docs/EncryptUpdateRequest.md)
 - [FortanixSdkmsRestApi.EncryptUpdateRequestEx](docs/EncryptUpdateRequestEx.md)
 - [FortanixSdkmsRestApi.EncryptUpdateResponse](docs/EncryptUpdateResponse.md)
 - [FortanixSdkmsRestApi.Entity](docs/Entity.md)
 - [FortanixSdkmsRestApi.Error](docs/Error.md)
 - [FortanixSdkmsRestApi.ExportComponentsResponse](docs/ExportComponentsResponse.md)
 - [FortanixSdkmsRestApi.ExportSobjectComponentsRequest](docs/ExportSobjectComponentsRequest.md)
 - [FortanixSdkmsRestApi.ForgotPasswordRequest](docs/ForgotPasswordRequest.md)
 - [FortanixSdkmsRestApi.FpeCompoundPart](docs/FpeCompoundPart.md)
 - [FortanixSdkmsRestApi.FpeConstraints](docs/FpeConstraints.md)
 - [FortanixSdkmsRestApi.FpeConstraintsApplicabilitySubparts](docs/FpeConstraintsApplicabilitySubparts.md)
 - [FortanixSdkmsRestApi.FpeDataPart](docs/FpeDataPart.md)
 - [FortanixSdkmsRestApi.FpeDate](docs/FpeDate.md)
 - [FortanixSdkmsRestApi.FpeDateBound](docs/FpeDateBound.md)
 - [FortanixSdkmsRestApi.FpeDatePart](docs/FpeDatePart.md)
 - [FortanixSdkmsRestApi.FpeDateWithBounds](docs/FpeDateWithBounds.md)
 - [FortanixSdkmsRestApi.FpeEncryptedPart](docs/FpeEncryptedPart.md)
 - [FortanixSdkmsRestApi.FpeLiteralPart](docs/FpeLiteralPart.md)
 - [FortanixSdkmsRestApi.FpeOptions](docs/FpeOptions.md)
 - [FortanixSdkmsRestApi.FpeOptionsAdvanced](docs/FpeOptionsAdvanced.md)
 - [FortanixSdkmsRestApi.FpeOptionsBasic](docs/FpeOptionsBasic.md)
 - [FortanixSdkmsRestApi.GoogleServiceAccountKey](docs/GoogleServiceAccountKey.md)
 - [FortanixSdkmsRestApi.Group](docs/Group.md)
 - [FortanixSdkmsRestApi.GroupRequest](docs/GroupRequest.md)
 - [FortanixSdkmsRestApi.HistoryItem](docs/HistoryItem.md)
 - [FortanixSdkmsRestApi.HistoryItemState](docs/HistoryItemState.md)
 - [FortanixSdkmsRestApi.HmgConfig](docs/HmgConfig.md)
 - [FortanixSdkmsRestApi.HmgKind](docs/HmgKind.md)
 - [FortanixSdkmsRestApi.IVDecryptInput](docs/IVDecryptInput.md)
 - [FortanixSdkmsRestApi.IVEncryptInput](docs/IVEncryptInput.md)
 - [FortanixSdkmsRestApi.IVEncryptOutput](docs/IVEncryptOutput.md)
 - [FortanixSdkmsRestApi.ImportSobjectComponentsRequest](docs/ImportSobjectComponentsRequest.md)
 - [FortanixSdkmsRestApi.JWTSigningKeyType](docs/JWTSigningKeyType.md)
 - [FortanixSdkmsRestApi.KeyCheckValueResponse](docs/KeyCheckValueResponse.md)
 - [FortanixSdkmsRestApi.KeyFormat](docs/KeyFormat.md)
 - [FortanixSdkmsRestApi.KeyObject](docs/KeyObject.md)
 - [FortanixSdkmsRestApi.KeyObjectState](docs/KeyObjectState.md)
 - [FortanixSdkmsRestApi.KeyOperations](docs/KeyOperations.md)
 - [FortanixSdkmsRestApi.KeyUndoPolicy](docs/KeyUndoPolicy.md)
 - [FortanixSdkmsRestApi.Language](docs/Language.md)
 - [FortanixSdkmsRestApi.LoggingConfig](docs/LoggingConfig.md)
 - [FortanixSdkmsRestApi.LoggingConfigRequest](docs/LoggingConfigRequest.md)
 - [FortanixSdkmsRestApi.MacGenerateRequest](docs/MacGenerateRequest.md)
 - [FortanixSdkmsRestApi.MacGenerateRequestEx](docs/MacGenerateRequestEx.md)
 - [FortanixSdkmsRestApi.MacGenerateResponse](docs/MacGenerateResponse.md)
 - [FortanixSdkmsRestApi.MacVerifyRequest](docs/MacVerifyRequest.md)
 - [FortanixSdkmsRestApi.MacVerifyRequestEx](docs/MacVerifyRequestEx.md)
 - [FortanixSdkmsRestApi.MacVerifyResponse](docs/MacVerifyResponse.md)
 - [FortanixSdkmsRestApi.MfaChallenge](docs/MfaChallenge.md)
 - [FortanixSdkmsRestApi.Mgf](docs/Mgf.md)
 - [FortanixSdkmsRestApi.MgfMgf1](docs/MgfMgf1.md)
 - [FortanixSdkmsRestApi.NotificationPref](docs/NotificationPref.md)
 - [FortanixSdkmsRestApi.ObjectDigestRequest](docs/ObjectDigestRequest.md)
 - [FortanixSdkmsRestApi.ObjectOrigin](docs/ObjectOrigin.md)
 - [FortanixSdkmsRestApi.ObjectType](docs/ObjectType.md)
 - [FortanixSdkmsRestApi.PasswordChangeRequest](docs/PasswordChangeRequest.md)
 - [FortanixSdkmsRestApi.PasswordResetRequest](docs/PasswordResetRequest.md)
 - [FortanixSdkmsRestApi.PersistTransientKeyRequest](docs/PersistTransientKeyRequest.md)
 - [FortanixSdkmsRestApi.Plugin](docs/Plugin.md)
 - [FortanixSdkmsRestApi.PluginInvokeRequest](docs/PluginInvokeRequest.md)
 - [FortanixSdkmsRestApi.PluginInvokeResponse](docs/PluginInvokeResponse.md)
 - [FortanixSdkmsRestApi.PluginRequest](docs/PluginRequest.md)
 - [FortanixSdkmsRestApi.PluginSource](docs/PluginSource.md)
 - [FortanixSdkmsRestApi.PluginType](docs/PluginType.md)
 - [FortanixSdkmsRestApi.ProcessInviteRequest](docs/ProcessInviteRequest.md)
 - [FortanixSdkmsRestApi.RecoveryCodes](docs/RecoveryCodes.md)
 - [FortanixSdkmsRestApi.RevertRequest](docs/RevertRequest.md)
 - [FortanixSdkmsRestApi.RevocationReason](docs/RevocationReason.md)
 - [FortanixSdkmsRestApi.RevocationReasonCode](docs/RevocationReasonCode.md)
 - [FortanixSdkmsRestApi.RotationInterval](docs/RotationInterval.md)
 - [FortanixSdkmsRestApi.RotationPolicy](docs/RotationPolicy.md)
 - [FortanixSdkmsRestApi.RsaEncryptionPadding](docs/RsaEncryptionPadding.md)
 - [FortanixSdkmsRestApi.RsaEncryptionPaddingOAEP](docs/RsaEncryptionPaddingOAEP.md)
 - [FortanixSdkmsRestApi.RsaEncryptionPolicy](docs/RsaEncryptionPolicy.md)
 - [FortanixSdkmsRestApi.RsaEncryptionPolicyPadding](docs/RsaEncryptionPolicyPadding.md)
 - [FortanixSdkmsRestApi.RsaEncryptionPolicyPaddingOAEP](docs/RsaEncryptionPolicyPaddingOAEP.md)
 - [FortanixSdkmsRestApi.RsaOptions](docs/RsaOptions.md)
 - [FortanixSdkmsRestApi.RsaSignaturePadding](docs/RsaSignaturePadding.md)
 - [FortanixSdkmsRestApi.RsaSignaturePaddingPSS](docs/RsaSignaturePaddingPSS.md)
 - [FortanixSdkmsRestApi.RsaSignaturePolicy](docs/RsaSignaturePolicy.md)
 - [FortanixSdkmsRestApi.RsaSignaturePolicyPadding](docs/RsaSignaturePolicyPadding.md)
 - [FortanixSdkmsRestApi.ScheduleDeletionRequest](docs/ScheduleDeletionRequest.md)
 - [FortanixSdkmsRestApi.SelectAccountRequest](docs/SelectAccountRequest.md)
 - [FortanixSdkmsRestApi.SelectAccountResponse](docs/SelectAccountResponse.md)
 - [FortanixSdkmsRestApi.ServerMode](docs/ServerMode.md)
 - [FortanixSdkmsRestApi.SignRequest](docs/SignRequest.md)
 - [FortanixSdkmsRestApi.SignRequestEx](docs/SignRequestEx.md)
 - [FortanixSdkmsRestApi.SignResponse](docs/SignResponse.md)
 - [FortanixSdkmsRestApi.SignatureMode](docs/SignatureMode.md)
 - [FortanixSdkmsRestApi.SignupRequest](docs/SignupRequest.md)
 - [FortanixSdkmsRestApi.SobjectComponent](docs/SobjectComponent.md)
 - [FortanixSdkmsRestApi.SobjectDescriptor](docs/SobjectDescriptor.md)
 - [FortanixSdkmsRestApi.SobjectRequest](docs/SobjectRequest.md)
 - [FortanixSdkmsRestApi.SplittingMethod](docs/SplittingMethod.md)
 - [FortanixSdkmsRestApi.SplunkLoggingConfig](docs/SplunkLoggingConfig.md)
 - [FortanixSdkmsRestApi.SplunkLoggingConfigRequest](docs/SplunkLoggingConfigRequest.md)
 - [FortanixSdkmsRestApi.StackdriverLoggingConfig](docs/StackdriverLoggingConfig.md)
 - [FortanixSdkmsRestApi.StackdriverLoggingConfigRequest](docs/StackdriverLoggingConfigRequest.md)
 - [FortanixSdkmsRestApi.StatsResponse](docs/StatsResponse.md)
 - [FortanixSdkmsRestApi.SubscriptionChangeRequest](docs/SubscriptionChangeRequest.md)
 - [FortanixSdkmsRestApi.SubscriptionType](docs/SubscriptionType.md)
 - [FortanixSdkmsRestApi.TagDecryptInput](docs/TagDecryptInput.md)
 - [FortanixSdkmsRestApi.TagEncryptOutput](docs/TagEncryptOutput.md)
 - [FortanixSdkmsRestApi.TagLenEncryptInput](docs/TagLenEncryptInput.md)
 - [FortanixSdkmsRestApi.TlsConfig](docs/TlsConfig.md)
 - [FortanixSdkmsRestApi.TlsMode](docs/TlsMode.md)
 - [FortanixSdkmsRestApi.U2fAddDeviceRequest](docs/U2fAddDeviceRequest.md)
 - [FortanixSdkmsRestApi.U2fDelDeviceRequest](docs/U2fDelDeviceRequest.md)
 - [FortanixSdkmsRestApi.U2fDevice](docs/U2fDevice.md)
 - [FortanixSdkmsRestApi.U2fKey](docs/U2fKey.md)
 - [FortanixSdkmsRestApi.U2fRenameDeviceRequest](docs/U2fRenameDeviceRequest.md)
 - [FortanixSdkmsRestApi.UnwrapKeyParams](docs/UnwrapKeyParams.md)
 - [FortanixSdkmsRestApi.UnwrapKeyRequest](docs/UnwrapKeyRequest.md)
 - [FortanixSdkmsRestApi.UnwrapKeyRequestEx](docs/UnwrapKeyRequestEx.md)
 - [FortanixSdkmsRestApi.User](docs/User.md)
 - [FortanixSdkmsRestApi.UserAccountFlags](docs/UserAccountFlags.md)
 - [FortanixSdkmsRestApi.UserAccountMap](docs/UserAccountMap.md)
 - [FortanixSdkmsRestApi.UserGroupFlags](docs/UserGroupFlags.md)
 - [FortanixSdkmsRestApi.UserGroupMap](docs/UserGroupMap.md)
 - [FortanixSdkmsRestApi.UserRequest](docs/UserRequest.md)
 - [FortanixSdkmsRestApi.UserState](docs/UserState.md)
 - [FortanixSdkmsRestApi.Uuid](docs/Uuid.md)
 - [FortanixSdkmsRestApi.ValidateTokenRequest](docs/ValidateTokenRequest.md)
 - [FortanixSdkmsRestApi.ValidateTokenResponse](docs/ValidateTokenResponse.md)
 - [FortanixSdkmsRestApi.VerifyKcvRequest](docs/VerifyKcvRequest.md)
 - [FortanixSdkmsRestApi.VerifyKcvResponse](docs/VerifyKcvResponse.md)
 - [FortanixSdkmsRestApi.VerifyRequest](docs/VerifyRequest.md)
 - [FortanixSdkmsRestApi.VerifyRequestEx](docs/VerifyRequestEx.md)
 - [FortanixSdkmsRestApi.VerifyResponse](docs/VerifyResponse.md)
 - [FortanixSdkmsRestApi.VersionResponse](docs/VersionResponse.md)
 - [FortanixSdkmsRestApi.WrapKeyParams](docs/WrapKeyParams.md)
 - [FortanixSdkmsRestApi.WrapKeyRequest](docs/WrapKeyRequest.md)
 - [FortanixSdkmsRestApi.WrapKeyRequestEx](docs/WrapKeyRequestEx.md)
 - [FortanixSdkmsRestApi.WrapKeyResponse](docs/WrapKeyResponse.md)


## Documentation for Authorization


### basicAuth

- **Type**: HTTP basic authentication

### bearerToken

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header

