# FortanixSdkmsRestApi.AWSApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**cancelDeletion**](AWSApi.md#cancelDeletion) | **POST** /crypto/v1/keys/{key-id}/cancel_deletion | Cancel scheduled deletion of an AWS KMS key
[**deleteKeyMaterial**](AWSApi.md#deleteKeyMaterial) | **POST** /crypto/v1/keys/{key-id}/delete_key_material | Delete the key material of an AWS KMS key
[**restore**](AWSApi.md#restore) | **POST** /crypto/v1/keys/{key-id}/restore | Restore an AWS KMS key from its source key material
[**scheduleDeletion**](AWSApi.md#scheduleDeletion) | **POST** /crypto/v1/keys/{key-id}/schedule_deletion | Schedule an AWS KMS key for deletion


<a name="cancelDeletion"></a>
# **cancelDeletion**
> KeyObject cancelDeletion(keyId)

Cancel scheduled deletion of an AWS KMS key

Cancel scheduled deletion of an AWS KMS key

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.AWSApi();

var keyId = "keyId_example"; // String | kid of security object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.cancelDeletion(keyId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **keyId** | **String**| kid of security object | 

### Return type

[**KeyObject**](KeyObject.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="deleteKeyMaterial"></a>
# **deleteKeyMaterial**
> KeyObject deleteKeyMaterial(keyId)

Delete the key material of an AWS KMS key

Delete the key material of an AWS KMS key

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.AWSApi();

var keyId = "keyId_example"; // String | kid of security object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.deleteKeyMaterial(keyId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **keyId** | **String**| kid of security object | 

### Return type

[**KeyObject**](KeyObject.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="restore"></a>
# **restore**
> KeyObject restore(keyId)

Restore an AWS KMS key from its source key material

Restore an AWS key from its source key material

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.AWSApi();

var keyId = "keyId_example"; // String | kid of security object


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.restore(keyId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **keyId** | **String**| kid of security object | 

### Return type

[**KeyObject**](KeyObject.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="scheduleDeletion"></a>
# **scheduleDeletion**
> KeyObject scheduleDeletion(keyIdbody)

Schedule an AWS KMS key for deletion

Schedule an AWS KMS key for deletion

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.AWSApi();

var keyId = "keyId_example"; // String | kid of security object

var body = new FortanixSdkmsRestApi.ScheduleDeletionRequest(); // ScheduleDeletionRequest | Request to schedule deletion for an AWS KMS key


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.scheduleDeletion(keyIdbody, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **keyId** | **String**| kid of security object | 
 **body** | [**ScheduleDeletionRequest**](ScheduleDeletionRequest.md)| Request to schedule deletion for an AWS KMS key | 

### Return type

[**KeyObject**](KeyObject.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

