# FortanixSdkmsRestApi.ChildAccountUsersApi

All URIs are relative to *https://apps.smartkey.io*

Method | HTTP request | Description
------------- | ------------- | -------------
[**createChildAccountUser**](ChildAccountUsersApi.md#createChildAccountUser) | **POST** /sys/v1/users/child_account | Create a new user user in a child account
[**deleteChildAccountUser**](ChildAccountUsersApi.md#deleteChildAccountUser) | **DELETE** /sys/v1/users/child_account/{user-id} | Completely delete a user in child account
[**getAllChildAccountUsers**](ChildAccountUsersApi.md#getAllChildAccountUsers) | **GET** /sys/v1/users/child_account/{account-id}/all | Get all users in a child account
[**getChildAccountUser**](ChildAccountUsersApi.md#getChildAccountUser) | **GET** /sys/v1/users/child_account/{user-id} | Get a specific child account user
[**updateChildAccountUser**](ChildAccountUsersApi.md#updateChildAccountUser) | **PATCH** /sys/v1/users/child_account/{user-id} | Update a child account user


<a name="createChildAccountUser"></a>
# **createChildAccountUser**
> ChildAccountUser createChildAccountUser(body)

Create a new user user in a child account

Create a new user user in a child account.

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.ChildAccountUsersApi();

var body = new FortanixSdkmsRestApi.ChildAccountUserRequest(); // ChildAccountUserRequest | User in child account


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.createChildAccountUser(body, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **body** | [**ChildAccountUserRequest**](ChildAccountUserRequest.md)| User in child account | 

### Return type

[**ChildAccountUser**](ChildAccountUser.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="deleteChildAccountUser"></a>
# **deleteChildAccountUser**
> deleteChildAccountUser(userId, )

Completely delete a user in child account

Completely delete a user in child account.

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.ChildAccountUsersApi();

var userId = "userId_example"; // String | User Identifier


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully.');
  }
};
apiInstance.deleteChildAccountUser(userId, , callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **String**| User Identifier | 

### Return type

null (empty response body)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getAllChildAccountUsers"></a>
# **getAllChildAccountUsers**
> [ChildAccountUser] getAllChildAccountUsers(accountId)

Get all users in a child account

Get all users in a child account

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.ChildAccountUsersApi();

var accountId = "accountId_example"; // String | Account Identifier


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getAllChildAccountUsers(accountId, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **accountId** | **String**| Account Identifier | 

### Return type

[**[ChildAccountUser]**](ChildAccountUser.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="getChildAccountUser"></a>
# **getChildAccountUser**
> ChildAccountUser getChildAccountUser(userId, )

Get a specific child account user

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.ChildAccountUsersApi();

var userId = "userId_example"; // String | User Identifier


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.getChildAccountUser(userId, , callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **String**| User Identifier | 

### Return type

[**ChildAccountUser**](ChildAccountUser.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="updateChildAccountUser"></a>
# **updateChildAccountUser**
> ChildAccountUser updateChildAccountUser(userId, body)

Update a child account user

Change a child account user&#39;s properties.

### Example
```javascript
var FortanixSdkmsRestApi = require('fortanix_sdkms_rest_api');
var defaultClient = FortanixSdkmsRestApi.ApiClient.instance;

// Configure API key authorization: bearerToken
var bearerToken = defaultClient.authentications['bearerToken'];
bearerToken.apiKey = 'YOUR API KEY';
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//bearerToken.apiKeyPrefix = 'Token';

var apiInstance = new FortanixSdkmsRestApi.ChildAccountUsersApi();

var userId = "userId_example"; // String | User Identifier

var body = new FortanixSdkmsRestApi.ChildAccountUserRequest(); // ChildAccountUserRequest | User in child account


var callback = function(error, data, response) {
  if (error) {
    console.error(error);
  } else {
    console.log('API called successfully. Returned data: ' + data);
  }
};
apiInstance.updateChildAccountUser(userId, body, callback);
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **String**| User Identifier | 
 **body** | [**ChildAccountUserRequest**](ChildAccountUserRequest.md)| User in child account | 

### Return type

[**ChildAccountUser**](ChildAccountUser.md)

### Authorization

[bearerToken](../README.md#bearerToken)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

