/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ADDecryptInput', 'model/ADEncryptInput', 'model/Account', 'model/AccountRequest', 'model/AccountState', 'model/AgreeKeyMechanism', 'model/AgreeKeyRequest', 'model/App', 'model/AppAuthType', 'model/AppCredential', 'model/AppCredentialResponse', 'model/AppCredentialSignedjwt', 'model/AppCredentialSignedjwtSigningKeys', 'model/AppCredentialTrustedca', 'model/AppOauthConfig', 'model/AppPermissions', 'model/AppRequest', 'model/AppResetSecretRequest', 'model/ApprovableResult', 'model/ApprovalRequest', 'model/ApprovalRequestRequest', 'model/ApprovalStatus', 'model/ApprovalSubject', 'model/ApproveRequest', 'model/AuditLogResponse', 'model/AuthConfig', 'model/AuthConfigPassword', 'model/AuthConfigSignedJWT', 'model/AuthResponse', 'model/AuthType', 'model/AzureKeyVaultType', 'model/BatchDecryptRequest', 'model/BatchDecryptRequestInner', 'model/BatchDecryptResponse', 'model/BatchDecryptResponseInner', 'model/BatchEncryptRequest', 'model/BatchEncryptRequestInner', 'model/BatchEncryptResponse', 'model/BatchEncryptResponseInner', 'model/BatchMacRequest', 'model/BatchMacResponse', 'model/BatchMacResponseInner', 'model/BatchMacVerifyRequest', 'model/BatchSignRequest', 'model/BatchSignResponse', 'model/BatchSignResponseInner', 'model/BatchVerifyRequest', 'model/BatchVerifyResponse', 'model/BatchVerifyResponseInner', 'model/CaConfig', 'model/ChildAccountUser', 'model/ChildAccountUserRequest', 'model/CipherMode', 'model/ConfirmEmailRequest', 'model/ConfirmEmailResponse', 'model/CreatorType', 'model/CryptMode', 'model/DecryptFinalRequest', 'model/DecryptFinalRequestEx', 'model/DecryptFinalResponse', 'model/DecryptInitRequest', 'model/DecryptInitRequestEx', 'model/DecryptInitResponse', 'model/DecryptRequest', 'model/DecryptRequestEx', 'model/DecryptResponse', 'model/DecryptUpdateRequest', 'model/DecryptUpdateRequestEx', 'model/DecryptUpdateResponse', 'model/DeriveKeyMechanism', 'model/DeriveKeyRequest', 'model/DeriveKeyRequestEx', 'model/DigestAlgorithm', 'model/DigestRequest', 'model/DigestResponse', 'model/DsaOptions', 'model/EllipticCurve', 'model/EncryptFinalRequest', 'model/EncryptFinalRequestEx', 'model/EncryptFinalResponse', 'model/EncryptInitRequest', 'model/EncryptInitRequestEx', 'model/EncryptInitResponse', 'model/EncryptRequest', 'model/EncryptRequestEx', 'model/EncryptResponse', 'model/EncryptUpdateRequest', 'model/EncryptUpdateRequestEx', 'model/EncryptUpdateResponse', 'model/Entity', 'model/Error', 'model/ExportComponentsResponse', 'model/ExportSobjectComponentsRequest', 'model/ForgotPasswordRequest', 'model/FpeCompoundPart', 'model/FpeConstraints', 'model/FpeConstraintsApplicabilitySubparts', 'model/FpeDataPart', 'model/FpeDate', 'model/FpeDateBound', 'model/FpeDatePart', 'model/FpeDateWithBounds', 'model/FpeEncryptedPart', 'model/FpeLiteralPart', 'model/FpeOptions', 'model/FpeOptionsAdvanced', 'model/FpeOptionsBasic', 'model/GoogleServiceAccountKey', 'model/Group', 'model/GroupRequest', 'model/HistoryItem', 'model/HistoryItemState', 'model/HmgConfig', 'model/HmgKind', 'model/IVDecryptInput', 'model/IVEncryptInput', 'model/IVEncryptOutput', 'model/ImportSobjectComponentsRequest', 'model/JWTSigningKeyType', 'model/KeyCheckValueResponse', 'model/KeyFormat', 'model/KeyObject', 'model/KeyObjectState', 'model/KeyOperations', 'model/KeyUndoPolicy', 'model/Language', 'model/LoggingConfig', 'model/LoggingConfigRequest', 'model/MacGenerateRequest', 'model/MacGenerateRequestEx', 'model/MacGenerateResponse', 'model/MacVerifyRequest', 'model/MacVerifyRequestEx', 'model/MacVerifyResponse', 'model/MfaChallenge', 'model/Mgf', 'model/MgfMgf1', 'model/NotificationPref', 'model/ObjectDigestRequest', 'model/ObjectOrigin', 'model/ObjectType', 'model/PasswordChangeRequest', 'model/PasswordResetRequest', 'model/PersistTransientKeyRequest', 'model/Plugin', 'model/PluginInvokeRequest', 'model/PluginInvokeResponse', 'model/PluginRequest', 'model/PluginSource', 'model/PluginType', 'model/ProcessInviteRequest', 'model/RecoveryCodes', 'model/RevertRequest', 'model/RevocationReason', 'model/RevocationReasonCode', 'model/RotationInterval', 'model/RotationPolicy', 'model/RsaEncryptionPadding', 'model/RsaEncryptionPaddingOAEP', 'model/RsaEncryptionPolicy', 'model/RsaEncryptionPolicyPadding', 'model/RsaEncryptionPolicyPaddingOAEP', 'model/RsaOptions', 'model/RsaSignaturePadding', 'model/RsaSignaturePaddingPSS', 'model/RsaSignaturePolicy', 'model/RsaSignaturePolicyPadding', 'model/ScheduleDeletionRequest', 'model/SelectAccountRequest', 'model/SelectAccountResponse', 'model/ServerMode', 'model/SignRequest', 'model/SignRequestEx', 'model/SignResponse', 'model/SignatureMode', 'model/SignupRequest', 'model/SobjectComponent', 'model/SobjectDescriptor', 'model/SobjectRequest', 'model/SplittingMethod', 'model/SplunkLoggingConfig', 'model/SplunkLoggingConfigRequest', 'model/StackdriverLoggingConfig', 'model/StackdriverLoggingConfigRequest', 'model/StatsResponse', 'model/SubscriptionChangeRequest', 'model/SubscriptionType', 'model/TagDecryptInput', 'model/TagEncryptOutput', 'model/TagLenEncryptInput', 'model/TlsConfig', 'model/TlsMode', 'model/U2fAddDeviceRequest', 'model/U2fDelDeviceRequest', 'model/U2fDevice', 'model/U2fKey', 'model/U2fRenameDeviceRequest', 'model/UnwrapKeyParams', 'model/UnwrapKeyRequest', 'model/UnwrapKeyRequestEx', 'model/User', 'model/UserAccountFlags', 'model/UserAccountMap', 'model/UserGroupFlags', 'model/UserGroupMap', 'model/UserRequest', 'model/UserState', 'model/Uuid', 'model/ValidateTokenRequest', 'model/ValidateTokenResponse', 'model/VerifyKcvRequest', 'model/VerifyKcvResponse', 'model/VerifyRequest', 'model/VerifyRequestEx', 'model/VerifyResponse', 'model/VersionResponse', 'model/WrapKeyParams', 'model/WrapKeyRequest', 'model/WrapKeyRequestEx', 'model/WrapKeyResponse', 'api/AWSApi', 'api/AccountsApi', 'api/ApprovalRequestsApi', 'api/AppsApi', 'api/AuthenticationApi', 'api/ChildAccountUsersApi', 'api/ChildAccountsApi', 'api/DigestApi', 'api/EncryptionAndDecryptionApi', 'api/GroupsApi', 'api/LogsApi', 'api/PluginsApi', 'api/SecurityObjectsApi', 'api/SignAndVerifyApi', 'api/StatsApi', 'api/TwoFactorAuthenticationApi', 'api/UsersApi', 'api/WrappingAndUnwrappingApi'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('./ApiClient'), require('./model/ADDecryptInput'), require('./model/ADEncryptInput'), require('./model/Account'), require('./model/AccountRequest'), require('./model/AccountState'), require('./model/AgreeKeyMechanism'), require('./model/AgreeKeyRequest'), require('./model/App'), require('./model/AppAuthType'), require('./model/AppCredential'), require('./model/AppCredentialResponse'), require('./model/AppCredentialSignedjwt'), require('./model/AppCredentialSignedjwtSigningKeys'), require('./model/AppCredentialTrustedca'), require('./model/AppOauthConfig'), require('./model/AppPermissions'), require('./model/AppRequest'), require('./model/AppResetSecretRequest'), require('./model/ApprovableResult'), require('./model/ApprovalRequest'), require('./model/ApprovalRequestRequest'), require('./model/ApprovalStatus'), require('./model/ApprovalSubject'), require('./model/ApproveRequest'), require('./model/AuditLogResponse'), require('./model/AuthConfig'), require('./model/AuthConfigPassword'), require('./model/AuthConfigSignedJWT'), require('./model/AuthResponse'), require('./model/AuthType'), require('./model/AzureKeyVaultType'), require('./model/BatchDecryptRequest'), require('./model/BatchDecryptRequestInner'), require('./model/BatchDecryptResponse'), require('./model/BatchDecryptResponseInner'), require('./model/BatchEncryptRequest'), require('./model/BatchEncryptRequestInner'), require('./model/BatchEncryptResponse'), require('./model/BatchEncryptResponseInner'), require('./model/BatchMacRequest'), require('./model/BatchMacResponse'), require('./model/BatchMacResponseInner'), require('./model/BatchMacVerifyRequest'), require('./model/BatchSignRequest'), require('./model/BatchSignResponse'), require('./model/BatchSignResponseInner'), require('./model/BatchVerifyRequest'), require('./model/BatchVerifyResponse'), require('./model/BatchVerifyResponseInner'), require('./model/CaConfig'), require('./model/ChildAccountUser'), require('./model/ChildAccountUserRequest'), require('./model/CipherMode'), require('./model/ConfirmEmailRequest'), require('./model/ConfirmEmailResponse'), require('./model/CreatorType'), require('./model/CryptMode'), require('./model/DecryptFinalRequest'), require('./model/DecryptFinalRequestEx'), require('./model/DecryptFinalResponse'), require('./model/DecryptInitRequest'), require('./model/DecryptInitRequestEx'), require('./model/DecryptInitResponse'), require('./model/DecryptRequest'), require('./model/DecryptRequestEx'), require('./model/DecryptResponse'), require('./model/DecryptUpdateRequest'), require('./model/DecryptUpdateRequestEx'), require('./model/DecryptUpdateResponse'), require('./model/DeriveKeyMechanism'), require('./model/DeriveKeyRequest'), require('./model/DeriveKeyRequestEx'), require('./model/DigestAlgorithm'), require('./model/DigestRequest'), require('./model/DigestResponse'), require('./model/DsaOptions'), require('./model/EllipticCurve'), require('./model/EncryptFinalRequest'), require('./model/EncryptFinalRequestEx'), require('./model/EncryptFinalResponse'), require('./model/EncryptInitRequest'), require('./model/EncryptInitRequestEx'), require('./model/EncryptInitResponse'), require('./model/EncryptRequest'), require('./model/EncryptRequestEx'), require('./model/EncryptResponse'), require('./model/EncryptUpdateRequest'), require('./model/EncryptUpdateRequestEx'), require('./model/EncryptUpdateResponse'), require('./model/Entity'), require('./model/Error'), require('./model/ExportComponentsResponse'), require('./model/ExportSobjectComponentsRequest'), require('./model/ForgotPasswordRequest'), require('./model/FpeCompoundPart'), require('./model/FpeConstraints'), require('./model/FpeConstraintsApplicabilitySubparts'), require('./model/FpeDataPart'), require('./model/FpeDate'), require('./model/FpeDateBound'), require('./model/FpeDatePart'), require('./model/FpeDateWithBounds'), require('./model/FpeEncryptedPart'), require('./model/FpeLiteralPart'), require('./model/FpeOptions'), require('./model/FpeOptionsAdvanced'), require('./model/FpeOptionsBasic'), require('./model/GoogleServiceAccountKey'), require('./model/Group'), require('./model/GroupRequest'), require('./model/HistoryItem'), require('./model/HistoryItemState'), require('./model/HmgConfig'), require('./model/HmgKind'), require('./model/IVDecryptInput'), require('./model/IVEncryptInput'), require('./model/IVEncryptOutput'), require('./model/ImportSobjectComponentsRequest'), require('./model/JWTSigningKeyType'), require('./model/KeyCheckValueResponse'), require('./model/KeyFormat'), require('./model/KeyObject'), require('./model/KeyObjectState'), require('./model/KeyOperations'), require('./model/KeyUndoPolicy'), require('./model/Language'), require('./model/LoggingConfig'), require('./model/LoggingConfigRequest'), require('./model/MacGenerateRequest'), require('./model/MacGenerateRequestEx'), require('./model/MacGenerateResponse'), require('./model/MacVerifyRequest'), require('./model/MacVerifyRequestEx'), require('./model/MacVerifyResponse'), require('./model/MfaChallenge'), require('./model/Mgf'), require('./model/MgfMgf1'), require('./model/NotificationPref'), require('./model/ObjectDigestRequest'), require('./model/ObjectOrigin'), require('./model/ObjectType'), require('./model/PasswordChangeRequest'), require('./model/PasswordResetRequest'), require('./model/PersistTransientKeyRequest'), require('./model/Plugin'), require('./model/PluginInvokeRequest'), require('./model/PluginInvokeResponse'), require('./model/PluginRequest'), require('./model/PluginSource'), require('./model/PluginType'), require('./model/ProcessInviteRequest'), require('./model/RecoveryCodes'), require('./model/RevertRequest'), require('./model/RevocationReason'), require('./model/RevocationReasonCode'), require('./model/RotationInterval'), require('./model/RotationPolicy'), require('./model/RsaEncryptionPadding'), require('./model/RsaEncryptionPaddingOAEP'), require('./model/RsaEncryptionPolicy'), require('./model/RsaEncryptionPolicyPadding'), require('./model/RsaEncryptionPolicyPaddingOAEP'), require('./model/RsaOptions'), require('./model/RsaSignaturePadding'), require('./model/RsaSignaturePaddingPSS'), require('./model/RsaSignaturePolicy'), require('./model/RsaSignaturePolicyPadding'), require('./model/ScheduleDeletionRequest'), require('./model/SelectAccountRequest'), require('./model/SelectAccountResponse'), require('./model/ServerMode'), require('./model/SignRequest'), require('./model/SignRequestEx'), require('./model/SignResponse'), require('./model/SignatureMode'), require('./model/SignupRequest'), require('./model/SobjectComponent'), require('./model/SobjectDescriptor'), require('./model/SobjectRequest'), require('./model/SplittingMethod'), require('./model/SplunkLoggingConfig'), require('./model/SplunkLoggingConfigRequest'), require('./model/StackdriverLoggingConfig'), require('./model/StackdriverLoggingConfigRequest'), require('./model/StatsResponse'), require('./model/SubscriptionChangeRequest'), require('./model/SubscriptionType'), require('./model/TagDecryptInput'), require('./model/TagEncryptOutput'), require('./model/TagLenEncryptInput'), require('./model/TlsConfig'), require('./model/TlsMode'), require('./model/U2fAddDeviceRequest'), require('./model/U2fDelDeviceRequest'), require('./model/U2fDevice'), require('./model/U2fKey'), require('./model/U2fRenameDeviceRequest'), require('./model/UnwrapKeyParams'), require('./model/UnwrapKeyRequest'), require('./model/UnwrapKeyRequestEx'), require('./model/User'), require('./model/UserAccountFlags'), require('./model/UserAccountMap'), require('./model/UserGroupFlags'), require('./model/UserGroupMap'), require('./model/UserRequest'), require('./model/UserState'), require('./model/Uuid'), require('./model/ValidateTokenRequest'), require('./model/ValidateTokenResponse'), require('./model/VerifyKcvRequest'), require('./model/VerifyKcvResponse'), require('./model/VerifyRequest'), require('./model/VerifyRequestEx'), require('./model/VerifyResponse'), require('./model/VersionResponse'), require('./model/WrapKeyParams'), require('./model/WrapKeyRequest'), require('./model/WrapKeyRequestEx'), require('./model/WrapKeyResponse'), require('./api/AWSApi'), require('./api/AccountsApi'), require('./api/ApprovalRequestsApi'), require('./api/AppsApi'), require('./api/AuthenticationApi'), require('./api/ChildAccountUsersApi'), require('./api/ChildAccountsApi'), require('./api/DigestApi'), require('./api/EncryptionAndDecryptionApi'), require('./api/GroupsApi'), require('./api/LogsApi'), require('./api/PluginsApi'), require('./api/SecurityObjectsApi'), require('./api/SignAndVerifyApi'), require('./api/StatsApi'), require('./api/TwoFactorAuthenticationApi'), require('./api/UsersApi'), require('./api/WrappingAndUnwrappingApi'));
  }
}(function(ApiClient, ADDecryptInput, ADEncryptInput, Account, AccountRequest, AccountState, AgreeKeyMechanism, AgreeKeyRequest, App, AppAuthType, AppCredential, AppCredentialResponse, AppCredentialSignedjwt, AppCredentialSignedjwtSigningKeys, AppCredentialTrustedca, AppOauthConfig, AppPermissions, AppRequest, AppResetSecretRequest, ApprovableResult, ApprovalRequest, ApprovalRequestRequest, ApprovalStatus, ApprovalSubject, ApproveRequest, AuditLogResponse, AuthConfig, AuthConfigPassword, AuthConfigSignedJWT, AuthResponse, AuthType, AzureKeyVaultType, BatchDecryptRequest, BatchDecryptRequestInner, BatchDecryptResponse, BatchDecryptResponseInner, BatchEncryptRequest, BatchEncryptRequestInner, BatchEncryptResponse, BatchEncryptResponseInner, BatchMacRequest, BatchMacResponse, BatchMacResponseInner, BatchMacVerifyRequest, BatchSignRequest, BatchSignResponse, BatchSignResponseInner, BatchVerifyRequest, BatchVerifyResponse, BatchVerifyResponseInner, CaConfig, ChildAccountUser, ChildAccountUserRequest, CipherMode, ConfirmEmailRequest, ConfirmEmailResponse, CreatorType, CryptMode, DecryptFinalRequest, DecryptFinalRequestEx, DecryptFinalResponse, DecryptInitRequest, DecryptInitRequestEx, DecryptInitResponse, DecryptRequest, DecryptRequestEx, DecryptResponse, DecryptUpdateRequest, DecryptUpdateRequestEx, DecryptUpdateResponse, DeriveKeyMechanism, DeriveKeyRequest, DeriveKeyRequestEx, DigestAlgorithm, DigestRequest, DigestResponse, DsaOptions, EllipticCurve, EncryptFinalRequest, EncryptFinalRequestEx, EncryptFinalResponse, EncryptInitRequest, EncryptInitRequestEx, EncryptInitResponse, EncryptRequest, EncryptRequestEx, EncryptResponse, EncryptUpdateRequest, EncryptUpdateRequestEx, EncryptUpdateResponse, Entity, Error, ExportComponentsResponse, ExportSobjectComponentsRequest, ForgotPasswordRequest, FpeCompoundPart, FpeConstraints, FpeConstraintsApplicabilitySubparts, FpeDataPart, FpeDate, FpeDateBound, FpeDatePart, FpeDateWithBounds, FpeEncryptedPart, FpeLiteralPart, FpeOptions, FpeOptionsAdvanced, FpeOptionsBasic, GoogleServiceAccountKey, Group, GroupRequest, HistoryItem, HistoryItemState, HmgConfig, HmgKind, IVDecryptInput, IVEncryptInput, IVEncryptOutput, ImportSobjectComponentsRequest, JWTSigningKeyType, KeyCheckValueResponse, KeyFormat, KeyObject, KeyObjectState, KeyOperations, KeyUndoPolicy, Language, LoggingConfig, LoggingConfigRequest, MacGenerateRequest, MacGenerateRequestEx, MacGenerateResponse, MacVerifyRequest, MacVerifyRequestEx, MacVerifyResponse, MfaChallenge, Mgf, MgfMgf1, NotificationPref, ObjectDigestRequest, ObjectOrigin, ObjectType, PasswordChangeRequest, PasswordResetRequest, PersistTransientKeyRequest, Plugin, PluginInvokeRequest, PluginInvokeResponse, PluginRequest, PluginSource, PluginType, ProcessInviteRequest, RecoveryCodes, RevertRequest, RevocationReason, RevocationReasonCode, RotationInterval, RotationPolicy, RsaEncryptionPadding, RsaEncryptionPaddingOAEP, RsaEncryptionPolicy, RsaEncryptionPolicyPadding, RsaEncryptionPolicyPaddingOAEP, RsaOptions, RsaSignaturePadding, RsaSignaturePaddingPSS, RsaSignaturePolicy, RsaSignaturePolicyPadding, ScheduleDeletionRequest, SelectAccountRequest, SelectAccountResponse, ServerMode, SignRequest, SignRequestEx, SignResponse, SignatureMode, SignupRequest, SobjectComponent, SobjectDescriptor, SobjectRequest, SplittingMethod, SplunkLoggingConfig, SplunkLoggingConfigRequest, StackdriverLoggingConfig, StackdriverLoggingConfigRequest, StatsResponse, SubscriptionChangeRequest, SubscriptionType, TagDecryptInput, TagEncryptOutput, TagLenEncryptInput, TlsConfig, TlsMode, U2fAddDeviceRequest, U2fDelDeviceRequest, U2fDevice, U2fKey, U2fRenameDeviceRequest, UnwrapKeyParams, UnwrapKeyRequest, UnwrapKeyRequestEx, User, UserAccountFlags, UserAccountMap, UserGroupFlags, UserGroupMap, UserRequest, UserState, Uuid, ValidateTokenRequest, ValidateTokenResponse, VerifyKcvRequest, VerifyKcvResponse, VerifyRequest, VerifyRequestEx, VerifyResponse, VersionResponse, WrapKeyParams, WrapKeyRequest, WrapKeyRequestEx, WrapKeyResponse, AWSApi, AccountsApi, ApprovalRequestsApi, AppsApi, AuthenticationApi, ChildAccountUsersApi, ChildAccountsApi, DigestApi, EncryptionAndDecryptionApi, GroupsApi, LogsApi, PluginsApi, SecurityObjectsApi, SignAndVerifyApi, StatsApi, TwoFactorAuthenticationApi, UsersApi, WrappingAndUnwrappingApi) {
  'use strict';

  /**
   * This_is_a_set_of_REST_APIs_for_accessing_the_Fortanix_Self_Defending_Key_Management_System__This_includes_APIs_for_managing_accounts_and_for_performing_cryptographic_and_key_management_operations_.<br>
   * The <code>index</code> module provides access to constructors for all the classes which comprise the public API.
   * <p>
   * An AMD (recommended!) or CommonJS application will generally do something equivalent to the following:
   * <pre>
   * var FortanixSdkmsRestApi = require('index'); // See note below*.
   * var xxxSvc = new FortanixSdkmsRestApi.XxxApi(); // Allocate the API class we're going to use.
   * var yyyModel = new FortanixSdkmsRestApi.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * <em>*NOTE: For a top-level AMD script, use require(['index'], function(){...})
   * and put the application logic within the callback function.</em>
   * </p>
   * <p>
   * A non-AMD browser application (discouraged) might do something like this:
   * <pre>
   * var xxxSvc = new FortanixSdkmsRestApi.XxxApi(); // Allocate the API class we're going to use.
   * var yyy = new FortanixSdkmsRestApi.Yyy(); // Construct a model instance.
   * yyyModel.someProperty = 'someValue';
   * ...
   * var zzz = xxxSvc.doSomething(yyyModel); // Invoke the service.
   * ...
   * </pre>
   * </p>
   * @module index
   * @version 1.0.0-20200608
   */
  var exports = {
    /**
     * The ApiClient constructor.
     * @property {module:ApiClient}
     */
    ApiClient: ApiClient,
    /**
     * The ADDecryptInput model constructor.
     * @property {module:model/ADDecryptInput}
     */
    ADDecryptInput: ADDecryptInput,
    /**
     * The ADEncryptInput model constructor.
     * @property {module:model/ADEncryptInput}
     */
    ADEncryptInput: ADEncryptInput,
    /**
     * The Account model constructor.
     * @property {module:model/Account}
     */
    Account: Account,
    /**
     * The AccountRequest model constructor.
     * @property {module:model/AccountRequest}
     */
    AccountRequest: AccountRequest,
    /**
     * The AccountState model constructor.
     * @property {module:model/AccountState}
     */
    AccountState: AccountState,
    /**
     * The AgreeKeyMechanism model constructor.
     * @property {module:model/AgreeKeyMechanism}
     */
    AgreeKeyMechanism: AgreeKeyMechanism,
    /**
     * The AgreeKeyRequest model constructor.
     * @property {module:model/AgreeKeyRequest}
     */
    AgreeKeyRequest: AgreeKeyRequest,
    /**
     * The App model constructor.
     * @property {module:model/App}
     */
    App: App,
    /**
     * The AppAuthType model constructor.
     * @property {module:model/AppAuthType}
     */
    AppAuthType: AppAuthType,
    /**
     * The AppCredential model constructor.
     * @property {module:model/AppCredential}
     */
    AppCredential: AppCredential,
    /**
     * The AppCredentialResponse model constructor.
     * @property {module:model/AppCredentialResponse}
     */
    AppCredentialResponse: AppCredentialResponse,
    /**
     * The AppCredentialSignedjwt model constructor.
     * @property {module:model/AppCredentialSignedjwt}
     */
    AppCredentialSignedjwt: AppCredentialSignedjwt,
    /**
     * The AppCredentialSignedjwtSigningKeys model constructor.
     * @property {module:model/AppCredentialSignedjwtSigningKeys}
     */
    AppCredentialSignedjwtSigningKeys: AppCredentialSignedjwtSigningKeys,
    /**
     * The AppCredentialTrustedca model constructor.
     * @property {module:model/AppCredentialTrustedca}
     */
    AppCredentialTrustedca: AppCredentialTrustedca,
    /**
     * The AppOauthConfig model constructor.
     * @property {module:model/AppOauthConfig}
     */
    AppOauthConfig: AppOauthConfig,
    /**
     * The AppPermissions model constructor.
     * @property {module:model/AppPermissions}
     */
    AppPermissions: AppPermissions,
    /**
     * The AppRequest model constructor.
     * @property {module:model/AppRequest}
     */
    AppRequest: AppRequest,
    /**
     * The AppResetSecretRequest model constructor.
     * @property {module:model/AppResetSecretRequest}
     */
    AppResetSecretRequest: AppResetSecretRequest,
    /**
     * The ApprovableResult model constructor.
     * @property {module:model/ApprovableResult}
     */
    ApprovableResult: ApprovableResult,
    /**
     * The ApprovalRequest model constructor.
     * @property {module:model/ApprovalRequest}
     */
    ApprovalRequest: ApprovalRequest,
    /**
     * The ApprovalRequestRequest model constructor.
     * @property {module:model/ApprovalRequestRequest}
     */
    ApprovalRequestRequest: ApprovalRequestRequest,
    /**
     * The ApprovalStatus model constructor.
     * @property {module:model/ApprovalStatus}
     */
    ApprovalStatus: ApprovalStatus,
    /**
     * The ApprovalSubject model constructor.
     * @property {module:model/ApprovalSubject}
     */
    ApprovalSubject: ApprovalSubject,
    /**
     * The ApproveRequest model constructor.
     * @property {module:model/ApproveRequest}
     */
    ApproveRequest: ApproveRequest,
    /**
     * The AuditLogResponse model constructor.
     * @property {module:model/AuditLogResponse}
     */
    AuditLogResponse: AuditLogResponse,
    /**
     * The AuthConfig model constructor.
     * @property {module:model/AuthConfig}
     */
    AuthConfig: AuthConfig,
    /**
     * The AuthConfigPassword model constructor.
     * @property {module:model/AuthConfigPassword}
     */
    AuthConfigPassword: AuthConfigPassword,
    /**
     * The AuthConfigSignedJWT model constructor.
     * @property {module:model/AuthConfigSignedJWT}
     */
    AuthConfigSignedJWT: AuthConfigSignedJWT,
    /**
     * The AuthResponse model constructor.
     * @property {module:model/AuthResponse}
     */
    AuthResponse: AuthResponse,
    /**
     * The AuthType model constructor.
     * @property {module:model/AuthType}
     */
    AuthType: AuthType,
    /**
     * The AzureKeyVaultType model constructor.
     * @property {module:model/AzureKeyVaultType}
     */
    AzureKeyVaultType: AzureKeyVaultType,
    /**
     * The BatchDecryptRequest model constructor.
     * @property {module:model/BatchDecryptRequest}
     */
    BatchDecryptRequest: BatchDecryptRequest,
    /**
     * The BatchDecryptRequestInner model constructor.
     * @property {module:model/BatchDecryptRequestInner}
     */
    BatchDecryptRequestInner: BatchDecryptRequestInner,
    /**
     * The BatchDecryptResponse model constructor.
     * @property {module:model/BatchDecryptResponse}
     */
    BatchDecryptResponse: BatchDecryptResponse,
    /**
     * The BatchDecryptResponseInner model constructor.
     * @property {module:model/BatchDecryptResponseInner}
     */
    BatchDecryptResponseInner: BatchDecryptResponseInner,
    /**
     * The BatchEncryptRequest model constructor.
     * @property {module:model/BatchEncryptRequest}
     */
    BatchEncryptRequest: BatchEncryptRequest,
    /**
     * The BatchEncryptRequestInner model constructor.
     * @property {module:model/BatchEncryptRequestInner}
     */
    BatchEncryptRequestInner: BatchEncryptRequestInner,
    /**
     * The BatchEncryptResponse model constructor.
     * @property {module:model/BatchEncryptResponse}
     */
    BatchEncryptResponse: BatchEncryptResponse,
    /**
     * The BatchEncryptResponseInner model constructor.
     * @property {module:model/BatchEncryptResponseInner}
     */
    BatchEncryptResponseInner: BatchEncryptResponseInner,
    /**
     * The BatchMacRequest model constructor.
     * @property {module:model/BatchMacRequest}
     */
    BatchMacRequest: BatchMacRequest,
    /**
     * The BatchMacResponse model constructor.
     * @property {module:model/BatchMacResponse}
     */
    BatchMacResponse: BatchMacResponse,
    /**
     * The BatchMacResponseInner model constructor.
     * @property {module:model/BatchMacResponseInner}
     */
    BatchMacResponseInner: BatchMacResponseInner,
    /**
     * The BatchMacVerifyRequest model constructor.
     * @property {module:model/BatchMacVerifyRequest}
     */
    BatchMacVerifyRequest: BatchMacVerifyRequest,
    /**
     * The BatchSignRequest model constructor.
     * @property {module:model/BatchSignRequest}
     */
    BatchSignRequest: BatchSignRequest,
    /**
     * The BatchSignResponse model constructor.
     * @property {module:model/BatchSignResponse}
     */
    BatchSignResponse: BatchSignResponse,
    /**
     * The BatchSignResponseInner model constructor.
     * @property {module:model/BatchSignResponseInner}
     */
    BatchSignResponseInner: BatchSignResponseInner,
    /**
     * The BatchVerifyRequest model constructor.
     * @property {module:model/BatchVerifyRequest}
     */
    BatchVerifyRequest: BatchVerifyRequest,
    /**
     * The BatchVerifyResponse model constructor.
     * @property {module:model/BatchVerifyResponse}
     */
    BatchVerifyResponse: BatchVerifyResponse,
    /**
     * The BatchVerifyResponseInner model constructor.
     * @property {module:model/BatchVerifyResponseInner}
     */
    BatchVerifyResponseInner: BatchVerifyResponseInner,
    /**
     * The CaConfig model constructor.
     * @property {module:model/CaConfig}
     */
    CaConfig: CaConfig,
    /**
     * The ChildAccountUser model constructor.
     * @property {module:model/ChildAccountUser}
     */
    ChildAccountUser: ChildAccountUser,
    /**
     * The ChildAccountUserRequest model constructor.
     * @property {module:model/ChildAccountUserRequest}
     */
    ChildAccountUserRequest: ChildAccountUserRequest,
    /**
     * The CipherMode model constructor.
     * @property {module:model/CipherMode}
     */
    CipherMode: CipherMode,
    /**
     * The ConfirmEmailRequest model constructor.
     * @property {module:model/ConfirmEmailRequest}
     */
    ConfirmEmailRequest: ConfirmEmailRequest,
    /**
     * The ConfirmEmailResponse model constructor.
     * @property {module:model/ConfirmEmailResponse}
     */
    ConfirmEmailResponse: ConfirmEmailResponse,
    /**
     * The CreatorType model constructor.
     * @property {module:model/CreatorType}
     */
    CreatorType: CreatorType,
    /**
     * The CryptMode model constructor.
     * @property {module:model/CryptMode}
     */
    CryptMode: CryptMode,
    /**
     * The DecryptFinalRequest model constructor.
     * @property {module:model/DecryptFinalRequest}
     */
    DecryptFinalRequest: DecryptFinalRequest,
    /**
     * The DecryptFinalRequestEx model constructor.
     * @property {module:model/DecryptFinalRequestEx}
     */
    DecryptFinalRequestEx: DecryptFinalRequestEx,
    /**
     * The DecryptFinalResponse model constructor.
     * @property {module:model/DecryptFinalResponse}
     */
    DecryptFinalResponse: DecryptFinalResponse,
    /**
     * The DecryptInitRequest model constructor.
     * @property {module:model/DecryptInitRequest}
     */
    DecryptInitRequest: DecryptInitRequest,
    /**
     * The DecryptInitRequestEx model constructor.
     * @property {module:model/DecryptInitRequestEx}
     */
    DecryptInitRequestEx: DecryptInitRequestEx,
    /**
     * The DecryptInitResponse model constructor.
     * @property {module:model/DecryptInitResponse}
     */
    DecryptInitResponse: DecryptInitResponse,
    /**
     * The DecryptRequest model constructor.
     * @property {module:model/DecryptRequest}
     */
    DecryptRequest: DecryptRequest,
    /**
     * The DecryptRequestEx model constructor.
     * @property {module:model/DecryptRequestEx}
     */
    DecryptRequestEx: DecryptRequestEx,
    /**
     * The DecryptResponse model constructor.
     * @property {module:model/DecryptResponse}
     */
    DecryptResponse: DecryptResponse,
    /**
     * The DecryptUpdateRequest model constructor.
     * @property {module:model/DecryptUpdateRequest}
     */
    DecryptUpdateRequest: DecryptUpdateRequest,
    /**
     * The DecryptUpdateRequestEx model constructor.
     * @property {module:model/DecryptUpdateRequestEx}
     */
    DecryptUpdateRequestEx: DecryptUpdateRequestEx,
    /**
     * The DecryptUpdateResponse model constructor.
     * @property {module:model/DecryptUpdateResponse}
     */
    DecryptUpdateResponse: DecryptUpdateResponse,
    /**
     * The DeriveKeyMechanism model constructor.
     * @property {module:model/DeriveKeyMechanism}
     */
    DeriveKeyMechanism: DeriveKeyMechanism,
    /**
     * The DeriveKeyRequest model constructor.
     * @property {module:model/DeriveKeyRequest}
     */
    DeriveKeyRequest: DeriveKeyRequest,
    /**
     * The DeriveKeyRequestEx model constructor.
     * @property {module:model/DeriveKeyRequestEx}
     */
    DeriveKeyRequestEx: DeriveKeyRequestEx,
    /**
     * The DigestAlgorithm model constructor.
     * @property {module:model/DigestAlgorithm}
     */
    DigestAlgorithm: DigestAlgorithm,
    /**
     * The DigestRequest model constructor.
     * @property {module:model/DigestRequest}
     */
    DigestRequest: DigestRequest,
    /**
     * The DigestResponse model constructor.
     * @property {module:model/DigestResponse}
     */
    DigestResponse: DigestResponse,
    /**
     * The DsaOptions model constructor.
     * @property {module:model/DsaOptions}
     */
    DsaOptions: DsaOptions,
    /**
     * The EllipticCurve model constructor.
     * @property {module:model/EllipticCurve}
     */
    EllipticCurve: EllipticCurve,
    /**
     * The EncryptFinalRequest model constructor.
     * @property {module:model/EncryptFinalRequest}
     */
    EncryptFinalRequest: EncryptFinalRequest,
    /**
     * The EncryptFinalRequestEx model constructor.
     * @property {module:model/EncryptFinalRequestEx}
     */
    EncryptFinalRequestEx: EncryptFinalRequestEx,
    /**
     * The EncryptFinalResponse model constructor.
     * @property {module:model/EncryptFinalResponse}
     */
    EncryptFinalResponse: EncryptFinalResponse,
    /**
     * The EncryptInitRequest model constructor.
     * @property {module:model/EncryptInitRequest}
     */
    EncryptInitRequest: EncryptInitRequest,
    /**
     * The EncryptInitRequestEx model constructor.
     * @property {module:model/EncryptInitRequestEx}
     */
    EncryptInitRequestEx: EncryptInitRequestEx,
    /**
     * The EncryptInitResponse model constructor.
     * @property {module:model/EncryptInitResponse}
     */
    EncryptInitResponse: EncryptInitResponse,
    /**
     * The EncryptRequest model constructor.
     * @property {module:model/EncryptRequest}
     */
    EncryptRequest: EncryptRequest,
    /**
     * The EncryptRequestEx model constructor.
     * @property {module:model/EncryptRequestEx}
     */
    EncryptRequestEx: EncryptRequestEx,
    /**
     * The EncryptResponse model constructor.
     * @property {module:model/EncryptResponse}
     */
    EncryptResponse: EncryptResponse,
    /**
     * The EncryptUpdateRequest model constructor.
     * @property {module:model/EncryptUpdateRequest}
     */
    EncryptUpdateRequest: EncryptUpdateRequest,
    /**
     * The EncryptUpdateRequestEx model constructor.
     * @property {module:model/EncryptUpdateRequestEx}
     */
    EncryptUpdateRequestEx: EncryptUpdateRequestEx,
    /**
     * The EncryptUpdateResponse model constructor.
     * @property {module:model/EncryptUpdateResponse}
     */
    EncryptUpdateResponse: EncryptUpdateResponse,
    /**
     * The Entity model constructor.
     * @property {module:model/Entity}
     */
    Entity: Entity,
    /**
     * The Error model constructor.
     * @property {module:model/Error}
     */
    Error: Error,
    /**
     * The ExportComponentsResponse model constructor.
     * @property {module:model/ExportComponentsResponse}
     */
    ExportComponentsResponse: ExportComponentsResponse,
    /**
     * The ExportSobjectComponentsRequest model constructor.
     * @property {module:model/ExportSobjectComponentsRequest}
     */
    ExportSobjectComponentsRequest: ExportSobjectComponentsRequest,
    /**
     * The ForgotPasswordRequest model constructor.
     * @property {module:model/ForgotPasswordRequest}
     */
    ForgotPasswordRequest: ForgotPasswordRequest,
    /**
     * The FpeCompoundPart model constructor.
     * @property {module:model/FpeCompoundPart}
     */
    FpeCompoundPart: FpeCompoundPart,
    /**
     * The FpeConstraints model constructor.
     * @property {module:model/FpeConstraints}
     */
    FpeConstraints: FpeConstraints,
    /**
     * The FpeConstraintsApplicabilitySubparts model constructor.
     * @property {module:model/FpeConstraintsApplicabilitySubparts}
     */
    FpeConstraintsApplicabilitySubparts: FpeConstraintsApplicabilitySubparts,
    /**
     * The FpeDataPart model constructor.
     * @property {module:model/FpeDataPart}
     */
    FpeDataPart: FpeDataPart,
    /**
     * The FpeDate model constructor.
     * @property {module:model/FpeDate}
     */
    FpeDate: FpeDate,
    /**
     * The FpeDateBound model constructor.
     * @property {module:model/FpeDateBound}
     */
    FpeDateBound: FpeDateBound,
    /**
     * The FpeDatePart model constructor.
     * @property {module:model/FpeDatePart}
     */
    FpeDatePart: FpeDatePart,
    /**
     * The FpeDateWithBounds model constructor.
     * @property {module:model/FpeDateWithBounds}
     */
    FpeDateWithBounds: FpeDateWithBounds,
    /**
     * The FpeEncryptedPart model constructor.
     * @property {module:model/FpeEncryptedPart}
     */
    FpeEncryptedPart: FpeEncryptedPart,
    /**
     * The FpeLiteralPart model constructor.
     * @property {module:model/FpeLiteralPart}
     */
    FpeLiteralPart: FpeLiteralPart,
    /**
     * The FpeOptions model constructor.
     * @property {module:model/FpeOptions}
     */
    FpeOptions: FpeOptions,
    /**
     * The FpeOptionsAdvanced model constructor.
     * @property {module:model/FpeOptionsAdvanced}
     */
    FpeOptionsAdvanced: FpeOptionsAdvanced,
    /**
     * The FpeOptionsBasic model constructor.
     * @property {module:model/FpeOptionsBasic}
     */
    FpeOptionsBasic: FpeOptionsBasic,
    /**
     * The GoogleServiceAccountKey model constructor.
     * @property {module:model/GoogleServiceAccountKey}
     */
    GoogleServiceAccountKey: GoogleServiceAccountKey,
    /**
     * The Group model constructor.
     * @property {module:model/Group}
     */
    Group: Group,
    /**
     * The GroupRequest model constructor.
     * @property {module:model/GroupRequest}
     */
    GroupRequest: GroupRequest,
    /**
     * The HistoryItem model constructor.
     * @property {module:model/HistoryItem}
     */
    HistoryItem: HistoryItem,
    /**
     * The HistoryItemState model constructor.
     * @property {module:model/HistoryItemState}
     */
    HistoryItemState: HistoryItemState,
    /**
     * The HmgConfig model constructor.
     * @property {module:model/HmgConfig}
     */
    HmgConfig: HmgConfig,
    /**
     * The HmgKind model constructor.
     * @property {module:model/HmgKind}
     */
    HmgKind: HmgKind,
    /**
     * The IVDecryptInput model constructor.
     * @property {module:model/IVDecryptInput}
     */
    IVDecryptInput: IVDecryptInput,
    /**
     * The IVEncryptInput model constructor.
     * @property {module:model/IVEncryptInput}
     */
    IVEncryptInput: IVEncryptInput,
    /**
     * The IVEncryptOutput model constructor.
     * @property {module:model/IVEncryptOutput}
     */
    IVEncryptOutput: IVEncryptOutput,
    /**
     * The ImportSobjectComponentsRequest model constructor.
     * @property {module:model/ImportSobjectComponentsRequest}
     */
    ImportSobjectComponentsRequest: ImportSobjectComponentsRequest,
    /**
     * The JWTSigningKeyType model constructor.
     * @property {module:model/JWTSigningKeyType}
     */
    JWTSigningKeyType: JWTSigningKeyType,
    /**
     * The KeyCheckValueResponse model constructor.
     * @property {module:model/KeyCheckValueResponse}
     */
    KeyCheckValueResponse: KeyCheckValueResponse,
    /**
     * The KeyFormat model constructor.
     * @property {module:model/KeyFormat}
     */
    KeyFormat: KeyFormat,
    /**
     * The KeyObject model constructor.
     * @property {module:model/KeyObject}
     */
    KeyObject: KeyObject,
    /**
     * The KeyObjectState model constructor.
     * @property {module:model/KeyObjectState}
     */
    KeyObjectState: KeyObjectState,
    /**
     * The KeyOperations model constructor.
     * @property {module:model/KeyOperations}
     */
    KeyOperations: KeyOperations,
    /**
     * The KeyUndoPolicy model constructor.
     * @property {module:model/KeyUndoPolicy}
     */
    KeyUndoPolicy: KeyUndoPolicy,
    /**
     * The Language model constructor.
     * @property {module:model/Language}
     */
    Language: Language,
    /**
     * The LoggingConfig model constructor.
     * @property {module:model/LoggingConfig}
     */
    LoggingConfig: LoggingConfig,
    /**
     * The LoggingConfigRequest model constructor.
     * @property {module:model/LoggingConfigRequest}
     */
    LoggingConfigRequest: LoggingConfigRequest,
    /**
     * The MacGenerateRequest model constructor.
     * @property {module:model/MacGenerateRequest}
     */
    MacGenerateRequest: MacGenerateRequest,
    /**
     * The MacGenerateRequestEx model constructor.
     * @property {module:model/MacGenerateRequestEx}
     */
    MacGenerateRequestEx: MacGenerateRequestEx,
    /**
     * The MacGenerateResponse model constructor.
     * @property {module:model/MacGenerateResponse}
     */
    MacGenerateResponse: MacGenerateResponse,
    /**
     * The MacVerifyRequest model constructor.
     * @property {module:model/MacVerifyRequest}
     */
    MacVerifyRequest: MacVerifyRequest,
    /**
     * The MacVerifyRequestEx model constructor.
     * @property {module:model/MacVerifyRequestEx}
     */
    MacVerifyRequestEx: MacVerifyRequestEx,
    /**
     * The MacVerifyResponse model constructor.
     * @property {module:model/MacVerifyResponse}
     */
    MacVerifyResponse: MacVerifyResponse,
    /**
     * The MfaChallenge model constructor.
     * @property {module:model/MfaChallenge}
     */
    MfaChallenge: MfaChallenge,
    /**
     * The Mgf model constructor.
     * @property {module:model/Mgf}
     */
    Mgf: Mgf,
    /**
     * The MgfMgf1 model constructor.
     * @property {module:model/MgfMgf1}
     */
    MgfMgf1: MgfMgf1,
    /**
     * The NotificationPref model constructor.
     * @property {module:model/NotificationPref}
     */
    NotificationPref: NotificationPref,
    /**
     * The ObjectDigestRequest model constructor.
     * @property {module:model/ObjectDigestRequest}
     */
    ObjectDigestRequest: ObjectDigestRequest,
    /**
     * The ObjectOrigin model constructor.
     * @property {module:model/ObjectOrigin}
     */
    ObjectOrigin: ObjectOrigin,
    /**
     * The ObjectType model constructor.
     * @property {module:model/ObjectType}
     */
    ObjectType: ObjectType,
    /**
     * The PasswordChangeRequest model constructor.
     * @property {module:model/PasswordChangeRequest}
     */
    PasswordChangeRequest: PasswordChangeRequest,
    /**
     * The PasswordResetRequest model constructor.
     * @property {module:model/PasswordResetRequest}
     */
    PasswordResetRequest: PasswordResetRequest,
    /**
     * The PersistTransientKeyRequest model constructor.
     * @property {module:model/PersistTransientKeyRequest}
     */
    PersistTransientKeyRequest: PersistTransientKeyRequest,
    /**
     * The Plugin model constructor.
     * @property {module:model/Plugin}
     */
    Plugin: Plugin,
    /**
     * The PluginInvokeRequest model constructor.
     * @property {module:model/PluginInvokeRequest}
     */
    PluginInvokeRequest: PluginInvokeRequest,
    /**
     * The PluginInvokeResponse model constructor.
     * @property {module:model/PluginInvokeResponse}
     */
    PluginInvokeResponse: PluginInvokeResponse,
    /**
     * The PluginRequest model constructor.
     * @property {module:model/PluginRequest}
     */
    PluginRequest: PluginRequest,
    /**
     * The PluginSource model constructor.
     * @property {module:model/PluginSource}
     */
    PluginSource: PluginSource,
    /**
     * The PluginType model constructor.
     * @property {module:model/PluginType}
     */
    PluginType: PluginType,
    /**
     * The ProcessInviteRequest model constructor.
     * @property {module:model/ProcessInviteRequest}
     */
    ProcessInviteRequest: ProcessInviteRequest,
    /**
     * The RecoveryCodes model constructor.
     * @property {module:model/RecoveryCodes}
     */
    RecoveryCodes: RecoveryCodes,
    /**
     * The RevertRequest model constructor.
     * @property {module:model/RevertRequest}
     */
    RevertRequest: RevertRequest,
    /**
     * The RevocationReason model constructor.
     * @property {module:model/RevocationReason}
     */
    RevocationReason: RevocationReason,
    /**
     * The RevocationReasonCode model constructor.
     * @property {module:model/RevocationReasonCode}
     */
    RevocationReasonCode: RevocationReasonCode,
    /**
     * The RotationInterval model constructor.
     * @property {module:model/RotationInterval}
     */
    RotationInterval: RotationInterval,
    /**
     * The RotationPolicy model constructor.
     * @property {module:model/RotationPolicy}
     */
    RotationPolicy: RotationPolicy,
    /**
     * The RsaEncryptionPadding model constructor.
     * @property {module:model/RsaEncryptionPadding}
     */
    RsaEncryptionPadding: RsaEncryptionPadding,
    /**
     * The RsaEncryptionPaddingOAEP model constructor.
     * @property {module:model/RsaEncryptionPaddingOAEP}
     */
    RsaEncryptionPaddingOAEP: RsaEncryptionPaddingOAEP,
    /**
     * The RsaEncryptionPolicy model constructor.
     * @property {module:model/RsaEncryptionPolicy}
     */
    RsaEncryptionPolicy: RsaEncryptionPolicy,
    /**
     * The RsaEncryptionPolicyPadding model constructor.
     * @property {module:model/RsaEncryptionPolicyPadding}
     */
    RsaEncryptionPolicyPadding: RsaEncryptionPolicyPadding,
    /**
     * The RsaEncryptionPolicyPaddingOAEP model constructor.
     * @property {module:model/RsaEncryptionPolicyPaddingOAEP}
     */
    RsaEncryptionPolicyPaddingOAEP: RsaEncryptionPolicyPaddingOAEP,
    /**
     * The RsaOptions model constructor.
     * @property {module:model/RsaOptions}
     */
    RsaOptions: RsaOptions,
    /**
     * The RsaSignaturePadding model constructor.
     * @property {module:model/RsaSignaturePadding}
     */
    RsaSignaturePadding: RsaSignaturePadding,
    /**
     * The RsaSignaturePaddingPSS model constructor.
     * @property {module:model/RsaSignaturePaddingPSS}
     */
    RsaSignaturePaddingPSS: RsaSignaturePaddingPSS,
    /**
     * The RsaSignaturePolicy model constructor.
     * @property {module:model/RsaSignaturePolicy}
     */
    RsaSignaturePolicy: RsaSignaturePolicy,
    /**
     * The RsaSignaturePolicyPadding model constructor.
     * @property {module:model/RsaSignaturePolicyPadding}
     */
    RsaSignaturePolicyPadding: RsaSignaturePolicyPadding,
    /**
     * The ScheduleDeletionRequest model constructor.
     * @property {module:model/ScheduleDeletionRequest}
     */
    ScheduleDeletionRequest: ScheduleDeletionRequest,
    /**
     * The SelectAccountRequest model constructor.
     * @property {module:model/SelectAccountRequest}
     */
    SelectAccountRequest: SelectAccountRequest,
    /**
     * The SelectAccountResponse model constructor.
     * @property {module:model/SelectAccountResponse}
     */
    SelectAccountResponse: SelectAccountResponse,
    /**
     * The ServerMode model constructor.
     * @property {module:model/ServerMode}
     */
    ServerMode: ServerMode,
    /**
     * The SignRequest model constructor.
     * @property {module:model/SignRequest}
     */
    SignRequest: SignRequest,
    /**
     * The SignRequestEx model constructor.
     * @property {module:model/SignRequestEx}
     */
    SignRequestEx: SignRequestEx,
    /**
     * The SignResponse model constructor.
     * @property {module:model/SignResponse}
     */
    SignResponse: SignResponse,
    /**
     * The SignatureMode model constructor.
     * @property {module:model/SignatureMode}
     */
    SignatureMode: SignatureMode,
    /**
     * The SignupRequest model constructor.
     * @property {module:model/SignupRequest}
     */
    SignupRequest: SignupRequest,
    /**
     * The SobjectComponent model constructor.
     * @property {module:model/SobjectComponent}
     */
    SobjectComponent: SobjectComponent,
    /**
     * The SobjectDescriptor model constructor.
     * @property {module:model/SobjectDescriptor}
     */
    SobjectDescriptor: SobjectDescriptor,
    /**
     * The SobjectRequest model constructor.
     * @property {module:model/SobjectRequest}
     */
    SobjectRequest: SobjectRequest,
    /**
     * The SplittingMethod model constructor.
     * @property {module:model/SplittingMethod}
     */
    SplittingMethod: SplittingMethod,
    /**
     * The SplunkLoggingConfig model constructor.
     * @property {module:model/SplunkLoggingConfig}
     */
    SplunkLoggingConfig: SplunkLoggingConfig,
    /**
     * The SplunkLoggingConfigRequest model constructor.
     * @property {module:model/SplunkLoggingConfigRequest}
     */
    SplunkLoggingConfigRequest: SplunkLoggingConfigRequest,
    /**
     * The StackdriverLoggingConfig model constructor.
     * @property {module:model/StackdriverLoggingConfig}
     */
    StackdriverLoggingConfig: StackdriverLoggingConfig,
    /**
     * The StackdriverLoggingConfigRequest model constructor.
     * @property {module:model/StackdriverLoggingConfigRequest}
     */
    StackdriverLoggingConfigRequest: StackdriverLoggingConfigRequest,
    /**
     * The StatsResponse model constructor.
     * @property {module:model/StatsResponse}
     */
    StatsResponse: StatsResponse,
    /**
     * The SubscriptionChangeRequest model constructor.
     * @property {module:model/SubscriptionChangeRequest}
     */
    SubscriptionChangeRequest: SubscriptionChangeRequest,
    /**
     * The SubscriptionType model constructor.
     * @property {module:model/SubscriptionType}
     */
    SubscriptionType: SubscriptionType,
    /**
     * The TagDecryptInput model constructor.
     * @property {module:model/TagDecryptInput}
     */
    TagDecryptInput: TagDecryptInput,
    /**
     * The TagEncryptOutput model constructor.
     * @property {module:model/TagEncryptOutput}
     */
    TagEncryptOutput: TagEncryptOutput,
    /**
     * The TagLenEncryptInput model constructor.
     * @property {module:model/TagLenEncryptInput}
     */
    TagLenEncryptInput: TagLenEncryptInput,
    /**
     * The TlsConfig model constructor.
     * @property {module:model/TlsConfig}
     */
    TlsConfig: TlsConfig,
    /**
     * The TlsMode model constructor.
     * @property {module:model/TlsMode}
     */
    TlsMode: TlsMode,
    /**
     * The U2fAddDeviceRequest model constructor.
     * @property {module:model/U2fAddDeviceRequest}
     */
    U2fAddDeviceRequest: U2fAddDeviceRequest,
    /**
     * The U2fDelDeviceRequest model constructor.
     * @property {module:model/U2fDelDeviceRequest}
     */
    U2fDelDeviceRequest: U2fDelDeviceRequest,
    /**
     * The U2fDevice model constructor.
     * @property {module:model/U2fDevice}
     */
    U2fDevice: U2fDevice,
    /**
     * The U2fKey model constructor.
     * @property {module:model/U2fKey}
     */
    U2fKey: U2fKey,
    /**
     * The U2fRenameDeviceRequest model constructor.
     * @property {module:model/U2fRenameDeviceRequest}
     */
    U2fRenameDeviceRequest: U2fRenameDeviceRequest,
    /**
     * The UnwrapKeyParams model constructor.
     * @property {module:model/UnwrapKeyParams}
     */
    UnwrapKeyParams: UnwrapKeyParams,
    /**
     * The UnwrapKeyRequest model constructor.
     * @property {module:model/UnwrapKeyRequest}
     */
    UnwrapKeyRequest: UnwrapKeyRequest,
    /**
     * The UnwrapKeyRequestEx model constructor.
     * @property {module:model/UnwrapKeyRequestEx}
     */
    UnwrapKeyRequestEx: UnwrapKeyRequestEx,
    /**
     * The User model constructor.
     * @property {module:model/User}
     */
    User: User,
    /**
     * The UserAccountFlags model constructor.
     * @property {module:model/UserAccountFlags}
     */
    UserAccountFlags: UserAccountFlags,
    /**
     * The UserAccountMap model constructor.
     * @property {module:model/UserAccountMap}
     */
    UserAccountMap: UserAccountMap,
    /**
     * The UserGroupFlags model constructor.
     * @property {module:model/UserGroupFlags}
     */
    UserGroupFlags: UserGroupFlags,
    /**
     * The UserGroupMap model constructor.
     * @property {module:model/UserGroupMap}
     */
    UserGroupMap: UserGroupMap,
    /**
     * The UserRequest model constructor.
     * @property {module:model/UserRequest}
     */
    UserRequest: UserRequest,
    /**
     * The UserState model constructor.
     * @property {module:model/UserState}
     */
    UserState: UserState,
    /**
     * The Uuid model constructor.
     * @property {module:model/Uuid}
     */
    Uuid: Uuid,
    /**
     * The ValidateTokenRequest model constructor.
     * @property {module:model/ValidateTokenRequest}
     */
    ValidateTokenRequest: ValidateTokenRequest,
    /**
     * The ValidateTokenResponse model constructor.
     * @property {module:model/ValidateTokenResponse}
     */
    ValidateTokenResponse: ValidateTokenResponse,
    /**
     * The VerifyKcvRequest model constructor.
     * @property {module:model/VerifyKcvRequest}
     */
    VerifyKcvRequest: VerifyKcvRequest,
    /**
     * The VerifyKcvResponse model constructor.
     * @property {module:model/VerifyKcvResponse}
     */
    VerifyKcvResponse: VerifyKcvResponse,
    /**
     * The VerifyRequest model constructor.
     * @property {module:model/VerifyRequest}
     */
    VerifyRequest: VerifyRequest,
    /**
     * The VerifyRequestEx model constructor.
     * @property {module:model/VerifyRequestEx}
     */
    VerifyRequestEx: VerifyRequestEx,
    /**
     * The VerifyResponse model constructor.
     * @property {module:model/VerifyResponse}
     */
    VerifyResponse: VerifyResponse,
    /**
     * The VersionResponse model constructor.
     * @property {module:model/VersionResponse}
     */
    VersionResponse: VersionResponse,
    /**
     * The WrapKeyParams model constructor.
     * @property {module:model/WrapKeyParams}
     */
    WrapKeyParams: WrapKeyParams,
    /**
     * The WrapKeyRequest model constructor.
     * @property {module:model/WrapKeyRequest}
     */
    WrapKeyRequest: WrapKeyRequest,
    /**
     * The WrapKeyRequestEx model constructor.
     * @property {module:model/WrapKeyRequestEx}
     */
    WrapKeyRequestEx: WrapKeyRequestEx,
    /**
     * The WrapKeyResponse model constructor.
     * @property {module:model/WrapKeyResponse}
     */
    WrapKeyResponse: WrapKeyResponse,
    /**
     * The AWSApi service constructor.
     * @property {module:api/AWSApi}
     */
    AWSApi: AWSApi,
    /**
     * The AccountsApi service constructor.
     * @property {module:api/AccountsApi}
     */
    AccountsApi: AccountsApi,
    /**
     * The ApprovalRequestsApi service constructor.
     * @property {module:api/ApprovalRequestsApi}
     */
    ApprovalRequestsApi: ApprovalRequestsApi,
    /**
     * The AppsApi service constructor.
     * @property {module:api/AppsApi}
     */
    AppsApi: AppsApi,
    /**
     * The AuthenticationApi service constructor.
     * @property {module:api/AuthenticationApi}
     */
    AuthenticationApi: AuthenticationApi,
    /**
     * The ChildAccountUsersApi service constructor.
     * @property {module:api/ChildAccountUsersApi}
     */
    ChildAccountUsersApi: ChildAccountUsersApi,
    /**
     * The ChildAccountsApi service constructor.
     * @property {module:api/ChildAccountsApi}
     */
    ChildAccountsApi: ChildAccountsApi,
    /**
     * The DigestApi service constructor.
     * @property {module:api/DigestApi}
     */
    DigestApi: DigestApi,
    /**
     * The EncryptionAndDecryptionApi service constructor.
     * @property {module:api/EncryptionAndDecryptionApi}
     */
    EncryptionAndDecryptionApi: EncryptionAndDecryptionApi,
    /**
     * The GroupsApi service constructor.
     * @property {module:api/GroupsApi}
     */
    GroupsApi: GroupsApi,
    /**
     * The LogsApi service constructor.
     * @property {module:api/LogsApi}
     */
    LogsApi: LogsApi,
    /**
     * The PluginsApi service constructor.
     * @property {module:api/PluginsApi}
     */
    PluginsApi: PluginsApi,
    /**
     * The SecurityObjectsApi service constructor.
     * @property {module:api/SecurityObjectsApi}
     */
    SecurityObjectsApi: SecurityObjectsApi,
    /**
     * The SignAndVerifyApi service constructor.
     * @property {module:api/SignAndVerifyApi}
     */
    SignAndVerifyApi: SignAndVerifyApi,
    /**
     * The StatsApi service constructor.
     * @property {module:api/StatsApi}
     */
    StatsApi: StatsApi,
    /**
     * The TwoFactorAuthenticationApi service constructor.
     * @property {module:api/TwoFactorAuthenticationApi}
     */
    TwoFactorAuthenticationApi: TwoFactorAuthenticationApi,
    /**
     * The UsersApi service constructor.
     * @property {module:api/UsersApi}
     */
    UsersApi: UsersApi,
    /**
     * The WrappingAndUnwrappingApi service constructor.
     * @property {module:api/WrappingAndUnwrappingApi}
     */
    WrappingAndUnwrappingApi: WrappingAndUnwrappingApi
  };

  return exports;
}));
