/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AccountState', 'model/AuthConfig', 'model/AuthType', 'model/KeyUndoPolicy', 'model/LoggingConfig', 'model/NotificationPref', 'model/SubscriptionChangeRequest', 'model/SubscriptionType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AccountState'), require('./AuthConfig'), require('./AuthType'), require('./KeyUndoPolicy'), require('./LoggingConfig'), require('./NotificationPref'), require('./SubscriptionChangeRequest'), require('./SubscriptionType'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.Account = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.AccountState, root.FortanixSdkmsRestApi.AuthConfig, root.FortanixSdkmsRestApi.AuthType, root.FortanixSdkmsRestApi.KeyUndoPolicy, root.FortanixSdkmsRestApi.LoggingConfig, root.FortanixSdkmsRestApi.NotificationPref, root.FortanixSdkmsRestApi.SubscriptionChangeRequest, root.FortanixSdkmsRestApi.SubscriptionType);
  }
}(this, function(ApiClient, AccountState, AuthConfig, AuthType, KeyUndoPolicy, LoggingConfig, NotificationPref, SubscriptionChangeRequest, SubscriptionType) {
  'use strict';




  /**
   * The Account model module.
   * @module model/Account
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>Account</code>.
   * @alias module:model/Account
   * @class
   * @param name {String} Name of the account. Account names must be unique within an SDKMS instance.
   * @param acctId {String} Account ID uniquely identifying this account.
   * @param subscription {module:model/SubscriptionType} 
   * @param state {module:model/AccountState} 
   * @param authType {module:model/AuthType} 
   */
  var exports = function(name, acctId, subscription, state, authType) {
    var _this = this;

    _this['name'] = name;
    _this['acct_id'] = acctId;






    _this['subscription'] = subscription;
    _this['state'] = state;
    _this['auth_type'] = authType;







  };

  /**
   * Constructs a <code>Account</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Account} obj Optional instance to populate.
   * @return {module:model/Account} The populated <code>Account</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('acct_id')) {
        obj['acct_id'] = ApiClient.convertToType(data['acct_id'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('organization')) {
        obj['organization'] = ApiClient.convertToType(data['organization'], 'String');
      }
      if (data.hasOwnProperty('country')) {
        obj['country'] = ApiClient.convertToType(data['country'], 'String');
      }
      if (data.hasOwnProperty('phone')) {
        obj['phone'] = ApiClient.convertToType(data['phone'], 'String');
      }
      if (data.hasOwnProperty('notification_pref')) {
        obj['notification_pref'] = NotificationPref.constructFromObject(data['notification_pref']);
      }
      if (data.hasOwnProperty('auth_config')) {
        obj['auth_config'] = AuthConfig.constructFromObject(data['auth_config']);
      }
      if (data.hasOwnProperty('subscription')) {
        obj['subscription'] = SubscriptionType.constructFromObject(data['subscription']);
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = AccountState.constructFromObject(data['state']);
      }
      if (data.hasOwnProperty('auth_type')) {
        obj['auth_type'] = AuthType.constructFromObject(data['auth_type']);
      }
      if (data.hasOwnProperty('logging_configs')) {
        obj['logging_configs'] = ApiClient.convertToType(data['logging_configs'], {'String': LoggingConfig});
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('created_at')) {
        obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
      }
      if (data.hasOwnProperty('initial_purchase_at')) {
        obj['initial_purchase_at'] = ApiClient.convertToType(data['initial_purchase_at'], 'String');
      }
      if (data.hasOwnProperty('pending_subscription_change_request')) {
        obj['pending_subscription_change_request'] = SubscriptionChangeRequest.constructFromObject(data['pending_subscription_change_request']);
      }
      if (data.hasOwnProperty('custom_metadata')) {
        obj['custom_metadata'] = ApiClient.convertToType(data['custom_metadata'], {'String': 'String'});
      }
      if (data.hasOwnProperty('key_undo_policy')) {
        obj['key_undo_policy'] = KeyUndoPolicy.constructFromObject(data['key_undo_policy']);
      }
    }
    return obj;
  }

  /**
   * Name of the account. Account names must be unique within an SDKMS instance.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Account ID uniquely identifying this account.
   * @member {String} acct_id
   */
  exports.prototype['acct_id'] = undefined;
  /**
   * Description of this account.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Organization (e.g. company name) that owns this account
   * @member {String} organization
   */
  exports.prototype['organization'] = undefined;
  /**
   * Main country associated with this account
   * @member {String} country
   */
  exports.prototype['country'] = undefined;
  /**
   * Contact phone number associated with this account
   * @member {String} phone
   */
  exports.prototype['phone'] = undefined;
  /**
   * @member {module:model/NotificationPref} notification_pref
   */
  exports.prototype['notification_pref'] = undefined;
  /**
   * @member {module:model/AuthConfig} auth_config
   */
  exports.prototype['auth_config'] = undefined;
  /**
   * @member {module:model/SubscriptionType} subscription
   */
  exports.prototype['subscription'] = undefined;
  /**
   * @member {module:model/AccountState} state
   */
  exports.prototype['state'] = undefined;
  /**
   * @member {module:model/AuthType} auth_type
   */
  exports.prototype['auth_type'] = undefined;
  /**
   * Map from UUIDs to LoggingConfig objects
   * @member {Object.<String, module:model/LoggingConfig>} logging_configs
   */
  exports.prototype['logging_configs'] = undefined;
  /**
   * Whether this account is enabled. This may only be changed by sysadmins.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * When this account was created.
   * @member {String} created_at
   */
  exports.prototype['created_at'] = undefined;
  /**
   * When this accout was upgraded a paid subscription.
   * @member {String} initial_purchase_at
   */
  exports.prototype['initial_purchase_at'] = undefined;
  /**
   * @member {module:model/SubscriptionChangeRequest} pending_subscription_change_request
   */
  exports.prototype['pending_subscription_change_request'] = undefined;
  /**
   * Sysadmin-defined metadata for this account. Stored as key-value pairs. This field is only visible to sysadmin users. 
   * @member {Object.<String, String>} custom_metadata
   */
  exports.prototype['custom_metadata'] = undefined;
  /**
   * @member {module:model/KeyUndoPolicy} key_undo_policy
   */
  exports.prototype['key_undo_policy'] = undefined;



  return exports;
}));


