/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AppAuthType', 'model/AppOauthConfig', 'model/CreatorType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AppAuthType'), require('./AppOauthConfig'), require('./CreatorType'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.App = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.AppAuthType, root.FortanixSdkmsRestApi.AppOauthConfig, root.FortanixSdkmsRestApi.CreatorType);
  }
}(this, function(ApiClient, AppAuthType, AppOauthConfig, CreatorType) {
  'use strict';




  /**
   * The App model module.
   * @module model/App
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>App</code>.
   * @alias module:model/App
   * @class
   * @param name {String} Name of the application. Application names must be unique within an account.
   * @param appId {String} Application ID uniquely identifying this application.
   * @param authType {module:model/AppAuthType} 
   * @param acctId {String} The account ID of the account that this application belongs to.
   * @param groups {Array.<String>} An array of Security Group IDs. The application belongs to each Security Group in this array.
   * @param defaultGroup {String} The default group of this application. This is the group where security objects will be created by default by this application.
   * @param enabled {Boolean} Whether this application is enabled.
   * @param appType {String} The user-defined type of this application.
   * @param creator {module:model/CreatorType} 
   * @param createdAt {String} When this application was created.
   */
  var exports = function(name, appId, authType, acctId, groups, defaultGroup, enabled, appType, creator, createdAt) {
    var _this = this;

    _this['name'] = name;
    _this['app_id'] = appId;
    _this['auth_type'] = authType;


    _this['acct_id'] = acctId;
    _this['groups'] = groups;
    _this['default_group'] = defaultGroup;
    _this['enabled'] = enabled;
    _this['app_type'] = appType;
    _this['creator'] = creator;
    _this['created_at'] = createdAt;



  };

  /**
   * Constructs a <code>App</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/App} obj Optional instance to populate.
   * @return {module:model/App} The populated <code>App</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('app_id')) {
        obj['app_id'] = ApiClient.convertToType(data['app_id'], 'String');
      }
      if (data.hasOwnProperty('auth_type')) {
        obj['auth_type'] = AppAuthType.constructFromObject(data['auth_type']);
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('interface')) {
        obj['interface'] = ApiClient.convertToType(data['interface'], 'String');
      }
      if (data.hasOwnProperty('acct_id')) {
        obj['acct_id'] = ApiClient.convertToType(data['acct_id'], 'String');
      }
      if (data.hasOwnProperty('groups')) {
        obj['groups'] = ApiClient.convertToType(data['groups'], ['String']);
      }
      if (data.hasOwnProperty('default_group')) {
        obj['default_group'] = ApiClient.convertToType(data['default_group'], 'String');
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('app_type')) {
        obj['app_type'] = ApiClient.convertToType(data['app_type'], 'String');
      }
      if (data.hasOwnProperty('creator')) {
        obj['creator'] = CreatorType.constructFromObject(data['creator']);
      }
      if (data.hasOwnProperty('created_at')) {
        obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
      }
      if (data.hasOwnProperty('lastused_at')) {
        obj['lastused_at'] = ApiClient.convertToType(data['lastused_at'], 'String');
      }
      if (data.hasOwnProperty('oauth_config')) {
        obj['oauth_config'] = AppOauthConfig.constructFromObject(data['oauth_config']);
      }
      if (data.hasOwnProperty('cert_not_after')) {
        obj['cert_not_after'] = ApiClient.convertToType(data['cert_not_after'], 'String');
      }
    }
    return obj;
  }

  /**
   * Name of the application. Application names must be unique within an account.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Application ID uniquely identifying this application.
   * @member {String} app_id
   */
  exports.prototype['app_id'] = undefined;
  /**
   * @member {module:model/AppAuthType} auth_type
   */
  exports.prototype['auth_type'] = undefined;
  /**
   * Description of this application.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Interface used with this application (PKCS11, CNG, JCE, KMIP, etc.).
   * @member {String} interface
   */
  exports.prototype['interface'] = undefined;
  /**
   * The account ID of the account that this application belongs to.
   * @member {String} acct_id
   */
  exports.prototype['acct_id'] = undefined;
  /**
   * An array of Security Group IDs. The application belongs to each Security Group in this array.
   * @member {Array.<String>} groups
   */
  exports.prototype['groups'] = undefined;
  /**
   * The default group of this application. This is the group where security objects will be created by default by this application.
   * @member {String} default_group
   */
  exports.prototype['default_group'] = undefined;
  /**
   * Whether this application is enabled.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * The user-defined type of this application.
   * @member {String} app_type
   */
  exports.prototype['app_type'] = undefined;
  /**
   * @member {module:model/CreatorType} creator
   */
  exports.prototype['creator'] = undefined;
  /**
   * When this application was created.
   * @member {String} created_at
   */
  exports.prototype['created_at'] = undefined;
  /**
   * When this application was last used.
   * @member {String} lastused_at
   */
  exports.prototype['lastused_at'] = undefined;
  /**
   * @member {module:model/AppOauthConfig} oauth_config
   */
  exports.prototype['oauth_config'] = undefined;
  /**
   * Certificate expiration date.
   * @member {String} cert_not_after
   */
  exports.prototype['cert_not_after'] = undefined;



  return exports;
}));


