/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AppCredentialSignedjwt', 'model/AppCredentialTrustedca'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AppCredentialSignedjwt'), require('./AppCredentialTrustedca'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AppCredential = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.AppCredentialSignedjwt, root.FortanixSdkmsRestApi.AppCredentialTrustedca);
  }
}(this, function(ApiClient, AppCredentialSignedjwt, AppCredentialTrustedca) {
  'use strict';




  /**
   * The AppCredential model module.
   * @module model/AppCredential
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AppCredential</code>.
   * Credential for an application.
   * @alias module:model/AppCredential
   * @class
   */
  var exports = function() {
    var _this = this;






  };

  /**
   * Constructs a <code>AppCredential</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AppCredential} obj Optional instance to populate.
   * @return {module:model/AppCredential} The populated <code>AppCredential</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('secret')) {
        obj['secret'] = ApiClient.convertToType(data['secret'], 'String');
      }
      if (data.hasOwnProperty('certificate')) {
        obj['certificate'] = ApiClient.convertToType(data['certificate'], 'String');
      }
      if (data.hasOwnProperty('trustedca')) {
        obj['trustedca'] = AppCredentialTrustedca.constructFromObject(data['trustedca']);
      }
      if (data.hasOwnProperty('googleserviceaccount')) {
        obj['googleserviceaccount'] = ApiClient.convertToType(data['googleserviceaccount'], Object);
      }
      if (data.hasOwnProperty('signedjwt')) {
        obj['signedjwt'] = AppCredentialSignedjwt.constructFromObject(data['signedjwt']);
      }
    }
    return obj;
  }

  /**
   * @member {String} secret
   */
  exports.prototype['secret'] = undefined;
  /**
   * @member {String} certificate
   */
  exports.prototype['certificate'] = undefined;
  /**
   * @member {module:model/AppCredentialTrustedca} trustedca
   */
  exports.prototype['trustedca'] = undefined;
  /**
   * @member {Object} googleserviceaccount
   */
  exports.prototype['googleserviceaccount'] = undefined;
  /**
   * @member {module:model/AppCredentialSignedjwt} signedjwt
   */
  exports.prototype['signedjwt'] = undefined;



  return exports;
}));


