/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/JWTSigningKeyType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./JWTSigningKeyType'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AppCredentialSignedjwtSigningKeys = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.JWTSigningKeyType);
  }
}(this, function(ApiClient, JWTSigningKeyType) {
  'use strict';




  /**
   * The AppCredentialSignedjwtSigningKeys model module.
   * @module model/AppCredentialSignedjwtSigningKeys
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AppCredentialSignedjwtSigningKeys</code>.
   * Details of signning key that will be used for signature verification.
   * @alias module:model/AppCredentialSignedjwtSigningKeys
   * @class
   * @param kind {module:model/JWTSigningKeyType} Type of signing key, fetched or stored
   */
  var exports = function(kind) {
    var _this = this;

    _this['kind'] = kind;



  };

  /**
   * Constructs a <code>AppCredentialSignedjwtSigningKeys</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AppCredentialSignedjwtSigningKeys} obj Optional instance to populate.
   * @return {module:model/AppCredentialSignedjwtSigningKeys} The populated <code>AppCredentialSignedjwtSigningKeys</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('kind')) {
        obj['kind'] = JWTSigningKeyType.constructFromObject(data['kind']);
      }
      if (data.hasOwnProperty('keys')) {
        obj['keys'] = ApiClient.convertToType(data['keys'], {'String': 'String'});
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('cache_duration')) {
        obj['cache_duration'] = ApiClient.convertToType(data['cache_duration'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Type of signing key, fetched or stored
   * @member {module:model/JWTSigningKeyType} kind
   */
  exports.prototype['kind'] = undefined;
  /**
   * In case of \"stored\" kind, a map of key ids (arbitrary strings) to base64-encoded DER keys
   * @member {Object.<String, String>} keys
   */
  exports.prototype['keys'] = undefined;
  /**
   * In case of \"fetched\" kind, URL for fetching public key for verification of JWT signature
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * In case of \"fetched\" kind, duration for which the public key can be cached
   * @member {Number} cache_duration
   */
  exports.prototype['cache_duration'] = undefined;



  return exports;
}));


