/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AppCredentialTrustedca = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The AppCredentialTrustedca model module.
   * @module model/AppCredentialTrustedca
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AppCredentialTrustedca</code>.
   * @alias module:model/AppCredentialTrustedca
   * @class
   * @param caCertificate {String} 
   */
  var exports = function(caCertificate) {
    var _this = this;


    _this['ca_certificate'] = caCertificate;
  };

  /**
   * Constructs a <code>AppCredentialTrustedca</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AppCredentialTrustedca} obj Optional instance to populate.
   * @return {module:model/AppCredentialTrustedca} The populated <code>AppCredentialTrustedca</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('subject')) {
        obj['subject'] = ApiClient.convertToType(data['subject'], [['String']]);
      }
      if (data.hasOwnProperty('ca_certificate')) {
        obj['ca_certificate'] = ApiClient.convertToType(data['ca_certificate'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {Array.<Array.<String>>} subject
   */
  exports.prototype['subject'] = undefined;
  /**
   * @member {String} ca_certificate
   */
  exports.prototype['ca_certificate'] = undefined;



  return exports;
}));


