/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AppCredential', 'model/AppOauthConfig', 'model/AppPermissions'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AppCredential'), require('./AppOauthConfig'), require('./AppPermissions'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AppRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.AppCredential, root.FortanixSdkmsRestApi.AppOauthConfig, root.FortanixSdkmsRestApi.AppPermissions);
  }
}(this, function(ApiClient, AppCredential, AppOauthConfig, AppPermissions) {
  'use strict';




  /**
   * The AppRequest model module.
   * @module model/AppRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AppRequest</code>.
   * @alias module:model/AppRequest
   * @class
   * @param name {String} Name of this application. Application names must be unique within an account.
   * @param addGroups {Object.<String, Array.<module:model/AppPermissions>>} Map from UUIDs to group permissions
   * @param defaultGroup {String} The default group of this application. This is the group where security objects will be created by default by this application.
   */
  var exports = function(name, addGroups, defaultGroup) {
    var _this = this;

    _this['name'] = name;

    _this['add_groups'] = addGroups;


    _this['default_group'] = defaultGroup;






  };

  /**
   * Constructs a <code>AppRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AppRequest} obj Optional instance to populate.
   * @return {module:model/AppRequest} The populated <code>AppRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('add_groups')) {
        obj['add_groups'] = ApiClient.convertToType(data['add_groups'], {'String': [AppPermissions]});
      }
      if (data.hasOwnProperty('del_groups')) {
        obj['del_groups'] = ApiClient.convertToType(data['del_groups'], ['String']);
      }
      if (data.hasOwnProperty('mod_groups')) {
        obj['mod_groups'] = ApiClient.convertToType(data['mod_groups'], {'String': [AppPermissions]});
      }
      if (data.hasOwnProperty('default_group')) {
        obj['default_group'] = ApiClient.convertToType(data['default_group'], 'String');
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('AppOauthConfig')) {
        obj['AppOauthConfig'] = AppOauthConfig.constructFromObject(data['AppOauthConfig']);
      }
      if (data.hasOwnProperty('interface')) {
        obj['interface'] = ApiClient.convertToType(data['interface'], 'String');
      }
      if (data.hasOwnProperty('app_type')) {
        obj['app_type'] = ApiClient.convertToType(data['app_type'], 'String');
      }
      if (data.hasOwnProperty('credential')) {
        obj['credential'] = AppCredential.constructFromObject(data['credential']);
      }
      if (data.hasOwnProperty('secret_size')) {
        obj['secret_size'] = ApiClient.convertToType(data['secret_size'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Name of this application. Application names must be unique within an account.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of this application.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Map from UUIDs to group permissions
   * @member {Object.<String, Array.<module:model/AppPermissions>>} add_groups
   */
  exports.prototype['add_groups'] = undefined;
  /**
   * Array of UUID of group
   * @member {Array.<String>} del_groups
   */
  exports.prototype['del_groups'] = undefined;
  /**
   * Map from UUIDs to group permissions
   * @member {Object.<String, Array.<module:model/AppPermissions>>} mod_groups
   */
  exports.prototype['mod_groups'] = undefined;
  /**
   * The default group of this application. This is the group where security objects will be created by default by this application.
   * @member {String} default_group
   */
  exports.prototype['default_group'] = undefined;
  /**
   * Whether this application is enabled
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * @member {module:model/AppOauthConfig} AppOauthConfig
   */
  exports.prototype['AppOauthConfig'] = undefined;
  /**
   * Interface used with this application (PKCS11, CNG, JCE, KMIP, etc.).
   * @member {String} interface
   */
  exports.prototype['interface'] = undefined;
  /**
   * The user-defined type of this application.
   * @member {String} app_type
   */
  exports.prototype['app_type'] = undefined;
  /**
   * @member {module:model/AppCredential} credential
   */
  exports.prototype['credential'] = undefined;
  /**
   * Size in bytes of app's secret.
   * @member {Number} secret_size
   */
  exports.prototype['secret_size'] = undefined;



  return exports;
}));


