/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ApprovalRequestRequest = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ApprovalRequestRequest model module.
   * @module model/ApprovalRequestRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ApprovalRequestRequest</code>.
   * @alias module:model/ApprovalRequestRequest
   * @class
   * @param operation {String} Operation URL path, e.g. `/crypto/v1/keys`, `/crypto/v1/groups/<id>`.
   */
  var exports = function(operation) {
    var _this = this;

    _this['operation'] = operation;



  };

  /**
   * Constructs a <code>ApprovalRequestRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApprovalRequestRequest} obj Optional instance to populate.
   * @return {module:model/ApprovalRequestRequest} The populated <code>ApprovalRequestRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('operation')) {
        obj['operation'] = ApiClient.convertToType(data['operation'], 'String');
      }
      if (data.hasOwnProperty('method')) {
        obj['method'] = ApiClient.convertToType(data['method'], 'String');
      }
      if (data.hasOwnProperty('body')) {
        obj['body'] = ApiClient.convertToType(data['body'], Object);
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
    }
    return obj;
  }

  /**
   * Operation URL path, e.g. `/crypto/v1/keys`, `/crypto/v1/groups/<id>`.
   * @member {String} operation
   */
  exports.prototype['operation'] = undefined;
  /**
   * Method for the operation: POST, PATCH, PUT, DELETE, or GET. Default is POST. 
   * @member {String} method
   */
  exports.prototype['method'] = undefined;
  /**
   * @member {Object} body
   */
  exports.prototype['body'] = undefined;
  /**
   * Optional comment about the approval request for the reviewer.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;



  return exports;
}));


