/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ApprovalSubject = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The ApprovalSubject model module.
   * @module model/ApprovalSubject
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ApprovalSubject</code>.
   * Identifies an object acted upon by an approval request.
   * @alias module:model/ApprovalSubject
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>ApprovalSubject</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ApprovalSubject} obj Optional instance to populate.
   * @return {module:model/ApprovalSubject} The populated <code>ApprovalSubject</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('group')) {
        obj['group'] = ApiClient.convertToType(data['group'], 'String');
      }
      if (data.hasOwnProperty('sobject')) {
        obj['sobject'] = ApiClient.convertToType(data['sobject'], 'String');
      }
      if (data.hasOwnProperty('app')) {
        obj['app'] = ApiClient.convertToType(data['app'], 'String');
      }
      if (data.hasOwnProperty('plugin')) {
        obj['plugin'] = ApiClient.convertToType(data['plugin'], 'String');
      }
    }
    return obj;
  }

  /**
   * The ID of the group being acted upon, if the subject is a group.
   * @member {String} group
   */
  exports.prototype['group'] = undefined;
  /**
   * The ID of the security object being acted upon, if the subject is a security object.
   * @member {String} sobject
   */
  exports.prototype['sobject'] = undefined;
  /**
   * The ID of the app being acted upon, if the subject is a app.
   * @member {String} app
   */
  exports.prototype['app'] = undefined;
  /**
   * The ID of the plugin being acted upon, if the subject is a app.
   * @member {String} plugin
   */
  exports.prototype['plugin'] = undefined;



  return exports;
}));


