/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AuthConfigPassword', 'model/AuthConfigSignedJWT'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AuthConfigPassword'), require('./AuthConfigSignedJWT'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AuthConfig = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.AuthConfigPassword, root.FortanixSdkmsRestApi.AuthConfigSignedJWT);
  }
}(this, function(ApiClient, AuthConfigPassword, AuthConfigSignedJWT) {
  'use strict';




  /**
   * The AuthConfig model module.
   * @module model/AuthConfig
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AuthConfig</code>.
   * @alias module:model/AuthConfig
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>AuthConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AuthConfig} obj Optional instance to populate.
   * @return {module:model/AuthConfig} The populated <code>AuthConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('password')) {
        obj['password'] = AuthConfigPassword.constructFromObject(data['password']);
      }
      if (data.hasOwnProperty('saml')) {
        obj['saml'] = ApiClient.convertToType(data['saml'], 'String');
      }
      if (data.hasOwnProperty('signed_jwt')) {
        obj['signed_jwt'] = AuthConfigSignedJWT.constructFromObject(data['signed_jwt']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/AuthConfigPassword} password
   */
  exports.prototype['password'] = undefined;
  /**
   * XML metadata for a SAML 2.0 Identity Provider (IdP).
   * @member {String} saml
   */
  exports.prototype['saml'] = undefined;
  /**
   * Signed JWT verification data
   * @member {module:model/AuthConfigSignedJWT} signed_jwt
   */
  exports.prototype['signed_jwt'] = undefined;



  return exports;
}));


