/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AuthConfigPassword = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The AuthConfigPassword model module.
   * @module model/AuthConfigPassword
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AuthConfigPassword</code>.
   * Configuration for password-based authentication.
   * @alias module:model/AuthConfigPassword
   * @class
   * @param require2fa {Boolean} Reserved for future use, must be false.
   * @param administratorsOnly {Boolean} Reserved for future use, must be false.
   */
  var exports = function(require2fa, administratorsOnly) {
    var _this = this;

    _this['require_2fa'] = require2fa;
    _this['administrators_only'] = administratorsOnly;
  };

  /**
   * Constructs a <code>AuthConfigPassword</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AuthConfigPassword} obj Optional instance to populate.
   * @return {module:model/AuthConfigPassword} The populated <code>AuthConfigPassword</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('require_2fa')) {
        obj['require_2fa'] = ApiClient.convertToType(data['require_2fa'], 'Boolean');
      }
      if (data.hasOwnProperty('administrators_only')) {
        obj['administrators_only'] = ApiClient.convertToType(data['administrators_only'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Reserved for future use, must be false.
   * @member {Boolean} require_2fa
   */
  exports.prototype['require_2fa'] = undefined;
  /**
   * Reserved for future use, must be false.
   * @member {Boolean} administrators_only
   */
  exports.prototype['administrators_only'] = undefined;



  return exports;
}));


