/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/AppCredentialSignedjwtSigningKeys'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./AppCredentialSignedjwtSigningKeys'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AuthConfigSignedJWT = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.AppCredentialSignedjwtSigningKeys);
  }
}(this, function(ApiClient, AppCredentialSignedjwtSigningKeys) {
  'use strict';




  /**
   * The AuthConfigSignedJWT model module.
   * @module model/AuthConfigSignedJWT
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AuthConfigSignedJWT</code>.
   * Configuration for signed JWT authentication.
   * @alias module:model/AuthConfigSignedJWT
   * @class
   * @param validIssuers {Array.<String>} An array of valid issuers. JWT presented for authentication must have one of these issuers.
   */
  var exports = function(validIssuers) {
    var _this = this;

    _this['valid_issuers'] = validIssuers;

  };

  /**
   * Constructs a <code>AuthConfigSignedJWT</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AuthConfigSignedJWT} obj Optional instance to populate.
   * @return {module:model/AuthConfigSignedJWT} The populated <code>AuthConfigSignedJWT</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('valid_issuers')) {
        obj['valid_issuers'] = ApiClient.convertToType(data['valid_issuers'], ['String']);
      }
      if (data.hasOwnProperty('signing_keys')) {
        obj['signing_keys'] = AppCredentialSignedjwtSigningKeys.constructFromObject(data['signing_keys']);
      }
    }
    return obj;
  }

  /**
   * An array of valid issuers. JWT presented for authentication must have one of these issuers.
   * @member {Array.<String>} valid_issuers
   */
  exports.prototype['valid_issuers'] = undefined;
  /**
   * @member {module:model/AppCredentialSignedjwtSigningKeys} signing_keys
   */
  exports.prototype['signing_keys'] = undefined;



  return exports;
}));


