/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.AuthResponse = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The AuthResponse model module.
   * @module model/AuthResponse
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>AuthResponse</code>.
   * @alias module:model/AuthResponse
   * @class
   * @param expiresIn {Number} Number of seconds from token issuance that the token will expire.
   * @param accessToken {String} Bearer token to be used to authenticate to other APIs.
   * @param entityId {String} The UUID of the entity that was authorized. For users, this will be the user's UUID. For applications, this will be the application's UUID. 
   */
  var exports = function(expiresIn, accessToken, entityId) {
    var _this = this;

    _this['expires_in'] = expiresIn;
    _this['access_token'] = accessToken;
    _this['entity_id'] = entityId;
  };

  /**
   * Constructs a <code>AuthResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/AuthResponse} obj Optional instance to populate.
   * @return {module:model/AuthResponse} The populated <code>AuthResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('expires_in')) {
        obj['expires_in'] = ApiClient.convertToType(data['expires_in'], 'Number');
      }
      if (data.hasOwnProperty('access_token')) {
        obj['access_token'] = ApiClient.convertToType(data['access_token'], 'String');
      }
      if (data.hasOwnProperty('entity_id')) {
        obj['entity_id'] = ApiClient.convertToType(data['entity_id'], 'String');
      }
    }
    return obj;
  }

  /**
   * Number of seconds from token issuance that the token will expire.
   * @member {Number} expires_in
   */
  exports.prototype['expires_in'] = undefined;
  /**
   * Bearer token to be used to authenticate to other APIs.
   * @member {String} access_token
   */
  exports.prototype['access_token'] = undefined;
  /**
   * The UUID of the entity that was authorized. For users, this will be the user's UUID. For applications, this will be the application's UUID. 
   * @member {String} entity_id
   */
  exports.prototype['entity_id'] = undefined;



  return exports;
}));


