/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MacGenerateResponse'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./MacGenerateResponse'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.BatchMacResponseInner = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.MacGenerateResponse);
  }
}(this, function(ApiClient, MacGenerateResponse) {
  'use strict';




  /**
   * The BatchMacResponseInner model module.
   * @module model/BatchMacResponseInner
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>BatchMacResponseInner</code>.
   * @alias module:model/BatchMacResponseInner
   * @class
   * @param status {Number} The HTTP status code for this partial request.
   */
  var exports = function(status) {
    var _this = this;

    _this['status'] = status;


  };

  /**
   * Constructs a <code>BatchMacResponseInner</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/BatchMacResponseInner} obj Optional instance to populate.
   * @return {module:model/BatchMacResponseInner} The populated <code>BatchMacResponseInner</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('status')) {
        obj['status'] = ApiClient.convertToType(data['status'], 'Number');
      }
      if (data.hasOwnProperty('error')) {
        obj['error'] = ApiClient.convertToType(data['error'], 'String');
      }
      if (data.hasOwnProperty('body')) {
        obj['body'] = MacGenerateResponse.constructFromObject(data['body']);
      }
    }
    return obj;
  }

  /**
   * The HTTP status code for this partial request.
   * @member {Number} status
   */
  exports.prototype['status'] = undefined;
  /**
   * When the status property indicates an error, this contains the error message.
   * @member {String} error
   */
  exports.prototype['error'] = undefined;
  /**
   * @member {module:model/MacGenerateResponse} body
   */
  exports.prototype['body'] = undefined;



  return exports;
}));


