/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.CaConfig = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The CaConfig model module.
   * @module model/CaConfig
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>CaConfig</code>.
   * @alias module:model/CaConfig
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>CaConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/CaConfig} obj Optional instance to populate.
   * @return {module:model/CaConfig} The populated <code>CaConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('ca_set')) {
        obj['ca_set'] = ApiClient.convertToType(data['ca_set'], 'String');
      }
      if (data.hasOwnProperty('pinned')) {
        obj['pinned'] = ApiClient.convertToType(data['pinned'], ['Blob']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/CaConfig.CaSetEnum} ca_set
   * @default 'global_roots'
   */
  exports.prototype['ca_set'] = 'global_roots';
  /**
   * @member {Array.<Blob>} pinned
   */
  exports.prototype['pinned'] = undefined;


  /**
   * Allowed values for the <code>ca_set</code> property.
   * @enum {String}
   * @readonly
   */
  exports.CaSetEnum = {
    /**
     * value: "global_roots"
     * @const
     */
    "roots": "global_roots"  };


  return exports;
}));


