/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/UserAccountFlags', 'model/UserGroupMap'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./UserAccountFlags'), require('./UserGroupMap'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ChildAccountUser = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.UserAccountFlags, root.FortanixSdkmsRestApi.UserGroupMap);
  }
}(this, function(ApiClient, UserAccountFlags, UserGroupMap) {
  'use strict';




  /**
   * The ChildAccountUser model module.
   * @module model/ChildAccountUser
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ChildAccountUser</code>.
   * @alias module:model/ChildAccountUser
   * @class
   * @param userId {String} User ID uniquely identifying this user.
   * @param userEmail {String} The User's email address.
   * @param groups {module:model/UserGroupMap} 
   */
  var exports = function(userId, userEmail, groups) {
    var _this = this;

    _this['user_id'] = userId;
    _this['user_email'] = userEmail;

    _this['groups'] = groups;


  };

  /**
   * Constructs a <code>ChildAccountUser</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ChildAccountUser} obj Optional instance to populate.
   * @return {module:model/ChildAccountUser} The populated <code>ChildAccountUser</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('user_id')) {
        obj['user_id'] = ApiClient.convertToType(data['user_id'], 'String');
      }
      if (data.hasOwnProperty('user_email')) {
        obj['user_email'] = ApiClient.convertToType(data['user_email'], 'String');
      }
      if (data.hasOwnProperty('account_role')) {
        obj['account_role'] = ApiClient.convertToType(data['account_role'], [UserAccountFlags]);
      }
      if (data.hasOwnProperty('groups')) {
        obj['groups'] = UserGroupMap.constructFromObject(data['groups']);
      }
      if (data.hasOwnProperty('created_at')) {
        obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
      }
      if (data.hasOwnProperty('last_logged_in_at')) {
        obj['last_logged_in_at'] = ApiClient.convertToType(data['last_logged_in_at'], 'String');
      }
    }
    return obj;
  }

  /**
   * User ID uniquely identifying this user.
   * @member {String} user_id
   */
  exports.prototype['user_id'] = undefined;
  /**
   * The User's email address.
   * @member {String} user_email
   */
  exports.prototype['user_email'] = undefined;
  /**
   * @member {Array.<module:model/UserAccountFlags>} account_role
   */
  exports.prototype['account_role'] = undefined;
  /**
   * @member {module:model/UserGroupMap} groups
   */
  exports.prototype['groups'] = undefined;
  /**
   * When this user was added to account.
   * @member {String} created_at
   */
  exports.prototype['created_at'] = undefined;
  /**
   * When this user last logged in.
   * @member {String} last_logged_in_at
   */
  exports.prototype['last_logged_in_at'] = undefined;



  return exports;
}));


