/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/UserAccountFlags', 'model/UserGroupMap'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./UserAccountFlags'), require('./UserGroupMap'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ChildAccountUserRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.UserAccountFlags, root.FortanixSdkmsRestApi.UserGroupMap);
  }
}(this, function(ApiClient, UserAccountFlags, UserGroupMap) {
  'use strict';




  /**
   * The ChildAccountUserRequest model module.
   * @module model/ChildAccountUserRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ChildAccountUserRequest</code>.
   * @alias module:model/ChildAccountUserRequest
   * @class
   * @param childAcctId {String} Account id of child account
   * @param userEmail {String} User's email address.
   */
  var exports = function(childAcctId, userEmail) {
    var _this = this;

    _this['child_acct_id'] = childAcctId;
    _this['user_email'] = userEmail;





  };

  /**
   * Constructs a <code>ChildAccountUserRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ChildAccountUserRequest} obj Optional instance to populate.
   * @return {module:model/ChildAccountUserRequest} The populated <code>ChildAccountUserRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('child_acct_id')) {
        obj['child_acct_id'] = ApiClient.convertToType(data['child_acct_id'], 'String');
      }
      if (data.hasOwnProperty('user_email')) {
        obj['user_email'] = ApiClient.convertToType(data['user_email'], 'String');
      }
      if (data.hasOwnProperty('account_role')) {
        obj['account_role'] = ApiClient.convertToType(data['account_role'], [UserAccountFlags]);
      }
      if (data.hasOwnProperty('add_groups')) {
        obj['add_groups'] = UserGroupMap.constructFromObject(data['add_groups']);
      }
      if (data.hasOwnProperty('del_groups')) {
        obj['del_groups'] = UserGroupMap.constructFromObject(data['del_groups']);
      }
      if (data.hasOwnProperty('mod_groups')) {
        obj['mod_groups'] = UserGroupMap.constructFromObject(data['mod_groups']);
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * Account id of child account
   * @member {String} child_acct_id
   */
  exports.prototype['child_acct_id'] = undefined;
  /**
   * User's email address.
   * @member {String} user_email
   */
  exports.prototype['user_email'] = undefined;
  /**
   * @member {Array.<module:model/UserAccountFlags>} account_role
   */
  exports.prototype['account_role'] = undefined;
  /**
   * The user will be added to the specified security groups with the specified roles.
   * @member {module:model/UserGroupMap} add_groups
   */
  exports.prototype['add_groups'] = undefined;
  /**
   * The user will be removed from the specified security groups.
   * @member {module:model/UserGroupMap} del_groups
   */
  exports.prototype['del_groups'] = undefined;
  /**
   * The user's role in the specified groups will be updated to the specified roles.
   * @member {module:model/UserGroupMap} mod_groups
   */
  exports.prototype['mod_groups'] = undefined;
  /**
   * Whether this application is enabled.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;



  return exports;
}));


