/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/EncryptRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./EncryptRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.DeriveKeyMechanism = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.EncryptRequest);
  }
}(this, function(ApiClient, EncryptRequest) {
  'use strict';




  /**
   * The DeriveKeyMechanism model module.
   * @module model/DeriveKeyMechanism
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>DeriveKeyMechanism</code>.
   * Encodes the mechanism to be used when deriving a new key from an existing key. Exactly one mechanism should be supplied. Currently, the only supported mechanism is encrypting data to derive the new key. Other mechanisms may be added in the future. 
   * @alias module:model/DeriveKeyMechanism
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>DeriveKeyMechanism</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DeriveKeyMechanism} obj Optional instance to populate.
   * @return {module:model/DeriveKeyMechanism} The populated <code>DeriveKeyMechanism</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('encrypt_data')) {
        obj['encrypt_data'] = EncryptRequest.constructFromObject(data['encrypt_data']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/EncryptRequest} encrypt_data
   */
  exports.prototype['encrypt_data'] = undefined;



  return exports;
}));


