/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.DigestAlgorithm = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';


  /**
   * Enum class DigestAlgorithm.
   * @enum {}
   * @readonly
   */
  var exports = {
    /**
     * value: "Blake2b256"
     * @const
     */
    "Blake2b256": "Blake2b256",
    /**
     * value: "Blake2b384"
     * @const
     */
    "Blake2b384": "Blake2b384",
    /**
     * value: "Blake2b512"
     * @const
     */
    "Blake2b512": "Blake2b512",
    /**
     * value: "Blake2s256"
     * @const
     */
    "Blake2s256": "Blake2s256",
    /**
     * value: "RIPEMD160"
     * @const
     */
    "RIPEMD160": "RIPEMD160",
    /**
     * value: "SHA1"
     * @const
     */
    "SHA1": "SHA1",
    /**
     * value: "SHA256"
     * @const
     */
    "SHA256": "SHA256",
    /**
     * value: "SHA384"
     * @const
     */
    "SHA384": "SHA384",
    /**
     * value: "SHA512"
     * @const
     */
    "SHA512": "SHA512",
    /**
     * value: "SHA3_224"
     * @const
     */
    "SHA3_224": "SHA3_224",
    /**
     * value: "SHA3_256"
     * @const
     */
    "SHA3_256": "SHA3_256",
    /**
     * value: "SHA3_384"
     * @const
     */
    "SHA3_384": "SHA3_384",
    /**
     * value: "SHA3_512"
     * @const
     */
    "SHA3_512": "SHA3_512",
    /**
     * value: "Ssl3"
     * @const
     */
    "Ssl3": "Ssl3",
    /**
     * value: "Streebog256"
     * @const
     */
    "Streebog256": "Streebog256",
    /**
     * value: "Streebog512"
     * @const
     */
    "Streebog512": "Streebog512"  };

  /**
   * Returns a <code>DigestAlgorithm</code> enum value from a Javascript object name.
   * @param {Object} data The plain JavaScript object containing the name of the enum value.
   * @return {module:model/DigestAlgorithm} The enum <code>DigestAlgorithm</code> value.
   */
  exports.constructFromObject = function(object) {
    return object;
  }

  return exports;
}));


