/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.DsaOptions = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The DsaOptions model module.
   * @module model/DsaOptions
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>DsaOptions</code>.
   * DSA-specific options.
   * @alias module:model/DsaOptions
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>DsaOptions</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/DsaOptions} obj Optional instance to populate.
   * @return {module:model/DsaOptions} The populated <code>DsaOptions</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('subgroup_size')) {
        obj['subgroup_size'] = ApiClient.convertToType(data['subgroup_size'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Specify on Create only. Returned on Get. Size in bits (not bytes) of the DSA subgroup. When `key_size` = 2048, allowed values are 224 or 256. When `key_size` = 3072, allowed value is 256.
   * @member {Number} subgroup_size
   */
  exports.prototype['subgroup_size'] = undefined;



  return exports;
}));


