/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.EllipticCurve = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';


  /**
   * Enum class EllipticCurve.
   * @enum {}
   * @readonly
   */
  var exports = {
    /**
     * value: "SecP192K1"
     * @const
     */
    "SecP192K1": "SecP192K1",
    /**
     * value: "SecP224K1"
     * @const
     */
    "SecP224K1": "SecP224K1",
    /**
     * value: "SecP256K1"
     * @const
     */
    "SecP256K1": "SecP256K1",
    /**
     * value: "NistP192"
     * @const
     */
    "NistP192": "NistP192",
    /**
     * value: "NistP224"
     * @const
     */
    "NistP224": "NistP224",
    /**
     * value: "NistP256"
     * @const
     */
    "NistP256": "NistP256",
    /**
     * value: "NistP384"
     * @const
     */
    "NistP384": "NistP384",
    /**
     * value: "NistP521"
     * @const
     */
    "NistP521": "NistP521",
    /**
     * value: "Gost256A"
     * @const
     */
    "Gost256A": "Gost256A",
    /**
     * value: "Ed25519"
     * @const
     */
    "Ed25519": "Ed25519",
    /**
     * value: "X25519"
     * @const
     */
    "X25519": "X25519",
    /**
     * value: "X448"
     * @const
     */
    "X448": "X448"  };

  /**
   * Returns a <code>EllipticCurve</code> enum value from a Javascript object name.
   * @param {Object} data The plain JavaScript object containing the name of the enum value.
   * @return {module:model/EllipticCurve} The enum <code>EllipticCurve</code> value.
   */
  exports.constructFromObject = function(object) {
    return object;
  }

  return exports;
}));


