/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.EncryptInitResponse = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The EncryptInitResponse model module.
   * @module model/EncryptInitResponse
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>EncryptInitResponse</code>.
   * @alias module:model/EncryptInitResponse
   * @class
   * @param state {Blob} 
   */
  var exports = function(state) {
    var _this = this;



    _this['state'] = state;
  };

  /**
   * Constructs a <code>EncryptInitResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/EncryptInitResponse} obj Optional instance to populate.
   * @return {module:model/EncryptInitResponse} The populated <code>EncryptInitResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('kid')) {
        obj['kid'] = ApiClient.convertToType(data['kid'], 'String');
      }
      if (data.hasOwnProperty('iv')) {
        obj['iv'] = ApiClient.convertToType(data['iv'], 'Blob');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'Blob');
      }
    }
    return obj;
  }

  /**
   * @member {String} kid
   */
  exports.prototype['kid'] = undefined;
  /**
   * The initialiation value used for symmetric encryption. Not returned for asymmetric ciphers.
   * @member {Blob} iv
   */
  exports.prototype['iv'] = undefined;
  /**
   * @member {Blob} state
   */
  exports.prototype['state'] = undefined;



  return exports;
}));


