/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SobjectDescriptor'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SobjectDescriptor'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.EncryptUpdateRequestEx = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.SobjectDescriptor);
  }
}(this, function(ApiClient, SobjectDescriptor) {
  'use strict';




  /**
   * The EncryptUpdateRequestEx model module.
   * @module model/EncryptUpdateRequestEx
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>EncryptUpdateRequestEx</code>.
   * all fields are required
   * @alias module:model/EncryptUpdateRequestEx
   * @class
   * @param key {module:model/SobjectDescriptor} 
   * @param plain {Blob} Plaintext to encrypt.
   * @param state {Blob} 
   */
  var exports = function(key, plain, state) {
    var _this = this;

    _this['key'] = key;
    _this['plain'] = plain;
    _this['state'] = state;
  };

  /**
   * Constructs a <code>EncryptUpdateRequestEx</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/EncryptUpdateRequestEx} obj Optional instance to populate.
   * @return {module:model/EncryptUpdateRequestEx} The populated <code>EncryptUpdateRequestEx</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = SobjectDescriptor.constructFromObject(data['key']);
      }
      if (data.hasOwnProperty('plain')) {
        obj['plain'] = ApiClient.convertToType(data['plain'], 'Blob');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = ApiClient.convertToType(data['state'], 'Blob');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SobjectDescriptor} key
   */
  exports.prototype['key'] = undefined;
  /**
   * Plaintext to encrypt.
   * @member {Blob} plain
   */
  exports.prototype['plain'] = undefined;
  /**
   * @member {Blob} state
   */
  exports.prototype['state'] = undefined;



  return exports;
}));


