/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SobjectComponent'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SobjectComponent'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ExportComponentsResponse = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.SobjectComponent);
  }
}(this, function(ApiClient, SobjectComponent) {
  'use strict';




  /**
   * The ExportComponentsResponse model module.
   * @module model/ExportComponentsResponse
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ExportComponentsResponse</code>.
   * Response of security object export components operation
   * @alias module:model/ExportComponentsResponse
   * @class
   * @param components {Array.<module:model/SobjectComponent>} Components of the Security Object
   * @param keyKcv {Blob} KCV for the entire Security Object
   */
  var exports = function(components, keyKcv) {
    var _this = this;

    _this['components'] = components;
    _this['key_kcv'] = keyKcv;



  };

  /**
   * Constructs a <code>ExportComponentsResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ExportComponentsResponse} obj Optional instance to populate.
   * @return {module:model/ExportComponentsResponse} The populated <code>ExportComponentsResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('components')) {
        obj['components'] = ApiClient.convertToType(data['components'], [SobjectComponent]);
      }
      if (data.hasOwnProperty('key_kcv')) {
        obj['key_kcv'] = ApiClient.convertToType(data['key_kcv'], 'Blob');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('iv')) {
        obj['iv'] = ApiClient.convertToType(data['iv'], 'Blob');
      }
      if (data.hasOwnProperty('tag')) {
        obj['tag'] = ApiClient.convertToType(data['tag'], 'Blob');
      }
    }
    return obj;
  }

  /**
   * Components of the Security Object
   * @member {Array.<module:model/SobjectComponent>} components
   */
  exports.prototype['components'] = undefined;
  /**
   * KCV for the entire Security Object
   * @member {Blob} key_kcv
   */
  exports.prototype['key_kcv'] = undefined;
  /**
   * optional description to the export request
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * For symmetric ciphers, this value will be used for the cipher initialization value. If not provided, SDKMS will generate a random iv and return it in the response. If provided, iv length must match the length required by the cipher and mode. 
   * @member {Blob} iv
   */
  exports.prototype['iv'] = undefined;
  /**
   * For symmetric ciphers with cipher mode GCM or CCM, the authentication tag produced by the cipher. Its length will match the tag length specified by the encryption request. 
   * @member {Blob} tag
   */
  exports.prototype['tag'] = undefined;



  return exports;
}));


