/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CreatorType', 'model/SobjectDescriptor', 'model/SplittingMethod', 'model/WrapKeyParams'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CreatorType'), require('./SobjectDescriptor'), require('./SplittingMethod'), require('./WrapKeyParams'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ExportSobjectComponentsRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.CreatorType, root.FortanixSdkmsRestApi.SobjectDescriptor, root.FortanixSdkmsRestApi.SplittingMethod, root.FortanixSdkmsRestApi.WrapKeyParams);
  }
}(this, function(ApiClient, CreatorType, SobjectDescriptor, SplittingMethod, WrapKeyParams) {
  'use strict';




  /**
   * The ExportSobjectComponentsRequest model module.
   * @module model/ExportSobjectComponentsRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ExportSobjectComponentsRequest</code>.
   * Request to export security object as components
   * @alias module:model/ExportSobjectComponentsRequest
   * @class
   * @param key {module:model/SobjectDescriptor} 
   * @param wrapKeyParams {module:model/WrapKeyParams} 
   * @param custodians {Array.<module:model/CreatorType>} Map from USER or App to its UUIDs
   * @param method {module:model/SplittingMethod} 
   */
  var exports = function(key, wrapKeyParams, custodians, method) {
    var _this = this;

    _this['key'] = key;
    _this['wrap_key_params'] = wrapKeyParams;
    _this['custodians'] = custodians;
    _this['method'] = method;

  };

  /**
   * Constructs a <code>ExportSobjectComponentsRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ExportSobjectComponentsRequest} obj Optional instance to populate.
   * @return {module:model/ExportSobjectComponentsRequest} The populated <code>ExportSobjectComponentsRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = SobjectDescriptor.constructFromObject(data['key']);
      }
      if (data.hasOwnProperty('wrap_key_params')) {
        obj['wrap_key_params'] = WrapKeyParams.constructFromObject(data['wrap_key_params']);
      }
      if (data.hasOwnProperty('custodians')) {
        obj['custodians'] = ApiClient.convertToType(data['custodians'], [CreatorType]);
      }
      if (data.hasOwnProperty('method')) {
        obj['method'] = SplittingMethod.constructFromObject(data['method']);
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SobjectDescriptor} key
   */
  exports.prototype['key'] = undefined;
  /**
   * @member {module:model/WrapKeyParams} wrap_key_params
   */
  exports.prototype['wrap_key_params'] = undefined;
  /**
   * Map from USER or App to its UUIDs
   * @member {Array.<module:model/CreatorType>} custodians
   */
  exports.prototype['custodians'] = undefined;
  /**
   * @member {module:model/SplittingMethod} method
   */
  exports.prototype['method'] = undefined;
  /**
   * description to the export request
   * @member {String} description
   */
  exports.prototype['description'] = undefined;



  return exports;
}));


