/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/FpeConstraints', 'model/FpeDataPart'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./FpeConstraints'), require('./FpeDataPart'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeCompoundPart = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.FpeConstraints, root.FortanixSdkmsRestApi.FpeDataPart);
  }
}(this, function(ApiClient, FpeConstraints, FpeDataPart) {
  'use strict';




  /**
   * The FpeCompoundPart model module.
   * @module model/FpeCompoundPart
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeCompoundPart</code>.
   * Structure of a compound portion of a complex tokenization data type, itself composed of smaller parts. Note that there are three variants here:  - Or -- representing an OR of multiple structures  - Concat -- representing a concatenation of multiple structures  - Multiple -- representing a part possibly repeated multiple times, where the part to be repeated is under the &#x60;multiple&#x60; field  These three variants correspond to the &#x60;or&#x60;, &#x60;concat&#x60;, and &#x60;multiple&#x60; fields, respectively; one of these fields must be specified. It is an error to try to specify more than one variant (e.g., having both an &#x60;or&#x60; and a &#x60;concat&#x60; field).  ***Implementation note: for Or variants, the parser will go in the order of the choices (see description of the &#x60;or&#x60; field below), and for Multiple variants, the parser will try to (locally) match as many repetitions as possible. (See the description of &#x60;FpeDataPart&#x60; for more information about why this matters.)*** 
   * @alias module:model/FpeCompoundPart
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>FpeCompoundPart</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeCompoundPart} obj Optional instance to populate.
   * @return {module:model/FpeCompoundPart} The populated <code>FpeCompoundPart</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('or')) {
        obj['or'] = ApiClient.convertToType(data['or'], [FpeDataPart]);
      }
      if (data.hasOwnProperty('concat')) {
        obj['concat'] = ApiClient.convertToType(data['concat'], [FpeDataPart]);
      }
      if (data.hasOwnProperty('multiple')) {
        obj['multiple'] = FpeDataPart.constructFromObject(data['multiple']);
      }
      if (data.hasOwnProperty('min_repetitions')) {
        obj['min_repetitions'] = ApiClient.convertToType(data['min_repetitions'], 'Number');
      }
      if (data.hasOwnProperty('max_repetitions')) {
        obj['max_repetitions'] = ApiClient.convertToType(data['max_repetitions'], 'Number');
      }
      if (data.hasOwnProperty('constraints')) {
        obj['constraints'] = FpeConstraints.constructFromObject(data['constraints']);
      }
      if (data.hasOwnProperty('preserve')) {
        obj['preserve'] = ApiClient.convertToType(data['preserve'], 'Boolean');
      }
      if (data.hasOwnProperty('mask')) {
        obj['mask'] = ApiClient.convertToType(data['mask'], 'Boolean');
      }
      if (data.hasOwnProperty('min_length')) {
        obj['min_length'] = ApiClient.convertToType(data['min_length'], 'Number');
      }
      if (data.hasOwnProperty('max_length')) {
        obj['max_length'] = ApiClient.convertToType(data['max_length'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Represents an OR of multiple structures. This cannot be specified alongside the `concat` or `multiple` fields.  ***Implementation note: the order of the choices matters, as the parser will pick the first structure that matches. (The parser is locally \"greedy\"; see the description of `FpeDataPart` for more information about why this matters.)*** 
   * @member {Array.<module:model/FpeDataPart>} or
   */
  exports.prototype['or'] = undefined;
  /**
   * Represents a concatentation of multiple structures (in a particular order). This cannot be specified alongside the `or` or `multiple` fields. 
   * @member {Array.<module:model/FpeDataPart>} concat
   */
  exports.prototype['concat'] = undefined;
  /**
   * @member {module:model/FpeDataPart} multiple
   */
  exports.prototype['multiple'] = undefined;
  /**
   * The minimum number of times the subpart can be repeated. This field should only be used if the `multiple` field is being used.
   * @member {Number} min_repetitions
   */
  exports.prototype['min_repetitions'] = undefined;
  /**
   * The maximum number of times the subpart can be repeated. This field should only be used if the `multiple` field is being used.
   * @member {Number} max_repetitions
   */
  exports.prototype['max_repetitions'] = undefined;
  /**
   * @member {module:model/FpeConstraints} constraints
   */
  exports.prototype['constraints'] = undefined;
  /**
   * Whether the entire part should be preserved as-is (i.e., not tokenized). If this is set, any descendant subparts cannot contain any preserve-related fields set. 
   * @member {Boolean} preserve
   */
  exports.prototype['preserve'] = undefined;
  /**
   * Whether the entire part should be masked when doing masked decryption. If this is set, any descendant subparts cannot contain any mask-related fields set. 
   * @member {Boolean} mask
   */
  exports.prototype['mask'] = undefined;
  /**
   * The minimum allowed length for this part (in chars).
   * @member {Number} min_length
   */
  exports.prototype['min_length'] = undefined;
  /**
   * The minimum allowed length for this part (in chars).
   * @member {Number} max_length
   */
  exports.prototype['max_length'] = undefined;



  return exports;
}));


