/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeConstraints = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FpeConstraints model module.
   * @module model/FpeConstraints
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeConstraints</code>.
   * Constraints on a portion of a complex tokenization data type.
   * @alias module:model/FpeConstraints
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>FpeConstraints</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeConstraints} obj Optional instance to populate.
   * @return {module:model/FpeConstraints} The populated <code>FpeConstraints</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('luhn_check')) {
        obj['luhn_check'] = ApiClient.convertToType(data['luhn_check'], 'Boolean');
      }
      if (data.hasOwnProperty('num_gt')) {
        obj['num_gt'] = ApiClient.convertToType(data['num_gt'], 'Number');
      }
      if (data.hasOwnProperty('num_lt')) {
        obj['num_lt'] = ApiClient.convertToType(data['num_lt'], 'Number');
      }
      if (data.hasOwnProperty('num_ne')) {
        obj['num_ne'] = ApiClient.convertToType(data['num_ne'], 'Number');
      }
    }
    return obj;
  }

  /**
   * Whether the token should satisfy the Luhn checksum. It is an error to apply this constraint to non-numeric parts, or for an encrypted part to be under more than one Luhn check constraint. Also, if an encrypted part has a Luhn check constraint applied to it and may contain at least one digit that is not preserved, it must not specify any other constraints. 
   * @member {Boolean} luhn_check
   */
  exports.prototype['luhn_check'] = undefined;
  /**
   * Number that the token part should be greater than. This constraint can only be specified on (non-compound) numeric encrypted parts that are guaranteed to preserve either everything or nothing at all. 
   * @member {Number} num_gt
   */
  exports.prototype['num_gt'] = undefined;
  /**
   * Number that the token part should be smaller than. This constraint can only be specified on (non-compound) numeric encrypted parts that are guaranteed to preserve either everything or nothing at all. 
   * @member {Number} num_lt
   */
  exports.prototype['num_lt'] = undefined;
  /**
   * Numbers that the token part should not be equal to. It is an error to apply this constraint to non-numeric parts.
   * @member {Number} num_ne
   */
  exports.prototype['num_ne'] = undefined;



  return exports;
}));


