/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeConstraintsApplicabilitySubparts = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FpeConstraintsApplicabilitySubparts model module.
   * @module model/FpeConstraintsApplicabilitySubparts
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeConstraintsApplicabilitySubparts</code>.
   * An object representing the individual subparts that the constraints should apply to. This is an object where for each key-value pair, the key represents the (zero-based) \&quot;index\&quot; of the subpart, and the value is either \&quot;all\&quot; or another &#x60;FpeConstraintsApplicabilitySubparts&#x60; instance. Note that a Multiple part only allows for one possible key-value pair, due to it containing only one subpart.  This cannot be used with OR parts; instead, specify constraints individually on each relevant subpart. 
   * @alias module:model/FpeConstraintsApplicabilitySubparts
   * @class
   */
  var exports = function() {
    var _this = this;

  };

  /**
   * Constructs a <code>FpeConstraintsApplicabilitySubparts</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeConstraintsApplicabilitySubparts} obj Optional instance to populate.
   * @return {module:model/FpeConstraintsApplicabilitySubparts} The populated <code>FpeConstraintsApplicabilitySubparts</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

    }
    return obj;
  }




  return exports;
}));


