/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeDataPart = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FpeDataPart model module.
   * @module model/FpeDataPart
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeDataPart</code>.
   * Structure for specifying (part of) a complex tokenization data type, which must be either an &#x60;FpeEncryptedPart&#x60;, &#x60;FpeLiteralPart&#x60;, or an &#x60;FpeCompoundPart&#x60;.  ***Implementation note: the current parser is locally \&quot;greedy\&quot; and does not backtrack if it happens to construct an invalid parse of an input token. The general idea here is that if a section of an input token can be parsed multiple ways, currently, the parser will \&quot;greedily\&quot; pick the first choice that matches, and, if that choice turns out to be problematic, will not go back and consider other choices. (Exactly what the \&quot;first choice\&quot; is depends on the type of the &#x60;FpeDataPart&#x60;; this is described in further detail in the descriptions of the three &#x60;FpeDataPart&#x60; variants.)*** 
   * @alias module:model/FpeDataPart
   * @class
   */
  var exports = function() {
    var _this = this;

  };

  /**
   * Constructs a <code>FpeDataPart</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeDataPart} obj Optional instance to populate.
   * @return {module:model/FpeDataPart} The populated <code>FpeDataPart</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

    }
    return obj;
  }




  return exports;
}));


