/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/FpeDateWithBounds'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./FpeDateWithBounds'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeDate = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.FpeDateWithBounds);
  }
}(this, function(ApiClient, FpeDateWithBounds) {
  'use strict';




  /**
   * The FpeDate model module.
   * @module model/FpeDate
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeDate</code>.
   * A structure for indicating that a token part represents a date. The part should be a concatenation that matches one of the three variants below:  - DayMonthYear date -- contains a Day part and a Month part; this corresponds with the &#x60;dmy_date&#x60; field  - MonthYear date -- contains a Month part and a Year part; this corresponds with the &#x60;month_day_date&#x60; field  - MonthDay date -- contains a Day part, a Month part, and a Year part; this corresponds with the &#x60;month_year_date&#x60; field  (with this constraint applying to those subparts). Notice how each variant above corresponds with a particular field; using the wrong field, or multiple fields, is an error. The individual Month, Day, and/or Year parts that comprise the date cannot appear under Or or the Multiple compound part descendants of the overall Date part (i.e., when applying the date constraint, the \&quot;paths\&quot; from the Date part to the Month, Day, and/or Year parts can only \&quot;go through\&quot; concatenations, and not \&quot;through\&quot; Or or Multiple parts). Those parts also have additional restrictions on how they may be preserved; the exact rules are as such:  - A DayMonthYear date may preserve its Year part, and may preserve both its Month and Day parts at the same time. (The Day    part cannot be preserved if the Month part is not, and vice versa.)  - A MonthDay date cannot preserve only its Month part or only its Day part.  - A MonthYear date may preserve its Year part, but cannot preserve its Month part by itself.   It is an error to \&quot;share\&quot; Day, Month, or Year parts across multiple dates. 
   * @alias module:model/FpeDate
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>FpeDate</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeDate} obj Optional instance to populate.
   * @return {module:model/FpeDate} The populated <code>FpeDate</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('dmy_date')) {
        obj['dmy_date'] = FpeDateWithBounds.constructFromObject(data['dmy_date']);
      }
      if (data.hasOwnProperty('month_day_date')) {
        obj['month_day_date'] = FpeDateWithBounds.constructFromObject(data['month_day_date']);
      }
      if (data.hasOwnProperty('month_year_date')) {
        obj['month_year_date'] = FpeDateWithBounds.constructFromObject(data['month_year_date']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/FpeDateWithBounds} dmy_date
   */
  exports.prototype['dmy_date'] = undefined;
  /**
   * @member {module:model/FpeDateWithBounds} month_day_date
   */
  exports.prototype['month_day_date'] = undefined;
  /**
   * @member {module:model/FpeDateWithBounds} month_year_date
   */
  exports.prototype['month_year_date'] = undefined;



  return exports;
}));


