/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeDateBound = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FpeDateBound model module.
   * @module model/FpeDateBound
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeDateBound</code>.
   * A structure for specifying a particular date, used as an upper or lower bound for date parts. Note that depending on the &#x60;FpeDate&#x60; variant used, the &#x60;day&#x60; or &#x60;year&#x60; fields may be ignored. (For example, a Day-Month date would not require a &#x60;year&#x60; field, so specifying a year in a Day-Month date&#39;s upper bound is meaningless.) 
   * @alias module:model/FpeDateBound
   * @class
   * @param month {Number} The month, which should be a number from 1 to 12.
   */
  var exports = function(month) {
    var _this = this;


    _this['month'] = month;

  };

  /**
   * Constructs a <code>FpeDateBound</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeDateBound} obj Optional instance to populate.
   * @return {module:model/FpeDateBound} The populated <code>FpeDateBound</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('year')) {
        obj['year'] = ApiClient.convertToType(data['year'], 'Number');
      }
      if (data.hasOwnProperty('month')) {
        obj['month'] = ApiClient.convertToType(data['month'], 'Number');
      }
      if (data.hasOwnProperty('day')) {
        obj['day'] = ApiClient.convertToType(data['day'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The year, which should be a number less than 100000. Zero is treated as a leap year.
   * @member {Number} year
   */
  exports.prototype['year'] = undefined;
  /**
   * The month, which should be a number from 1 to 12.
   * @member {Number} month
   */
  exports.prototype['month'] = undefined;
  /**
   * The day, which should be a number from 1 to 31, and must not be out-of-range for the given month. February is considered to be 29 days long, unless the year, if specified, is not a leap year. 
   * @member {Number} day
   */
  exports.prototype['day'] = undefined;



  return exports;
}));


