/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/FpeDateBound'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./FpeDateBound'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeDateWithBounds = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.FpeDateBound);
  }
}(this, function(ApiClient, FpeDateBound) {
  'use strict';




  /**
   * The FpeDateWithBounds model module.
   * @module model/FpeDateWithBounds
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeDateWithBounds</code>.
   * A structure for specifying a date constraint, optionally bounded above (the &#x60;before&#x60; field) and/or below (the &#x60;after&#x60; field). All bounds are exclusive. 
   * @alias module:model/FpeDateWithBounds
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>FpeDateWithBounds</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeDateWithBounds} obj Optional instance to populate.
   * @return {module:model/FpeDateWithBounds} The populated <code>FpeDateWithBounds</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('before')) {
        obj['before'] = FpeDateBound.constructFromObject(data['before']);
      }
      if (data.hasOwnProperty('after')) {
        obj['after'] = FpeDateBound.constructFromObject(data['after']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/FpeDateBound} before
   */
  exports.prototype['before'] = undefined;
  /**
   * @member {module:model/FpeDateBound} after
   */
  exports.prototype['after'] = undefined;



  return exports;
}));


