/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/FpeConstraints'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./FpeConstraints'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeEncryptedPart = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.FpeConstraints);
  }
}(this, function(ApiClient, FpeConstraints) {
  'use strict';




  /**
   * The FpeEncryptedPart model module.
   * @module model/FpeEncryptedPart
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeEncryptedPart</code>.
   * Structure of a simple tokenized portion of a complex tokenization data type.  ***Implementation note: the parser will try to (locally) match as many characters as possible. (See the description of &#x60;FpeDataPart&#x60; for more information about why this matters.)*** 
   * @alias module:model/FpeEncryptedPart
   * @class
   * @param minLength {Number} The minimum allowed length for this part (in chars).
   * @param maxLength {Number} The maximum allowed length for this part (in chars).
   * @param charSet {Array.<Array.<String>>} The character set to use for this part.  Characters should be specified as a list of pairs, where each pair [a, b] (example: ['0', '9']) represents the range of Unicode codepoints from a to b, with both bounds being inclusive. A single character can be represented as [c, c] (example: ['/', '/']).  Ranges should not overlap with each other, and should not contain surrogate codepoints.  *Implementation note: normally, each character is assigned a numeric value for FF1, going in the order specified in the array. For instance, in the character set [['a', 'z'], ['0', '9']], the digits from 0 to 9 DO NOT have their usual numeric values; instead, they correspond to the numerals from 26 to 35 (since they come after the 'a' to 'z' range). Note that for practical purposes, this is largely irrelevant, except when specifying a \"numeric\" character set, which MUST contain exactly the digits from 0 to 9, in order. **(When trying to use numeric constraints, it is best to use [[\"0\", \"9\"]] as the character set.)*** 
   */
  var exports = function(minLength, maxLength, charSet) {
    var _this = this;

    _this['min_length'] = minLength;
    _this['max_length'] = maxLength;
    _this['char_set'] = charSet;

  };

  /**
   * Constructs a <code>FpeEncryptedPart</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeEncryptedPart} obj Optional instance to populate.
   * @return {module:model/FpeEncryptedPart} The populated <code>FpeEncryptedPart</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('min_length')) {
        obj['min_length'] = ApiClient.convertToType(data['min_length'], 'Number');
      }
      if (data.hasOwnProperty('max_length')) {
        obj['max_length'] = ApiClient.convertToType(data['max_length'], 'Number');
      }
      if (data.hasOwnProperty('char_set')) {
        obj['char_set'] = ApiClient.convertToType(data['char_set'], [['String']]);
      }
      if (data.hasOwnProperty('constraints')) {
        obj['constraints'] = FpeConstraints.constructFromObject(data['constraints']);
      }
    }
    return obj;
  }

  /**
   * The minimum allowed length for this part (in chars).
   * @member {Number} min_length
   */
  exports.prototype['min_length'] = undefined;
  /**
   * The maximum allowed length for this part (in chars).
   * @member {Number} max_length
   */
  exports.prototype['max_length'] = undefined;
  /**
   * The character set to use for this part.  Characters should be specified as a list of pairs, where each pair [a, b] (example: ['0', '9']) represents the range of Unicode codepoints from a to b, with both bounds being inclusive. A single character can be represented as [c, c] (example: ['/', '/']).  Ranges should not overlap with each other, and should not contain surrogate codepoints.  *Implementation note: normally, each character is assigned a numeric value for FF1, going in the order specified in the array. For instance, in the character set [['a', 'z'], ['0', '9']], the digits from 0 to 9 DO NOT have their usual numeric values; instead, they correspond to the numerals from 26 to 35 (since they come after the 'a' to 'z' range). Note that for practical purposes, this is largely irrelevant, except when specifying a \"numeric\" character set, which MUST contain exactly the digits from 0 to 9, in order. **(When trying to use numeric constraints, it is best to use [[\"0\", \"9\"]] as the character set.)*** 
   * @member {Array.<Array.<String>>} char_set
   */
  exports.prototype['char_set'] = undefined;
  /**
   * @member {module:model/FpeConstraints} constraints
   */
  exports.prototype['constraints'] = undefined;



  return exports;
}));


