/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeLiteralPart = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FpeLiteralPart model module.
   * @module model/FpeLiteralPart
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeLiteralPart</code>.
   * A literal section of a complex tokenization data type, such as a delimiter. 
   * @alias module:model/FpeLiteralPart
   * @class
   * @param literal {Array.<String>} The list of possible strings that make up this literal portion of the token.  ***Implementation note: the order of the strings matters, as the parser will pick the first string that matches. (See the description of `FpeDataPart` for more information about why this matters.)*** 
   */
  var exports = function(literal) {
    var _this = this;

    _this['literal'] = literal;
  };

  /**
   * Constructs a <code>FpeLiteralPart</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeLiteralPart} obj Optional instance to populate.
   * @return {module:model/FpeLiteralPart} The populated <code>FpeLiteralPart</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('literal')) {
        obj['literal'] = ApiClient.convertToType(data['literal'], ['String']);
      }
    }
    return obj;
  }

  /**
   * The list of possible strings that make up this literal portion of the token.  ***Implementation note: the order of the strings matters, as the parser will pick the first string that matches. (See the description of `FpeDataPart` for more information about why this matters.)*** 
   * @member {Array.<String>} literal
   */
  exports.prototype['literal'] = undefined;



  return exports;
}));


