/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/FpeDataPart'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./FpeDataPart'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeOptionsAdvanced = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.FpeDataPart);
  }
}(this, function(ApiClient, FpeDataPart) {
  'use strict';




  /**
   * The FpeOptionsAdvanced model module.
   * @module model/FpeOptionsAdvanced
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeOptionsAdvanced</code>.
   * Information about a complex tokenization data type.
   * @alias module:model/FpeOptionsAdvanced
   * @class
   * @param format {module:model/FpeDataPart} 
   */
  var exports = function(format) {
    var _this = this;

    _this['format'] = format;


  };

  /**
   * Constructs a <code>FpeOptionsAdvanced</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeOptionsAdvanced} obj Optional instance to populate.
   * @return {module:model/FpeOptionsAdvanced} The populated <code>FpeOptionsAdvanced</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('format')) {
        obj['format'] = FpeDataPart.constructFromObject(data['format']);
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/FpeDataPart} format
   */
  exports.prototype['format'] = undefined;
  /**
   * The user-friendly name for the data type that represents the input data.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * A duplicate of the `description` field. This field is read-only and cannot be assigned. Thus, when specifying a new `SobjectRequest`, this field should not be used. 
   * @member {String} name
   */
  exports.prototype['name'] = undefined;



  return exports;
}));


