/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.FpeOptionsBasic = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The FpeOptionsBasic model module.
   * @module model/FpeOptionsBasic
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>FpeOptionsBasic</code>.
   * Basic FPE-specific options.
   * @alias module:model/FpeOptionsBasic
   * @class
   * @param radix {Number} The base for input data. The radix should be a number from 2 to 36, inclusive. Each radix corresponds to a subset of ASCII alphanumeric characters (with all letters being uppercase). For instance, a radix of 10 corresponds to a character set consisting of the digits from 0 to 9, while a character set of 16 corresponds to a character set consisting of all hexadecimal digits (with letters A-F being uppercase). 
   */
  var exports = function(radix) {
    var _this = this;

    _this['radix'] = radix;






  };

  /**
   * Constructs a <code>FpeOptionsBasic</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/FpeOptionsBasic} obj Optional instance to populate.
   * @return {module:model/FpeOptionsBasic} The populated <code>FpeOptionsBasic</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('radix')) {
        obj['radix'] = ApiClient.convertToType(data['radix'], 'Number');
      }
      if (data.hasOwnProperty('min_length')) {
        obj['min_length'] = ApiClient.convertToType(data['min_length'], 'Number');
      }
      if (data.hasOwnProperty('max_length')) {
        obj['max_length'] = ApiClient.convertToType(data['max_length'], 'Number');
      }
      if (data.hasOwnProperty('preserve')) {
        obj['preserve'] = ApiClient.convertToType(data['preserve'], ['Number']);
      }
      if (data.hasOwnProperty('mask')) {
        obj['mask'] = ApiClient.convertToType(data['mask'], ['Number']);
      }
      if (data.hasOwnProperty('luhn_check')) {
        obj['luhn_check'] = ApiClient.convertToType(data['luhn_check'], 'Boolean');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
    }
    return obj;
  }

  /**
   * The base for input data. The radix should be a number from 2 to 36, inclusive. Each radix corresponds to a subset of ASCII alphanumeric characters (with all letters being uppercase). For instance, a radix of 10 corresponds to a character set consisting of the digits from 0 to 9, while a character set of 16 corresponds to a character set consisting of all hexadecimal digits (with letters A-F being uppercase). 
   * @member {Number} radix
   */
  exports.prototype['radix'] = undefined;
  /**
   * The minimum allowed length for the input data. If not specified, as a default, the min length will be set to the smallest value that allows the condition radix^min_length >= 100 to be satisfied.
   * @member {Number} min_length
   */
  exports.prototype['min_length'] = undefined;
  /**
   * The maximum allowed length for the input data. If not specified, a default max length of 2^16 will be used.
   * @member {Number} max_length
   */
  exports.prototype['max_length'] = undefined;
  /**
   * The list of indices of characters to be preserved while performing encryption/decryption. Indices are Python-like, where negative indices index from the back of the token, with -1 referring to the end of the token. It is an error to specify indices greater than (min_length - 1) or less than (-min_length). 
   * @member {Array.<Number>} preserve
   */
  exports.prototype['preserve'] = undefined;
  /**
   * The list of indices of characters to be masked while performing masked decryption. Indices are Python-like, where negative indices index from the back of the token, with -1 referring to the end of the token. It is an error to specify indices greater than (min_length - 1) or less than (-min_length). 
   * @member {Array.<Number>} mask
   */
  exports.prototype['mask'] = undefined;
  /**
   * Whether encrypted/decrypted data should satisfy LUHN checksum formula.
   * @member {Boolean} luhn_check
   */
  exports.prototype['luhn_check'] = undefined;
  /**
   * The user-friendly name for the data type that represents the input data.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;



  return exports;
}));


