/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.GoogleServiceAccountKey = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The GoogleServiceAccountKey model module.
   * @module model/GoogleServiceAccountKey
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>GoogleServiceAccountKey</code>.
   * A Google service account key object. See https://cloud.google.com/video-intelligence/docs/common/auth.
   * @alias module:model/GoogleServiceAccountKey
   * @class
   * @param type {String} Must be \"service_account\"
   * @param projectId {String} 
   * @param privateKeyId {String} 
   * @param clientEmail {String} 
   */
  var exports = function(type, projectId, privateKeyId, clientEmail) {
    var _this = this;

    _this['type'] = type;
    _this['project_id'] = projectId;
    _this['private_key_id'] = privateKeyId;

    _this['client_email'] = clientEmail;
  };

  /**
   * Constructs a <code>GoogleServiceAccountKey</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/GoogleServiceAccountKey} obj Optional instance to populate.
   * @return {module:model/GoogleServiceAccountKey} The populated <code>GoogleServiceAccountKey</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('type')) {
        obj['type'] = ApiClient.convertToType(data['type'], 'String');
      }
      if (data.hasOwnProperty('project_id')) {
        obj['project_id'] = ApiClient.convertToType(data['project_id'], 'String');
      }
      if (data.hasOwnProperty('private_key_id')) {
        obj['private_key_id'] = ApiClient.convertToType(data['private_key_id'], 'String');
      }
      if (data.hasOwnProperty('private_key')) {
        obj['private_key'] = ApiClient.convertToType(data['private_key'], 'String');
      }
      if (data.hasOwnProperty('client_email')) {
        obj['client_email'] = ApiClient.convertToType(data['client_email'], 'String');
      }
    }
    return obj;
  }

  /**
   * Must be \"service_account\"
   * @member {String} type
   */
  exports.prototype['type'] = undefined;
  /**
   * @member {String} project_id
   */
  exports.prototype['project_id'] = undefined;
  /**
   * @member {String} private_key_id
   */
  exports.prototype['private_key_id'] = undefined;
  /**
   * @member {String} private_key
   */
  exports.prototype['private_key'] = undefined;
  /**
   * @member {String} client_email
   */
  exports.prototype['client_email'] = undefined;



  return exports;
}));


