/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/HmgConfig', 'model/KeyUndoPolicy'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./HmgConfig'), require('./KeyUndoPolicy'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.GroupRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.HmgConfig, root.FortanixSdkmsRestApi.KeyUndoPolicy);
  }
}(this, function(ApiClient, HmgConfig, KeyUndoPolicy) {
  'use strict';




  /**
   * The GroupRequest model module.
   * @module model/GroupRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>GroupRequest</code>.
   * @alias module:model/GroupRequest
   * @class
   * @param name {String} Name of the group. Group names must be unique within an account.
   */
  var exports = function(name) {
    var _this = this;

    _this['name'] = name;






  };

  /**
   * Constructs a <code>GroupRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/GroupRequest} obj Optional instance to populate.
   * @return {module:model/GroupRequest} The populated <code>GroupRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('acct_id')) {
        obj['acct_id'] = ApiClient.convertToType(data['acct_id'], 'String');
      }
      if (data.hasOwnProperty('add_hmg')) {
        obj['add_hmg'] = ApiClient.convertToType(data['add_hmg'], [HmgConfig]);
      }
      if (data.hasOwnProperty('mod_hmg')) {
        obj['mod_hmg'] = ApiClient.convertToType(data['mod_hmg'], {'String': HmgConfig});
      }
      if (data.hasOwnProperty('del_hmg')) {
        obj['del_hmg'] = ApiClient.convertToType(data['del_hmg'], ['String']);
      }
      if (data.hasOwnProperty('key_undo_policy')) {
        obj['key_undo_policy'] = KeyUndoPolicy.constructFromObject(data['key_undo_policy']);
      }
    }
    return obj;
  }

  /**
   * Name of the group. Group names must be unique within an account.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the group.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Account ID of the account the new group will belong to.
   * @member {String} acct_id
   */
  exports.prototype['acct_id'] = undefined;
  /**
   * List of HmgConfig objects to add
   * @member {Array.<module:model/HmgConfig>} add_hmg
   */
  exports.prototype['add_hmg'] = undefined;
  /**
   * Map from UUIDs to HmgConfig objects to update
   * @member {Object.<String, module:model/HmgConfig>} mod_hmg
   */
  exports.prototype['mod_hmg'] = undefined;
  /**
   * List of HmgConfig UUIDs to delete
   * @member {Array.<String>} del_hmg
   */
  exports.prototype['del_hmg'] = undefined;
  /**
   * @member {module:model/KeyUndoPolicy} key_undo_policy
   */
  exports.prototype['key_undo_policy'] = undefined;



  return exports;
}));


