/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/HistoryItemState'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./HistoryItemState'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.HistoryItem = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.HistoryItemState);
  }
}(this, function(ApiClient, HistoryItemState) {
  'use strict';




  /**
   * The HistoryItem model module.
   * @module model/HistoryItem
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>HistoryItem</code>.
   * @alias module:model/HistoryItem
   * @class
   */
  var exports = function() {
    var _this = this;





  };

  /**
   * Constructs a <code>HistoryItem</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/HistoryItem} obj Optional instance to populate.
   * @return {module:model/HistoryItem} The populated <code>HistoryItem</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('id')) {
        obj['id'] = ApiClient.convertToType(data['id'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = HistoryItemState.constructFromObject(data['state']);
      }
      if (data.hasOwnProperty('created_at')) {
        obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
      }
      if (data.hasOwnProperty('expiry')) {
        obj['expiry'] = ApiClient.convertToType(data['expiry'], 'String');
      }
    }
    return obj;
  }

  /**
   * History item ID uniquely identifying this history item
   * @member {String} id
   */
  exports.prototype['id'] = undefined;
  /**
   * @member {module:model/HistoryItemState} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Date and time this history item was created
   * @member {String} created_at
   */
  exports.prototype['created_at'] = undefined;
  /**
   * Date and time this history item will expire. KeyObjects cannot be reverted to expired history items.
   * @member {String} expiry
   */
  exports.prototype['expiry'] = undefined;



  return exports;
}));


