/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/KeyObjectState', 'model/KeyOperations', 'model/RevocationReasonCode', 'model/RotationPolicy'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./KeyObjectState'), require('./KeyOperations'), require('./RevocationReasonCode'), require('./RotationPolicy'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.HistoryItemState = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.KeyObjectState, root.FortanixSdkmsRestApi.KeyOperations, root.FortanixSdkmsRestApi.RevocationReasonCode, root.FortanixSdkmsRestApi.RotationPolicy);
  }
}(this, function(ApiClient, KeyObjectState, KeyOperations, RevocationReasonCode, RotationPolicy) {
  'use strict';




  /**
   * The HistoryItemState model module.
   * @module model/HistoryItemState
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>HistoryItemState</code>.
   * @alias module:model/HistoryItemState
   * @class
   */
  var exports = function() {
    var _this = this;











  };

  /**
   * Constructs a <code>HistoryItemState</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/HistoryItemState} obj Optional instance to populate.
   * @return {module:model/HistoryItemState} The populated <code>HistoryItemState</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('activation_date')) {
        obj['activation_date'] = ApiClient.convertToType(data['activation_date'], 'String');
      }
      if (data.hasOwnProperty('revocation_reason')) {
        obj['revocation_reason'] = RevocationReasonCode.constructFromObject(data['revocation_reason']);
      }
      if (data.hasOwnProperty('compromise_date')) {
        obj['compromise_date'] = ApiClient.convertToType(data['compromise_date'], 'String');
      }
      if (data.hasOwnProperty('deactivation_date')) {
        obj['deactivation_date'] = ApiClient.convertToType(data['deactivation_date'], 'String');
      }
      if (data.hasOwnProperty('destruction_date')) {
        obj['destruction_date'] = ApiClient.convertToType(data['destruction_date'], 'String');
      }
      if (data.hasOwnProperty('deletion_date')) {
        obj['deletion_date'] = ApiClient.convertToType(data['deletion_date'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = KeyObjectState.constructFromObject(data['state']);
      }
      if (data.hasOwnProperty('key_ops')) {
        obj['key_ops'] = ApiClient.convertToType(data['key_ops'], [KeyOperations]);
      }
      if (data.hasOwnProperty('public_only')) {
        obj['public_only'] = ApiClient.convertToType(data['public_only'], 'Boolean');
      }
      if (data.hasOwnProperty('rotation_policy')) {
        obj['rotation_policy'] = RotationPolicy.constructFromObject(data['rotation_policy']);
      }
    }
    return obj;
  }

  /**
   * When this KeyObject will become active
   * @member {String} activation_date
   */
  exports.prototype['activation_date'] = undefined;
  /**
   * @member {module:model/RevocationReasonCode} revocation_reason
   */
  exports.prototype['revocation_reason'] = undefined;
  /**
   * When this security object was compromised.
   * @member {String} compromise_date
   */
  exports.prototype['compromise_date'] = undefined;
  /**
   * When this security object was deactivated
   * @member {String} deactivation_date
   */
  exports.prototype['deactivation_date'] = undefined;
  /**
   * When this security object was destroyed
   * @member {String} destruction_date
   */
  exports.prototype['destruction_date'] = undefined;
  /**
   * When the security object was deleted
   * @member {String} deletion_date
   */
  exports.prototype['deletion_date'] = undefined;
  /**
   * @member {module:model/KeyObjectState} state
   */
  exports.prototype['state'] = undefined;
  /**
   * Array of key operations enabled for this security object. 
   * @member {Array.<module:model/KeyOperations>} key_ops
   */
  exports.prototype['key_ops'] = undefined;
  /**
   * Whether the key object contains only a public part
   * @member {Boolean} public_only
   */
  exports.prototype['public_only'] = undefined;
  /**
   * @member {module:model/RotationPolicy} rotation_policy
   */
  exports.prototype['rotation_policy'] = undefined;



  return exports;
}));


