/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/HmgKind', 'model/TlsConfig'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./HmgKind'), require('./TlsConfig'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.HmgConfig = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.HmgKind, root.FortanixSdkmsRestApi.TlsConfig);
  }
}(this, function(ApiClient, HmgKind, TlsConfig) {
  'use strict';




  /**
   * The HmgConfig model module.
   * @module model/HmgConfig
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>HmgConfig</code>.
   * Configuration for an external key store
   * @alias module:model/HmgConfig
   * @class
   * @param kind {module:model/HmgKind} 
   * @param url {String} 
   * @param tls {module:model/TlsConfig} 
   */
  var exports = function(kind, url, tls) {
    var _this = this;

    _this['kind'] = kind;
    _this['url'] = url;
    _this['tls'] = tls;








  };

  /**
   * Constructs a <code>HmgConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/HmgConfig} obj Optional instance to populate.
   * @return {module:model/HmgConfig} The populated <code>HmgConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('kind')) {
        obj['kind'] = HmgKind.constructFromObject(data['kind']);
      }
      if (data.hasOwnProperty('url')) {
        obj['url'] = ApiClient.convertToType(data['url'], 'String');
      }
      if (data.hasOwnProperty('tls')) {
        obj['tls'] = TlsConfig.constructFromObject(data['tls']);
      }
      if (data.hasOwnProperty('pin')) {
        obj['pin'] = ApiClient.convertToType(data['pin'], 'String');
      }
      if (data.hasOwnProperty('slot')) {
        obj['slot'] = ApiClient.convertToType(data['slot'], 'Number');
      }
      if (data.hasOwnProperty('access_key')) {
        obj['access_key'] = ApiClient.convertToType(data['access_key'], 'String');
      }
      if (data.hasOwnProperty('secret_key')) {
        obj['secret_key'] = ApiClient.convertToType(data['secret_key'], 'String');
      }
      if (data.hasOwnProperty('hsm_order')) {
        obj['hsm_order'] = ApiClient.convertToType(data['hsm_order'], 'Number');
      }
      if (data.hasOwnProperty('tenant_id')) {
        obj['tenant_id'] = ApiClient.convertToType(data['tenant_id'], 'String');
      }
      if (data.hasOwnProperty('client_id')) {
        obj['client_id'] = ApiClient.convertToType(data['client_id'], 'String');
      }
      if (data.hasOwnProperty('subscription_id')) {
        obj['subscription_id'] = ApiClient.convertToType(data['subscription_id'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/HmgKind} kind
   */
  exports.prototype['kind'] = undefined;
  /**
   * @member {String} url
   */
  exports.prototype['url'] = undefined;
  /**
   * @member {module:model/TlsConfig} tls
   */
  exports.prototype['tls'] = undefined;
  /**
   * @member {String} pin
   */
  exports.prototype['pin'] = undefined;
  /**
   * @member {Number} slot
   */
  exports.prototype['slot'] = undefined;
  /**
   * @member {String} access_key
   */
  exports.prototype['access_key'] = undefined;
  /**
   * @member {String} secret_key
   */
  exports.prototype['secret_key'] = undefined;
  /**
   * @member {Number} hsm_order
   */
  exports.prototype['hsm_order'] = undefined;
  /**
   * @member {String} tenant_id
   */
  exports.prototype['tenant_id'] = undefined;
  /**
   * @member {String} client_id
   */
  exports.prototype['client_id'] = undefined;
  /**
   * @member {String} subscription_id
   */
  exports.prototype['subscription_id'] = undefined;



  return exports;
}));


