/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CreatorType', 'model/SobjectComponent', 'model/SobjectRequest', 'model/SplittingMethod', 'model/UnwrapKeyParams'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CreatorType'), require('./SobjectComponent'), require('./SobjectRequest'), require('./SplittingMethod'), require('./UnwrapKeyParams'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ImportSobjectComponentsRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.CreatorType, root.FortanixSdkmsRestApi.SobjectComponent, root.FortanixSdkmsRestApi.SobjectRequest, root.FortanixSdkmsRestApi.SplittingMethod, root.FortanixSdkmsRestApi.UnwrapKeyParams);
  }
}(this, function(ApiClient, CreatorType, SobjectComponent, SobjectRequest, SplittingMethod, UnwrapKeyParams) {
  'use strict';




  /**
   * The ImportSobjectComponentsRequest model module.
   * @module model/ImportSobjectComponentsRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ImportSobjectComponentsRequest</code>.
   * Request body to import security objcet components
   * @alias module:model/ImportSobjectComponentsRequest
   * @class
   * @param key {module:model/SobjectRequest} 
   * @param unwrapKeyParams {module:model/UnwrapKeyParams} 
   * @param custodians {Array.<module:model/CreatorType>} Map from USER or App to its UUIDs
   * @param components {Array.<module:model/SobjectComponent>} An array of Security Object components
   * @param method {module:model/SplittingMethod} 
   */
  var exports = function(key, unwrapKeyParams, custodians, components, method) {
    var _this = this;

    _this['key'] = key;
    _this['unwrap_key_params'] = unwrapKeyParams;
    _this['custodians'] = custodians;
    _this['components'] = components;

    _this['method'] = method;
  };

  /**
   * Constructs a <code>ImportSobjectComponentsRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ImportSobjectComponentsRequest} obj Optional instance to populate.
   * @return {module:model/ImportSobjectComponentsRequest} The populated <code>ImportSobjectComponentsRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = SobjectRequest.constructFromObject(data['key']);
      }
      if (data.hasOwnProperty('unwrap_key_params')) {
        obj['unwrap_key_params'] = UnwrapKeyParams.constructFromObject(data['unwrap_key_params']);
      }
      if (data.hasOwnProperty('custodians')) {
        obj['custodians'] = ApiClient.convertToType(data['custodians'], [CreatorType]);
      }
      if (data.hasOwnProperty('components')) {
        obj['components'] = ApiClient.convertToType(data['components'], [SobjectComponent]);
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('method')) {
        obj['method'] = SplittingMethod.constructFromObject(data['method']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SobjectRequest} key
   */
  exports.prototype['key'] = undefined;
  /**
   * @member {module:model/UnwrapKeyParams} unwrap_key_params
   */
  exports.prototype['unwrap_key_params'] = undefined;
  /**
   * Map from USER or App to its UUIDs
   * @member {Array.<module:model/CreatorType>} custodians
   */
  exports.prototype['custodians'] = undefined;
  /**
   * An array of Security Object components
   * @member {Array.<module:model/SobjectComponent>} components
   */
  exports.prototype['components'] = undefined;
  /**
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * @member {module:model/SplittingMethod} method
   */
  exports.prototype['method'] = undefined;



  return exports;
}));


