/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CreatorType', 'model/EllipticCurve', 'model/HistoryItem', 'model/KeyObjectState', 'model/KeyOperations', 'model/ObjectOrigin', 'model/ObjectType', 'model/RsaOptions'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CreatorType'), require('./EllipticCurve'), require('./HistoryItem'), require('./KeyObjectState'), require('./KeyOperations'), require('./ObjectOrigin'), require('./ObjectType'), require('./RsaOptions'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.KeyObject = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.CreatorType, root.FortanixSdkmsRestApi.EllipticCurve, root.FortanixSdkmsRestApi.HistoryItem, root.FortanixSdkmsRestApi.KeyObjectState, root.FortanixSdkmsRestApi.KeyOperations, root.FortanixSdkmsRestApi.ObjectOrigin, root.FortanixSdkmsRestApi.ObjectType, root.FortanixSdkmsRestApi.RsaOptions);
  }
}(this, function(ApiClient, CreatorType, EllipticCurve, HistoryItem, KeyObjectState, KeyOperations, ObjectOrigin, ObjectType, RsaOptions) {
  'use strict';




  /**
   * The KeyObject model module.
   * @module model/KeyObject
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>KeyObject</code>.
   * @alias module:model/KeyObject
   * @class
   * @param name {String} Name of the security object.
   * @param acctId {String} Account ID of the account this security object belongs to.
   * @param creator {module:model/CreatorType} 
   * @param objType {module:model/ObjectType} 
   * @param origin {module:model/ObjectOrigin} 
   * @param enabled {Boolean} Whether this security object has cryptographic operations enabled.
   * @param createdAt {String} When this security object was created.
   * @param lastusedAt {String} When this security object was last used.
   * @param neverExportable {Boolean} True if this key's operations have never contained EXPORT.
   */
  var exports = function(name, acctId, creator, objType, origin, enabled, createdAt, lastusedAt, neverExportable) {
    var _this = this;

    _this['name'] = name;



    _this['acct_id'] = acctId;

    _this['creator'] = creator;

    _this['obj_type'] = objType;


    _this['origin'] = origin;


    _this['enabled'] = enabled;

    _this['created_at'] = createdAt;
    _this['lastused_at'] = lastusedAt;

    _this['never_exportable'] = neverExportable;




  };

  /**
   * Constructs a <code>KeyObject</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/KeyObject} obj Optional instance to populate.
   * @return {module:model/KeyObject} The populated <code>KeyObject</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('key_size')) {
        obj['key_size'] = ApiClient.convertToType(data['key_size'], 'Number');
      }
      if (data.hasOwnProperty('elliptic_curve')) {
        obj['elliptic_curve'] = EllipticCurve.constructFromObject(data['elliptic_curve']);
      }
      if (data.hasOwnProperty('acct_id')) {
        obj['acct_id'] = ApiClient.convertToType(data['acct_id'], 'String');
      }
      if (data.hasOwnProperty('group_id')) {
        obj['group_id'] = ApiClient.convertToType(data['group_id'], 'String');
      }
      if (data.hasOwnProperty('creator')) {
        obj['creator'] = CreatorType.constructFromObject(data['creator']);
      }
      if (data.hasOwnProperty('kid')) {
        obj['kid'] = ApiClient.convertToType(data['kid'], 'String');
      }
      if (data.hasOwnProperty('obj_type')) {
        obj['obj_type'] = ObjectType.constructFromObject(data['obj_type']);
      }
      if (data.hasOwnProperty('key_ops')) {
        obj['key_ops'] = ApiClient.convertToType(data['key_ops'], [KeyOperations]);
      }
      if (data.hasOwnProperty('custom_metadata')) {
        obj['custom_metadata'] = ApiClient.convertToType(data['custom_metadata'], {'String': 'String'});
      }
      if (data.hasOwnProperty('origin')) {
        obj['origin'] = ObjectOrigin.constructFromObject(data['origin']);
      }
      if (data.hasOwnProperty('pub_key')) {
        obj['pub_key'] = ApiClient.convertToType(data['pub_key'], 'Blob');
      }
      if (data.hasOwnProperty('value')) {
        obj['value'] = ApiClient.convertToType(data['value'], 'Blob');
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('compliant_with_policies')) {
        obj['compliant_with_policies'] = ApiClient.convertToType(data['compliant_with_policies'], 'Boolean');
      }
      if (data.hasOwnProperty('created_at')) {
        obj['created_at'] = ApiClient.convertToType(data['created_at'], 'String');
      }
      if (data.hasOwnProperty('lastused_at')) {
        obj['lastused_at'] = ApiClient.convertToType(data['lastused_at'], 'String');
      }
      if (data.hasOwnProperty('transient_key')) {
        obj['transient_key'] = ApiClient.convertToType(data['transient_key'], 'String');
      }
      if (data.hasOwnProperty('never_exportable')) {
        obj['never_exportable'] = ApiClient.convertToType(data['never_exportable'], 'Boolean');
      }
      if (data.hasOwnProperty('rsa')) {
        obj['rsa'] = RsaOptions.constructFromObject(data['rsa']);
      }
      if (data.hasOwnProperty('kcv')) {
        obj['kcv'] = ApiClient.convertToType(data['kcv'], 'String');
      }
      if (data.hasOwnProperty('state')) {
        obj['state'] = KeyObjectState.constructFromObject(data['state']);
      }
      if (data.hasOwnProperty('history')) {
        obj['history'] = ApiClient.convertToType(data['history'], [HistoryItem]);
      }
    }
    return obj;
  }

  /**
   * Name of the security object.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the security object.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * For objects which are not elliptic curves, this is the size in bits (not bytes) of the object. This field is not returned for elliptic curves. 
   * @member {Number} key_size
   */
  exports.prototype['key_size'] = undefined;
  /**
   * @member {module:model/EllipticCurve} elliptic_curve
   */
  exports.prototype['elliptic_curve'] = undefined;
  /**
   * Account ID of the account this security object belongs to.
   * @member {String} acct_id
   */
  exports.prototype['acct_id'] = undefined;
  /**
   * Group ID of the security group that this security object belongs to.
   * @member {String} group_id
   */
  exports.prototype['group_id'] = undefined;
  /**
   * @member {module:model/CreatorType} creator
   */
  exports.prototype['creator'] = undefined;
  /**
   * Key ID uniquely identifying this security object.
   * @member {String} kid
   */
  exports.prototype['kid'] = undefined;
  /**
   * @member {module:model/ObjectType} obj_type
   */
  exports.prototype['obj_type'] = undefined;
  /**
   * Array of key operations enabled for this security object. 
   * @member {Array.<module:model/KeyOperations>} key_ops
   */
  exports.prototype['key_ops'] = undefined;
  /**
   * User-defined metadata for this key. Stored as key-value pairs.
   * @member {Object.<String, String>} custom_metadata
   */
  exports.prototype['custom_metadata'] = undefined;
  /**
   * @member {module:model/ObjectOrigin} origin
   */
  exports.prototype['origin'] = undefined;
  /**
   * This field is returned only for asymmetric keys. It contains the public key.
   * @member {Blob} pub_key
   */
  exports.prototype['pub_key'] = undefined;
  /**
   * This field is returned only for opaque and secret objects. It contains the contents of the object.
   * @member {Blob} value
   */
  exports.prototype['value'] = undefined;
  /**
   * Whether this security object has cryptographic operations enabled.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * Whether this security object is compliant with cryptographic policies or not.
   * @member {Boolean} compliant_with_policies
   */
  exports.prototype['compliant_with_policies'] = undefined;
  /**
   * When this security object was created.
   * @member {String} created_at
   */
  exports.prototype['created_at'] = undefined;
  /**
   * When this security object was last used.
   * @member {String} lastused_at
   */
  exports.prototype['lastused_at'] = undefined;
  /**
   * Transient key blob.
   * @member {String} transient_key
   */
  exports.prototype['transient_key'] = undefined;
  /**
   * True if this key's operations have never contained EXPORT.
   * @member {Boolean} never_exportable
   */
  exports.prototype['never_exportable'] = undefined;
  /**
   * @member {module:model/RsaOptions} rsa
   */
  exports.prototype['rsa'] = undefined;
  /**
   * KCV for the Security Object
   * @member {String} kcv
   */
  exports.prototype['kcv'] = undefined;
  /**
   * @member {module:model/KeyObjectState} state
   */
  exports.prototype['state'] = undefined;
  /**
   * When a Key Undo Policy is in place, a list of (non-expired) history items is returned. Each history item represents a passed key state that can be reverted to.
   * @member {Array.<module:model/HistoryItem>} history
   */
  exports.prototype['history'] = undefined;



  return exports;
}));


