/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.KeyUndoPolicy = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The KeyUndoPolicy model module.
   * @module model/KeyUndoPolicy
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>KeyUndoPolicy</code>.
   * A policy to revert operations done inadvertently
   * @alias module:model/KeyUndoPolicy
   * @class
   * @param undoTimeWindow {Number} The time window in seconds operations can be reverted
   */
  var exports = function(undoTimeWindow) {
    var _this = this;

    _this['undo_time_window'] = undoTimeWindow;
  };

  /**
   * Constructs a <code>KeyUndoPolicy</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/KeyUndoPolicy} obj Optional instance to populate.
   * @return {module:model/KeyUndoPolicy} The populated <code>KeyUndoPolicy</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('undo_time_window')) {
        obj['undo_time_window'] = ApiClient.convertToType(data['undo_time_window'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The time window in seconds operations can be reverted
   * @member {Number} undo_time_window
   */
  exports.prototype['undo_time_window'] = undefined;



  return exports;
}));


