/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SplunkLoggingConfigRequest', 'model/StackdriverLoggingConfigRequest'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SplunkLoggingConfigRequest'), require('./StackdriverLoggingConfigRequest'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.LoggingConfigRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.SplunkLoggingConfigRequest, root.FortanixSdkmsRestApi.StackdriverLoggingConfigRequest);
  }
}(this, function(ApiClient, SplunkLoggingConfigRequest, StackdriverLoggingConfigRequest) {
  'use strict';




  /**
   * The LoggingConfigRequest model module.
   * @module model/LoggingConfigRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>LoggingConfigRequest</code>.
   * @alias module:model/LoggingConfigRequest
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>LoggingConfigRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/LoggingConfigRequest} obj Optional instance to populate.
   * @return {module:model/LoggingConfigRequest} The populated <code>LoggingConfigRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('splunk')) {
        obj['splunk'] = SplunkLoggingConfigRequest.constructFromObject(data['splunk']);
      }
      if (data.hasOwnProperty('stackdriver')) {
        obj['stackdriver'] = StackdriverLoggingConfigRequest.constructFromObject(data['stackdriver']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SplunkLoggingConfigRequest} splunk
   */
  exports.prototype['splunk'] = undefined;
  /**
   * @member {module:model/StackdriverLoggingConfigRequest} stackdriver
   */
  exports.prototype['stackdriver'] = undefined;



  return exports;
}));


