/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.MacGenerateResponse = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The MacGenerateResponse model module.
   * @module model/MacGenerateResponse
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>MacGenerateResponse</code>.
   * @alias module:model/MacGenerateResponse
   * @class
   * @param mac {Blob} The MAC generated for the input data (returned for CMAC operation).
   */
  var exports = function(mac) {
    var _this = this;



    _this['mac'] = mac;
  };

  /**
   * Constructs a <code>MacGenerateResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MacGenerateResponse} obj Optional instance to populate.
   * @return {module:model/MacGenerateResponse} The populated <code>MacGenerateResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('kid')) {
        obj['kid'] = ApiClient.convertToType(data['kid'], 'String');
      }
      if (data.hasOwnProperty('digest')) {
        obj['digest'] = ApiClient.convertToType(data['digest'], 'Blob');
      }
      if (data.hasOwnProperty('mac')) {
        obj['mac'] = ApiClient.convertToType(data['mac'], 'Blob');
      }
    }
    return obj;
  }

  /**
   * Key ID of the key used to generate the MAC.
   * @member {String} kid
   */
  exports.prototype['kid'] = undefined;
  /**
   * The MAC generated for the input data (returned for HMAC operation).
   * @member {Blob} digest
   */
  exports.prototype['digest'] = undefined;
  /**
   * The MAC generated for the input data (returned for CMAC operation).
   * @member {Blob} mac
   */
  exports.prototype['mac'] = undefined;



  return exports;
}));


