/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/U2fKey'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./U2fKey'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.MfaChallenge = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.U2fKey);
  }
}(this, function(ApiClient, U2fKey) {
  'use strict';




  /**
   * The MfaChallenge model module.
   * @module model/MfaChallenge
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>MfaChallenge</code>.
   * Challenge for registring or authenticating with a U2F two factor device.
   * @alias module:model/MfaChallenge
   * @class
   * @param u2fChallenge {String} 
   * @param u2fKeys {Array.<module:model/U2fKey>} 
   */
  var exports = function(u2fChallenge, u2fKeys) {
    var _this = this;

    _this['u2f_challenge'] = u2fChallenge;
    _this['u2f_keys'] = u2fKeys;
  };

  /**
   * Constructs a <code>MfaChallenge</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/MfaChallenge} obj Optional instance to populate.
   * @return {module:model/MfaChallenge} The populated <code>MfaChallenge</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('u2f_challenge')) {
        obj['u2f_challenge'] = ApiClient.convertToType(data['u2f_challenge'], 'String');
      }
      if (data.hasOwnProperty('u2f_keys')) {
        obj['u2f_keys'] = ApiClient.convertToType(data['u2f_keys'], [U2fKey]);
      }
    }
    return obj;
  }

  /**
   * @member {String} u2f_challenge
   */
  exports.prototype['u2f_challenge'] = undefined;
  /**
   * @member {Array.<module:model/U2fKey>} u2f_keys
   */
  exports.prototype['u2f_keys'] = undefined;



  return exports;
}));


