/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/MgfMgf1'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./MgfMgf1'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.Mgf = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.MgfMgf1);
  }
}(this, function(ApiClient, MgfMgf1) {
  'use strict';




  /**
   * The Mgf model module.
   * @module model/Mgf
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>Mgf</code>.
   * Specifies the Mask Generating Function (MGF) to use.
   * @alias module:model/Mgf
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>Mgf</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/Mgf} obj Optional instance to populate.
   * @return {module:model/Mgf} The populated <code>Mgf</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('mgf1')) {
        obj['mgf1'] = MgfMgf1.constructFromObject(data['mgf1']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/MgfMgf1} mgf1
   */
  exports.prototype['mgf1'] = undefined;



  return exports;
}));


