/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/DigestAlgorithm', 'model/SobjectDescriptor'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./DigestAlgorithm'), require('./SobjectDescriptor'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.ObjectDigestRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.DigestAlgorithm, root.FortanixSdkmsRestApi.SobjectDescriptor);
  }
}(this, function(ApiClient, DigestAlgorithm, SobjectDescriptor) {
  'use strict';




  /**
   * The ObjectDigestRequest model module.
   * @module model/ObjectDigestRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>ObjectDigestRequest</code>.
   * @alias module:model/ObjectDigestRequest
   * @class
   * @param key {module:model/SobjectDescriptor} 
   * @param alg {module:model/DigestAlgorithm} 
   */
  var exports = function(key, alg) {
    var _this = this;

    _this['key'] = key;
    _this['alg'] = alg;
  };

  /**
   * Constructs a <code>ObjectDigestRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/ObjectDigestRequest} obj Optional instance to populate.
   * @return {module:model/ObjectDigestRequest} The populated <code>ObjectDigestRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = SobjectDescriptor.constructFromObject(data['key']);
      }
      if (data.hasOwnProperty('alg')) {
        obj['alg'] = DigestAlgorithm.constructFromObject(data['alg']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SobjectDescriptor} key
   */
  exports.prototype['key'] = undefined;
  /**
   * @member {module:model/DigestAlgorithm} alg
   */
  exports.prototype['alg'] = undefined;



  return exports;
}));


