/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Language'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Language'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.PluginSource = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.Language);
  }
}(this, function(ApiClient, Language) {
  'use strict';




  /**
   * The PluginSource model module.
   * @module model/PluginSource
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>PluginSource</code>.
   * Plugin code that will be executed in SDKMS.
   * @alias module:model/PluginSource
   * @class
   * @param language {module:model/Language} 
   * @param code {String} 
   */
  var exports = function(language, code) {
    var _this = this;

    _this['language'] = language;
    _this['code'] = code;
  };

  /**
   * Constructs a <code>PluginSource</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/PluginSource} obj Optional instance to populate.
   * @return {module:model/PluginSource} The populated <code>PluginSource</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('language')) {
        obj['language'] = Language.constructFromObject(data['language']);
      }
      if (data.hasOwnProperty('code')) {
        obj['code'] = ApiClient.convertToType(data['code'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/Language} language
   */
  exports.prototype['language'] = undefined;
  /**
   * @member {String} code
   */
  exports.prototype['code'] = undefined;



  return exports;
}));


