/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RevocationReasonCode'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RevocationReasonCode'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.RevocationReason = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.RevocationReasonCode);
  }
}(this, function(ApiClient, RevocationReasonCode) {
  'use strict';




  /**
   * The RevocationReason model module.
   * @module model/RevocationReason
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>RevocationReason</code>.
   * @alias module:model/RevocationReason
   * @class
   * @param code {module:model/RevocationReasonCode} 
   */
  var exports = function(code) {
    var _this = this;

    _this['code'] = code;


  };

  /**
   * Constructs a <code>RevocationReason</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RevocationReason} obj Optional instance to populate.
   * @return {module:model/RevocationReason} The populated <code>RevocationReason</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('code')) {
        obj['code'] = RevocationReasonCode.constructFromObject(data['code']);
      }
      if (data.hasOwnProperty('message')) {
        obj['message'] = ApiClient.convertToType(data['message'], 'String');
      }
      if (data.hasOwnProperty('compromise_occurance_date')) {
        obj['compromise_occurance_date'] = ApiClient.convertToType(data['compromise_occurance_date'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/RevocationReasonCode} code
   */
  exports.prototype['code'] = undefined;
  /**
   * Field that is used exclusively for audit trail/logging purposes and MAY contain additional information about why the object was revoked.
   * @member {String} message
   */
  exports.prototype['message'] = undefined;
  /**
   * An optional field specifying when this security object was compromised.
   * @member {String} compromise_occurance_date
   */
  exports.prototype['compromise_occurance_date'] = undefined;



  return exports;
}));


