/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RotationInterval'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RotationInterval'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.RotationPolicy = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.RotationInterval);
  }
}(this, function(ApiClient, RotationInterval) {
  'use strict';




  /**
   * The RotationPolicy model module.
   * @module model/RotationPolicy
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>RotationPolicy</code>.
   * @alias module:model/RotationPolicy
   * @class
   */
  var exports = function() {
    var _this = this;




  };

  /**
   * Constructs a <code>RotationPolicy</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RotationPolicy} obj Optional instance to populate.
   * @return {module:model/RotationPolicy} The populated <code>RotationPolicy</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('interval')) {
        obj['interval'] = RotationInterval.constructFromObject(data['interval']);
      }
      if (data.hasOwnProperty('effective_at')) {
        obj['effective_at'] = ApiClient.convertToType(data['effective_at'], 'String');
      }
      if (data.hasOwnProperty('deactivate_rotated_key')) {
        obj['deactivate_rotated_key'] = ApiClient.convertToType(data['deactivate_rotated_key'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/RotationInterval} interval
   */
  exports.prototype['interval'] = undefined;
  /**
   * Start time of the rotation policy
   * @member {String} effective_at
   */
  exports.prototype['effective_at'] = undefined;
  /**
   * Upon key rotation, the old key will automatically be deactivated. This only affects keys that were in the Preactive or Active state.
   * @member {Boolean} deactivate_rotated_key
   */
  exports.prototype['deactivate_rotated_key'] = undefined;



  return exports;
}));


