/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RsaEncryptionPaddingOAEP'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RsaEncryptionPaddingOAEP'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.RsaEncryptionPadding = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.RsaEncryptionPaddingOAEP);
  }
}(this, function(ApiClient, RsaEncryptionPaddingOAEP) {
  'use strict';




  /**
   * The RsaEncryptionPadding model module.
   * @module model/RsaEncryptionPadding
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>RsaEncryptionPadding</code>.
   * Type of padding to use for RSA encryption. The use of PKCS#1 v1.5 padding is strongly discouraged, because of its susceptibility to Bleichenbacher&#39;s attack. The padding specified must adhere to the key&#39;s encryption policy, see &#x60;RsaEncryptionPolicy&#x60;. If not specified, the default based on the key&#39;s policy will be used. 
   * @alias module:model/RsaEncryptionPadding
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>RsaEncryptionPadding</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RsaEncryptionPadding} obj Optional instance to populate.
   * @return {module:model/RsaEncryptionPadding} The populated <code>RsaEncryptionPadding</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('PKCS1_V15')) {
        obj['PKCS1_V15'] = ApiClient.convertToType(data['PKCS1_V15'], Object);
      }
      if (data.hasOwnProperty('OAEP')) {
        obj['OAEP'] = RsaEncryptionPaddingOAEP.constructFromObject(data['OAEP']);
      }
    }
    return obj;
  }

  /**
   * PKCS#1 v1.5 padding
   * @member {Object} PKCS1_V15
   */
  exports.prototype['PKCS1_V15'] = undefined;
  /**
   * @member {module:model/RsaEncryptionPaddingOAEP} OAEP
   */
  exports.prototype['OAEP'] = undefined;



  return exports;
}));


