/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/Mgf'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./Mgf'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.RsaEncryptionPaddingOAEP = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.Mgf);
  }
}(this, function(ApiClient, Mgf) {
  'use strict';




  /**
   * The RsaEncryptionPaddingOAEP model module.
   * @module model/RsaEncryptionPaddingOAEP
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>RsaEncryptionPaddingOAEP</code>.
   * Optimal Asymmetric Encryption Padding (PKCS#1 v2.1)
   * @alias module:model/RsaEncryptionPaddingOAEP
   * @class
   * @param mgf {module:model/Mgf} 
   */
  var exports = function(mgf) {
    var _this = this;

    _this['mgf'] = mgf;
  };

  /**
   * Constructs a <code>RsaEncryptionPaddingOAEP</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RsaEncryptionPaddingOAEP} obj Optional instance to populate.
   * @return {module:model/RsaEncryptionPaddingOAEP} The populated <code>RsaEncryptionPaddingOAEP</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('mgf')) {
        obj['mgf'] = Mgf.constructFromObject(data['mgf']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/Mgf} mgf
   */
  exports.prototype['mgf'] = undefined;



  return exports;
}));


