/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RsaSignaturePolicyPadding'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RsaSignaturePolicyPadding'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.RsaSignaturePolicy = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.RsaSignaturePolicyPadding);
  }
}(this, function(ApiClient, RsaSignaturePolicyPadding) {
  'use strict';




  /**
   * The RsaSignaturePolicy model module.
   * @module model/RsaSignaturePolicy
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>RsaSignaturePolicy</code>.
   * Constraints on RSA signature parameters. In general, if a constraint is not specified, anything is allowed.
   * @alias module:model/RsaSignaturePolicy
   * @class
   */
  var exports = function() {
    var _this = this;


  };

  /**
   * Constructs a <code>RsaSignaturePolicy</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RsaSignaturePolicy} obj Optional instance to populate.
   * @return {module:model/RsaSignaturePolicy} The populated <code>RsaSignaturePolicy</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('padding')) {
        obj['padding'] = RsaSignaturePolicyPadding.constructFromObject(data['padding']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/RsaSignaturePolicyPadding} padding
   */
  exports.prototype['padding'] = undefined;



  return exports;
}));


