/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/RsaEncryptionPolicyPaddingOAEP'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./RsaEncryptionPolicyPaddingOAEP'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.RsaSignaturePolicyPadding = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.RsaEncryptionPolicyPaddingOAEP);
  }
}(this, function(ApiClient, RsaEncryptionPolicyPaddingOAEP) {
  'use strict';




  /**
   * The RsaSignaturePolicyPadding model module.
   * @module model/RsaSignaturePolicyPadding
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>RsaSignaturePolicyPadding</code>.
   * @alias module:model/RsaSignaturePolicyPadding
   * @class
   */
  var exports = function() {
    var _this = this;



  };

  /**
   * Constructs a <code>RsaSignaturePolicyPadding</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/RsaSignaturePolicyPadding} obj Optional instance to populate.
   * @return {module:model/RsaSignaturePolicyPadding} The populated <code>RsaSignaturePolicyPadding</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('PKCS1_V15')) {
        obj['PKCS1_V15'] = ApiClient.convertToType(data['PKCS1_V15'], Object);
      }
      if (data.hasOwnProperty('PSS')) {
        obj['PSS'] = RsaEncryptionPolicyPaddingOAEP.constructFromObject(data['PSS']);
      }
    }
    return obj;
  }

  /**
   * @member {Object} PKCS1_V15
   */
  exports.prototype['PKCS1_V15'] = undefined;
  /**
   * @member {module:model/RsaEncryptionPolicyPaddingOAEP} PSS
   */
  exports.prototype['PSS'] = undefined;



  return exports;
}));


