/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/DigestAlgorithm', 'model/SignatureMode'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./DigestAlgorithm'), require('./SignatureMode'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.SignRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.DigestAlgorithm, root.FortanixSdkmsRestApi.SignatureMode);
  }
}(this, function(ApiClient, DigestAlgorithm, SignatureMode) {
  'use strict';




  /**
   * The SignRequest model module.
   * @module model/SignRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>SignRequest</code>.
   * @alias module:model/SignRequest
   * @class
   * @param hashAlg {module:model/DigestAlgorithm} 
   */
  var exports = function(hashAlg) {
    var _this = this;

    _this['hash_alg'] = hashAlg;




  };

  /**
   * Constructs a <code>SignRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SignRequest} obj Optional instance to populate.
   * @return {module:model/SignRequest} The populated <code>SignRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('hash_alg')) {
        obj['hash_alg'] = DigestAlgorithm.constructFromObject(data['hash_alg']);
      }
      if (data.hasOwnProperty('hash')) {
        obj['hash'] = ApiClient.convertToType(data['hash'], 'Blob');
      }
      if (data.hasOwnProperty('data')) {
        obj['data'] = ApiClient.convertToType(data['data'], 'Blob');
      }
      if (data.hasOwnProperty('mode')) {
        obj['mode'] = SignatureMode.constructFromObject(data['mode']);
      }
      if (data.hasOwnProperty('deterministic_signature')) {
        obj['deterministic_signature'] = ApiClient.convertToType(data['deterministic_signature'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/DigestAlgorithm} hash_alg
   */
  exports.prototype['hash_alg'] = undefined;
  /**
   * Hash of the data to be signed. Exactly one of `hash` and `data` is required. 
   * @member {Blob} hash
   */
  exports.prototype['hash'] = undefined;
  /**
   * Data to be signed. Exactly one of `hash` and `data` is required. To reduce request size and avoid reaching the request size limit, prefer `hash`. When using Ed25519 keys, a distinction is made between providing the message directly in `data` and providing a prehashed value in `hash`. Providing a full message results in an \"Ed25519\" signature while providing `hash` results in an \"Ed25519ph\" signature, which is not compatible. See RFC 8032 for details. 
   * @member {Blob} data
   */
  exports.prototype['data'] = undefined;
  /**
   * @member {module:model/SignatureMode} mode
   */
  exports.prototype['mode'] = undefined;
  /**
   * @member {Boolean} deterministic_signature
   */
  exports.prototype['deterministic_signature'] = undefined;



  return exports;
}));


