/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.SignupRequest = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The SignupRequest model module.
   * @module model/SignupRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>SignupRequest</code>.
   * @alias module:model/SignupRequest
   * @class
   * @param userEmail {String} User's email address.
   * @param userPassword {String} The password to assign to this user in SDKMS.
   * @param recaptchaResponse {String} 
   */
  var exports = function(userEmail, userPassword, recaptchaResponse) {
    var _this = this;

    _this['user_email'] = userEmail;
    _this['user_password'] = userPassword;


    _this['recaptcha_response'] = recaptchaResponse;
  };

  /**
   * Constructs a <code>SignupRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SignupRequest} obj Optional instance to populate.
   * @return {module:model/SignupRequest} The populated <code>SignupRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('user_email')) {
        obj['user_email'] = ApiClient.convertToType(data['user_email'], 'String');
      }
      if (data.hasOwnProperty('user_password')) {
        obj['user_password'] = ApiClient.convertToType(data['user_password'], 'String');
      }
      if (data.hasOwnProperty('first_name')) {
        obj['first_name'] = ApiClient.convertToType(data['first_name'], 'String');
      }
      if (data.hasOwnProperty('last_name')) {
        obj['last_name'] = ApiClient.convertToType(data['last_name'], 'String');
      }
      if (data.hasOwnProperty('recaptcha_response')) {
        obj['recaptcha_response'] = ApiClient.convertToType(data['recaptcha_response'], 'String');
      }
    }
    return obj;
  }

  /**
   * User's email address.
   * @member {String} user_email
   */
  exports.prototype['user_email'] = undefined;
  /**
   * The password to assign to this user in SDKMS.
   * @member {String} user_password
   */
  exports.prototype['user_password'] = undefined;
  /**
   * @member {String} first_name
   */
  exports.prototype['first_name'] = undefined;
  /**
   * @member {String} last_name
   */
  exports.prototype['last_name'] = undefined;
  /**
   * @member {String} recaptcha_response
   */
  exports.prototype['recaptcha_response'] = undefined;



  return exports;
}));


