/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/TlsConfig'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./TlsConfig'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.SplunkLoggingConfig = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.TlsConfig);
  }
}(this, function(ApiClient, TlsConfig) {
  'use strict';




  /**
   * The SplunkLoggingConfig model module.
   * @module model/SplunkLoggingConfig
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>SplunkLoggingConfig</code>.
   * @alias module:model/SplunkLoggingConfig
   * @class
   * @param host {String} 
   * @param port {Number} 
   * @param index {String} The Splunk index that will receive log items
   * @param tls {module:model/TlsConfig} 
   * @param enabled {Boolean} 
   */
  var exports = function(host, port, index, tls, enabled) {
    var _this = this;

    _this['host'] = host;
    _this['port'] = port;
    _this['index'] = index;
    _this['tls'] = tls;
    _this['enabled'] = enabled;
  };

  /**
   * Constructs a <code>SplunkLoggingConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SplunkLoggingConfig} obj Optional instance to populate.
   * @return {module:model/SplunkLoggingConfig} The populated <code>SplunkLoggingConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('host')) {
        obj['host'] = ApiClient.convertToType(data['host'], 'String');
      }
      if (data.hasOwnProperty('port')) {
        obj['port'] = ApiClient.convertToType(data['port'], 'Number');
      }
      if (data.hasOwnProperty('index')) {
        obj['index'] = ApiClient.convertToType(data['index'], 'String');
      }
      if (data.hasOwnProperty('tls')) {
        obj['tls'] = TlsConfig.constructFromObject(data['tls']);
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
    }
    return obj;
  }

  /**
   * @member {String} host
   */
  exports.prototype['host'] = undefined;
  /**
   * @member {Number} port
   */
  exports.prototype['port'] = undefined;
  /**
   * The Splunk index that will receive log items
   * @member {String} index
   */
  exports.prototype['index'] = undefined;
  /**
   * @member {module:model/TlsConfig} tls
   */
  exports.prototype['tls'] = undefined;
  /**
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;



  return exports;
}));


