/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/SubscriptionType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./SubscriptionType'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.SubscriptionChangeRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.SubscriptionType);
  }
}(this, function(ApiClient, SubscriptionType) {
  'use strict';




  /**
   * The SubscriptionChangeRequest model module.
   * @module model/SubscriptionChangeRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>SubscriptionChangeRequest</code>.
   * Describes a request to update subscription.
   * @alias module:model/SubscriptionChangeRequest
   * @class
   * @param subscription {module:model/SubscriptionType} 
   */
  var exports = function(subscription) {
    var _this = this;

    _this['subscription'] = subscription;


  };

  /**
   * Constructs a <code>SubscriptionChangeRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/SubscriptionChangeRequest} obj Optional instance to populate.
   * @return {module:model/SubscriptionChangeRequest} The populated <code>SubscriptionChangeRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('subscription')) {
        obj['subscription'] = SubscriptionType.constructFromObject(data['subscription']);
      }
      if (data.hasOwnProperty('contact')) {
        obj['contact'] = ApiClient.convertToType(data['contact'], 'String');
      }
      if (data.hasOwnProperty('comment')) {
        obj['comment'] = ApiClient.convertToType(data['comment'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SubscriptionType} subscription
   */
  exports.prototype['subscription'] = undefined;
  /**
   * contact information, e.g. phone number
   * @member {String} contact
   */
  exports.prototype['contact'] = undefined;
  /**
   * additional comments
   * @member {String} comment
   */
  exports.prototype['comment'] = undefined;



  return exports;
}));


