/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CaConfig', 'model/TlsMode'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CaConfig'), require('./TlsMode'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.TlsConfig = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.CaConfig, root.FortanixSdkmsRestApi.TlsMode);
  }
}(this, function(ApiClient, CaConfig, TlsMode) {
  'use strict';




  /**
   * The TlsConfig model module.
   * @module model/TlsConfig
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>TlsConfig</code>.
   * @alias module:model/TlsConfig
   * @class
   * @param mode {module:model/TlsMode} 
   */
  var exports = function(mode) {
    var _this = this;

    _this['mode'] = mode;


  };

  /**
   * Constructs a <code>TlsConfig</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/TlsConfig} obj Optional instance to populate.
   * @return {module:model/TlsConfig} The populated <code>TlsConfig</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('mode')) {
        obj['mode'] = TlsMode.constructFromObject(data['mode']);
      }
      if (data.hasOwnProperty('validate_hostname')) {
        obj['validate_hostname'] = ApiClient.convertToType(data['validate_hostname'], 'Boolean');
      }
      if (data.hasOwnProperty('ca')) {
        obj['ca'] = CaConfig.constructFromObject(data['ca']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/TlsMode} mode
   */
  exports.prototype['mode'] = undefined;
  /**
   * @member {Boolean} validate_hostname
   */
  exports.prototype['validate_hostname'] = undefined;
  /**
   * @member {module:model/CaConfig} ca
   */
  exports.prototype['ca'] = undefined;



  return exports;
}));


