/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.U2fRenameDeviceRequest = factory(root.FortanixSdkmsRestApi.ApiClient);
  }
}(this, function(ApiClient) {
  'use strict';




  /**
   * The U2fRenameDeviceRequest model module.
   * @module model/U2fRenameDeviceRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>U2fRenameDeviceRequest</code>.
   * Request to rename a U2F device.
   * @alias module:model/U2fRenameDeviceRequest
   * @class
   * @param oldName {String} 
   * @param newName {String} 
   */
  var exports = function(oldName, newName) {
    var _this = this;

    _this['old_name'] = oldName;
    _this['new_name'] = newName;
  };

  /**
   * Constructs a <code>U2fRenameDeviceRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/U2fRenameDeviceRequest} obj Optional instance to populate.
   * @return {module:model/U2fRenameDeviceRequest} The populated <code>U2fRenameDeviceRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('old_name')) {
        obj['old_name'] = ApiClient.convertToType(data['old_name'], 'String');
      }
      if (data.hasOwnProperty('new_name')) {
        obj['new_name'] = ApiClient.convertToType(data['new_name'], 'String');
      }
    }
    return obj;
  }

  /**
   * @member {String} old_name
   */
  exports.prototype['old_name'] = undefined;
  /**
   * @member {String} new_name
   */
  exports.prototype['new_name'] = undefined;



  return exports;
}));


