/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/CryptMode', 'model/KeyOperations', 'model/ObjectType', 'model/RsaOptions', 'model/SobjectDescriptor'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./CryptMode'), require('./KeyOperations'), require('./ObjectType'), require('./RsaOptions'), require('./SobjectDescriptor'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.UnwrapKeyRequestEx = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.CryptMode, root.FortanixSdkmsRestApi.KeyOperations, root.FortanixSdkmsRestApi.ObjectType, root.FortanixSdkmsRestApi.RsaOptions, root.FortanixSdkmsRestApi.SobjectDescriptor);
  }
}(this, function(ApiClient, CryptMode, KeyOperations, ObjectType, RsaOptions, SobjectDescriptor) {
  'use strict';




  /**
   * The UnwrapKeyRequestEx model module.
   * @module model/UnwrapKeyRequestEx
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>UnwrapKeyRequestEx</code>.
   * @alias module:model/UnwrapKeyRequestEx
   * @class
   * @param key {module:model/SobjectDescriptor} 
   * @param alg {module:model/ObjectType} 
   * @param objType {module:model/ObjectType} 
   * @param wrappedKey {Blob} A Security Object previously wrapped with another key. 
   * @param name {String} Name of the security object to unwrap. Security object names must be unique within an account.
   */
  var exports = function(key, alg, objType, wrappedKey, name) {
    var _this = this;

    _this['key'] = key;
    _this['alg'] = alg;

    _this['obj_type'] = objType;
    _this['wrapped_key'] = wrappedKey;




    _this['name'] = name;





  };

  /**
   * Constructs a <code>UnwrapKeyRequestEx</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/UnwrapKeyRequestEx} obj Optional instance to populate.
   * @return {module:model/UnwrapKeyRequestEx} The populated <code>UnwrapKeyRequestEx</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('key')) {
        obj['key'] = SobjectDescriptor.constructFromObject(data['key']);
      }
      if (data.hasOwnProperty('alg')) {
        obj['alg'] = ObjectType.constructFromObject(data['alg']);
      }
      if (data.hasOwnProperty('group_id')) {
        obj['group_id'] = ApiClient.convertToType(data['group_id'], 'String');
      }
      if (data.hasOwnProperty('obj_type')) {
        obj['obj_type'] = ObjectType.constructFromObject(data['obj_type']);
      }
      if (data.hasOwnProperty('wrapped_key')) {
        obj['wrapped_key'] = ApiClient.convertToType(data['wrapped_key'], 'Blob');
      }
      if (data.hasOwnProperty('mode')) {
        obj['mode'] = CryptMode.constructFromObject(data['mode']);
      }
      if (data.hasOwnProperty('iv')) {
        obj['iv'] = ApiClient.convertToType(data['iv'], 'Blob');
      }
      if (data.hasOwnProperty('ad')) {
        obj['ad'] = ApiClient.convertToType(data['ad'], 'Blob');
      }
      if (data.hasOwnProperty('tag')) {
        obj['tag'] = ApiClient.convertToType(data['tag'], 'Blob');
      }
      if (data.hasOwnProperty('name')) {
        obj['name'] = ApiClient.convertToType(data['name'], 'String');
      }
      if (data.hasOwnProperty('description')) {
        obj['description'] = ApiClient.convertToType(data['description'], 'String');
      }
      if (data.hasOwnProperty('key_ops')) {
        obj['key_ops'] = ApiClient.convertToType(data['key_ops'], [KeyOperations]);
      }
      if (data.hasOwnProperty('custom_metadata')) {
        obj['custom_metadata'] = ApiClient.convertToType(data['custom_metadata'], {'String': 'String'});
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('rsa')) {
        obj['rsa'] = RsaOptions.constructFromObject(data['rsa']);
      }
    }
    return obj;
  }

  /**
   * @member {module:model/SobjectDescriptor} key
   */
  exports.prototype['key'] = undefined;
  /**
   * @member {module:model/ObjectType} alg
   */
  exports.prototype['alg'] = undefined;
  /**
   * Group ID (not name) of the security group that this security object should belong to. The user or application creating this security object must be a member of this group. If no group is specified, the default group for the user or application will be used. 
   * @member {String} group_id
   */
  exports.prototype['group_id'] = undefined;
  /**
   * @member {module:model/ObjectType} obj_type
   */
  exports.prototype['obj_type'] = undefined;
  /**
   * A Security Object previously wrapped with another key. 
   * @member {Blob} wrapped_key
   */
  exports.prototype['wrapped_key'] = undefined;
  /**
   * @member {module:model/CryptMode} mode
   */
  exports.prototype['mode'] = undefined;
  /**
   * The initialization value used to encrypt this ciphertext. This field is required for symmetric ciphers, and ignored for asymmetric ciphers. 
   * @member {Blob} iv
   */
  exports.prototype['iv'] = undefined;
  /**
   * The authenticated data used with this ciphertext and authentication tag. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers. 
   * @member {Blob} ad
   */
  exports.prototype['ad'] = undefined;
  /**
   * The authentication tag used with this ciphertext and authenticated data. This field is required for symmetric ciphers using cipher mode GCM or CCM, and must not be specified for all other ciphers. 
   * @member {Blob} tag
   */
  exports.prototype['tag'] = undefined;
  /**
   * Name of the security object to unwrap. Security object names must be unique within an account.
   * @member {String} name
   */
  exports.prototype['name'] = undefined;
  /**
   * Description of the Security object to unwrap.
   * @member {String} description
   */
  exports.prototype['description'] = undefined;
  /**
   * Optional array of key operations to be enabled for this security object. If this property is not provided, the SDKMS server will provide a default set of key operations. Note that if you provide an empty array, all key operations will be disabled. 
   * @member {Array.<module:model/KeyOperations>} key_ops
   */
  exports.prototype['key_ops'] = undefined;
  /**
   * User-defined metadata for this key. Stored as key-value pairs.
   * @member {Object.<String, String>} custom_metadata
   */
  exports.prototype['custom_metadata'] = undefined;
  /**
   * Whether the new security object should be enabled. Disabled security objects may not perform cryptographic operations. 
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * @member {module:model/RsaOptions} rsa
   */
  exports.prototype['rsa'] = undefined;



  return exports;
}));


