/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/U2fAddDeviceRequest', 'model/U2fDelDeviceRequest', 'model/U2fRenameDeviceRequest', 'model/UserAccountFlags', 'model/UserGroupMap'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./U2fAddDeviceRequest'), require('./U2fDelDeviceRequest'), require('./U2fRenameDeviceRequest'), require('./UserAccountFlags'), require('./UserGroupMap'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.UserRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.U2fAddDeviceRequest, root.FortanixSdkmsRestApi.U2fDelDeviceRequest, root.FortanixSdkmsRestApi.U2fRenameDeviceRequest, root.FortanixSdkmsRestApi.UserAccountFlags, root.FortanixSdkmsRestApi.UserGroupMap);
  }
}(this, function(ApiClient, U2fAddDeviceRequest, U2fDelDeviceRequest, U2fRenameDeviceRequest, UserAccountFlags, UserGroupMap) {
  'use strict';




  /**
   * The UserRequest model module.
   * @module model/UserRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>UserRequest</code>.
   * @alias module:model/UserRequest
   * @class
   * @param userEmail {String} User's email address.
   * @param userPassword {String} The password to assign to this user in SDKMS.
   */
  var exports = function(userEmail, userPassword) {
    var _this = this;

    _this['user_email'] = userEmail;
    _this['user_password'] = userPassword;








  };

  /**
   * Constructs a <code>UserRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/UserRequest} obj Optional instance to populate.
   * @return {module:model/UserRequest} The populated <code>UserRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('user_email')) {
        obj['user_email'] = ApiClient.convertToType(data['user_email'], 'String');
      }
      if (data.hasOwnProperty('user_password')) {
        obj['user_password'] = ApiClient.convertToType(data['user_password'], 'String');
      }
      if (data.hasOwnProperty('account_role')) {
        obj['account_role'] = ApiClient.convertToType(data['account_role'], [UserAccountFlags]);
      }
      if (data.hasOwnProperty('add_groups')) {
        obj['add_groups'] = UserGroupMap.constructFromObject(data['add_groups']);
      }
      if (data.hasOwnProperty('del_groups')) {
        obj['del_groups'] = UserGroupMap.constructFromObject(data['del_groups']);
      }
      if (data.hasOwnProperty('mod_groups')) {
        obj['mod_groups'] = UserGroupMap.constructFromObject(data['mod_groups']);
      }
      if (data.hasOwnProperty('enabled')) {
        obj['enabled'] = ApiClient.convertToType(data['enabled'], 'Boolean');
      }
      if (data.hasOwnProperty('add_u2f_devices')) {
        obj['add_u2f_devices'] = ApiClient.convertToType(data['add_u2f_devices'], [U2fAddDeviceRequest]);
      }
      if (data.hasOwnProperty('del_u2f_devices')) {
        obj['del_u2f_devices'] = ApiClient.convertToType(data['del_u2f_devices'], [U2fDelDeviceRequest]);
      }
      if (data.hasOwnProperty('rename_u2f_devices')) {
        obj['rename_u2f_devices'] = ApiClient.convertToType(data['rename_u2f_devices'], [U2fRenameDeviceRequest]);
      }
    }
    return obj;
  }

  /**
   * User's email address.
   * @member {String} user_email
   */
  exports.prototype['user_email'] = undefined;
  /**
   * The password to assign to this user in SDKMS.
   * @member {String} user_password
   */
  exports.prototype['user_password'] = undefined;
  /**
   * @member {Array.<module:model/UserAccountFlags>} account_role
   */
  exports.prototype['account_role'] = undefined;
  /**
   * The user will be added to the specified security groups with the specified roles.
   * @member {module:model/UserGroupMap} add_groups
   */
  exports.prototype['add_groups'] = undefined;
  /**
   * The user will be removed from the specified security groups.
   * @member {module:model/UserGroupMap} del_groups
   */
  exports.prototype['del_groups'] = undefined;
  /**
   * The user's role in the specified groups will be updated to the specified roles.
   * @member {module:model/UserGroupMap} mod_groups
   */
  exports.prototype['mod_groups'] = undefined;
  /**
   * Whether this application is enabled.
   * @member {Boolean} enabled
   */
  exports.prototype['enabled'] = undefined;
  /**
   * @member {Array.<module:model/U2fAddDeviceRequest>} add_u2f_devices
   */
  exports.prototype['add_u2f_devices'] = undefined;
  /**
   * @member {Array.<module:model/U2fDelDeviceRequest>} del_u2f_devices
   */
  exports.prototype['del_u2f_devices'] = undefined;
  /**
   * @member {Array.<module:model/U2fRenameDeviceRequest>} rename_u2f_devices
   */
  exports.prototype['rename_u2f_devices'] = undefined;



  return exports;
}));


