/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ObjectType'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ObjectType'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.VerifyKcvRequest = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.ObjectType);
  }
}(this, function(ApiClient, ObjectType) {
  'use strict';




  /**
   * The VerifyKcvRequest model module.
   * @module model/VerifyKcvRequest
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>VerifyKcvRequest</code>.
   * @alias module:model/VerifyKcvRequest
   * @class
   * @param kcv {String} KCV to verify against provided key material in 'value'
   * @param value {String} Key material
   * @param objType {module:model/ObjectType} 
   */
  var exports = function(kcv, value, objType) {
    var _this = this;

    _this['kcv'] = kcv;
    _this['value'] = value;
    _this['obj_type'] = objType;
  };

  /**
   * Constructs a <code>VerifyKcvRequest</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VerifyKcvRequest} obj Optional instance to populate.
   * @return {module:model/VerifyKcvRequest} The populated <code>VerifyKcvRequest</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('kcv')) {
        obj['kcv'] = ApiClient.convertToType(data['kcv'], 'String');
      }
      if (data.hasOwnProperty('value')) {
        obj['value'] = ApiClient.convertToType(data['value'], 'String');
      }
      if (data.hasOwnProperty('obj_type')) {
        obj['obj_type'] = ObjectType.constructFromObject(data['obj_type']);
      }
    }
    return obj;
  }

  /**
   * KCV to verify against provided key material in 'value'
   * @member {String} kcv
   */
  exports.prototype['kcv'] = undefined;
  /**
   * Key material
   * @member {String} value
   */
  exports.prototype['value'] = undefined;
  /**
   * @member {module:model/ObjectType} obj_type
   */
  exports.prototype['obj_type'] = undefined;



  return exports;
}));


