/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD. Register as an anonymous module.
    define(['ApiClient', 'model/ServerMode'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    module.exports = factory(require('../ApiClient'), require('./ServerMode'));
  } else {
    // Browser globals (root is window)
    if (!root.FortanixSdkmsRestApi) {
      root.FortanixSdkmsRestApi = {};
    }
    root.FortanixSdkmsRestApi.VersionResponse = factory(root.FortanixSdkmsRestApi.ApiClient, root.FortanixSdkmsRestApi.ServerMode);
  }
}(this, function(ApiClient, ServerMode) {
  'use strict';




  /**
   * The VersionResponse model module.
   * @module model/VersionResponse
   * @version 1.0.0-20200608
   */

  /**
   * Constructs a new <code>VersionResponse</code>.
   * @alias module:model/VersionResponse
   * @class
   * @param version {String} The SDKMS server version. This is encoded as major.minor.build. For example, 1.0.25. 
   * @param apiVersion {String} The API version implemented by this server.
   * @param serverMode {module:model/ServerMode} 
   */
  var exports = function(version, apiVersion, serverMode) {
    var _this = this;

    _this['version'] = version;
    _this['api_version'] = apiVersion;
    _this['server_mode'] = serverMode;

  };

  /**
   * Constructs a <code>VersionResponse</code> from a plain JavaScript object, optionally creating a new instance.
   * Copies all relevant properties from <code>data</code> to <code>obj</code> if supplied or a new instance if not.
   * @param {Object} data The plain JavaScript object bearing properties of interest.
   * @param {module:model/VersionResponse} obj Optional instance to populate.
   * @return {module:model/VersionResponse} The populated <code>VersionResponse</code> instance.
   */
  exports.constructFromObject = function(data, obj) {
    if (data) {
      obj = obj || new exports();

      if (data.hasOwnProperty('version')) {
        obj['version'] = ApiClient.convertToType(data['version'], 'String');
      }
      if (data.hasOwnProperty('api_version')) {
        obj['api_version'] = ApiClient.convertToType(data['api_version'], 'String');
      }
      if (data.hasOwnProperty('server_mode')) {
        obj['server_mode'] = ServerMode.constructFromObject(data['server_mode']);
      }
      if (data.hasOwnProperty('fips_level')) {
        obj['fips_level'] = ApiClient.convertToType(data['fips_level'], 'Number');
      }
    }
    return obj;
  }

  /**
   * The SDKMS server version. This is encoded as major.minor.build. For example, 1.0.25. 
   * @member {String} version
   */
  exports.prototype['version'] = undefined;
  /**
   * The API version implemented by this server.
   * @member {String} api_version
   */
  exports.prototype['api_version'] = undefined;
  /**
   * @member {module:model/ServerMode} server_mode
   */
  exports.prototype['server_mode'] = undefined;
  /**
   * FIPS level at which SDKMS in running. If this field is absent, then SDKMS is not running in FIPS compliant mode.
   * @member {Number} fips_level
   */
  exports.prototype['fips_level'] = undefined;



  return exports;
}));


