/**
 * Fortanix SDKMS REST API
 * This is a set of REST APIs for accessing the Fortanix Self-Defending Key Management System. This includes APIs for managing accounts, and for performing cryptographic and key management operations. 
 *
 * OpenAPI spec version: 1.0.0-20200608
 * Contact: support@fortanix.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 *
 * Swagger Codegen version: 2.3.0-SNAPSHOT
 *
 * Do not edit the class manually.
 *
 */

(function(root, factory) {
  if (typeof define === 'function' && define.amd) {
    // AMD.
    define(['expect.js', '../../src/index'], factory);
  } else if (typeof module === 'object' && module.exports) {
    // CommonJS-like environments that support module.exports, like Node.
    factory(require('expect.js'), require('../../src/index'));
  } else {
    // Browser globals (root is window)
    factory(root.expect, root.FortanixSdkmsRestApi);
  }
}(this, function(expect, FortanixSdkmsRestApi) {
  'use strict';

  var instance;

  beforeEach(function() {
    instance = new FortanixSdkmsRestApi.KeyObject();
  });

  var getProperty = function(object, getter, property) {
    // Use getter method if present; otherwise, get the property directly.
    if (typeof object[getter] === 'function')
      return object[getter]();
    else
      return object[property];
  }

  var setProperty = function(object, setter, property, value) {
    // Use setter method if present; otherwise, set the property directly.
    if (typeof object[setter] === 'function')
      object[setter](value);
    else
      object[property] = value;
  }

  describe('KeyObject', function() {
    it('should create an instance of KeyObject', function() {
      // uncomment below and update the code to test KeyObject
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be.a(FortanixSdkmsRestApi.KeyObject);
    });

    it('should have the property name (base name: "name")', function() {
      // uncomment below and update the code to test the property name
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property description (base name: "description")', function() {
      // uncomment below and update the code to test the property description
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property keySize (base name: "key_size")', function() {
      // uncomment below and update the code to test the property keySize
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property ellipticCurve (base name: "elliptic_curve")', function() {
      // uncomment below and update the code to test the property ellipticCurve
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property acctId (base name: "acct_id")', function() {
      // uncomment below and update the code to test the property acctId
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property groupId (base name: "group_id")', function() {
      // uncomment below and update the code to test the property groupId
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property creator (base name: "creator")', function() {
      // uncomment below and update the code to test the property creator
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property kid (base name: "kid")', function() {
      // uncomment below and update the code to test the property kid
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property objType (base name: "obj_type")', function() {
      // uncomment below and update the code to test the property objType
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property keyOps (base name: "key_ops")', function() {
      // uncomment below and update the code to test the property keyOps
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property customMetadata (base name: "custom_metadata")', function() {
      // uncomment below and update the code to test the property customMetadata
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property origin (base name: "origin")', function() {
      // uncomment below and update the code to test the property origin
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property pubKey (base name: "pub_key")', function() {
      // uncomment below and update the code to test the property pubKey
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property value (base name: "value")', function() {
      // uncomment below and update the code to test the property value
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property enabled (base name: "enabled")', function() {
      // uncomment below and update the code to test the property enabled
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property compliantWithPolicies (base name: "compliant_with_policies")', function() {
      // uncomment below and update the code to test the property compliantWithPolicies
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property createdAt (base name: "created_at")', function() {
      // uncomment below and update the code to test the property createdAt
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property lastusedAt (base name: "lastused_at")', function() {
      // uncomment below and update the code to test the property lastusedAt
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property transientKey (base name: "transient_key")', function() {
      // uncomment below and update the code to test the property transientKey
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property neverExportable (base name: "never_exportable")', function() {
      // uncomment below and update the code to test the property neverExportable
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property rsa (base name: "rsa")', function() {
      // uncomment below and update the code to test the property rsa
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property kcv (base name: "kcv")', function() {
      // uncomment below and update the code to test the property kcv
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property state (base name: "state")', function() {
      // uncomment below and update the code to test the property state
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

    it('should have the property history (base name: "history")', function() {
      // uncomment below and update the code to test the property history
      //var instane = new FortanixSdkmsRestApi.KeyObject();
      //expect(instance).to.be();
    });

  });

}));
